<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/

require_once("./config.php");

// If requested we will not serve any requests that do not come thought a secure connection

include_once(PHP_INCLUDE_BASE_DIRECTORY . "FunctionLoadXMLDefFromDB.php");
include_once(PHP_INCLUDE_BASE_DIRECTORY . "FunctionInlineBarGraph.php");
/** Connection class */
include_once(PHP_INCLUDE_BASE_DIRECTORY . DB_CONNECTION);


$metaConn = false;

$action = getParameter("action", "");
$tableName = NULL;
$schemaName = NULL;

$table = NULL;

$tableName   = getParameter("table");
$schemaName  = getParameter("schema", "");
if($schemaName == "")
	$schemaName  = getParameter("SCHEMA", "");
/**
 ****************************NOTE*******************************
 * DANGER THE FOLLOWING ACTION CAN BE A POTENTIAL SECURITY HOLE
 ***************************************************************
 * Do not trust user input, a well formed parameter could run any PHP
 * script with the code below if not checked.
 *
 * So... the following rules will apply to an action command
 * it can only be composed of Alphabetic, Numeric and the characters '_'
 * and '-'. Any action command that contains anything else should
 * run the default action
 */

$actionHasBeenRun = false;

if(preg_match('/^[a-zA-Z0-9_\/-]+$/', $action) && file_exists(ACTION_DIRECTORY_ACTIVE_CONNECTION . "/" . RETURN_TYPE . "/" . $action . ".php"))
{
	if(connectionManager::getConnection()->connected)
	{
		$actionHasBeenRun = true;
		
		if($schemaName != "")
		{
			connectionManager::getConnection()->setSchema($schemaName);		
		}
		
		callAction(ACTION_DIRECTORY_ACTIVE_CONNECTION . "/" . RETURN_TYPE . "/" . $action . ".php");
	}
}

if(!$actionHasBeenRun)
{
	if(preg_match('/^[a-zA-Z0-9_\/-]+$/', $action) && file_exists(ACTION_DIRECTORY_NO_CONNECTION . "/" . RETURN_TYPE . "/" . $action . ".php"))
	{
		callAction(ACTION_DIRECTORY_NO_CONNECTION . "/" . RETURN_TYPE . "/" . $action . ".php");
	}
	elseif(preg_match('/^[a-zA-Z0-9_\/-]+$/', $action) && file_exists(ACTION_DIRECTORY_ACTIVE_CONNECTION . "/" . RETURN_TYPE . "/" . $action . ".php"))
	{
		if(RETURN_TYPE == "JSON")
		{
			NoConnectionMessageJSON();
		}
		else 
		{
			NoConnectionMessageHTML();
		}
	}
	else
	{
		if(RETURN_TYPE == "JSON")
		{
					echo <<<JSON
					{
						flagGeneralError: true,
						connectionError:false,
						returnCode: "false",
						returnValue: "Action \"".$action."\" not found"
					}
JSON;
		}
		else 
		{
			my_header("Action not found", "");
			echo "\n<table style='width:100%;height:100%'><tr><td align='center'>Action \"".$action."\" not found</td></tr></table>";
			my_footer();
		}
	}
}
?>