<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/

$SQLToRun 				= getParameter("SQL");
$DoNotReturnSQL			= getParameter("doNotReturnSQL", false);
$bindParameters 		= getParameter("bindParameters");
$SQLParameters 			= getParameter("parameter");
$SQLMaxRowReturn 		= getParameter("maxRowReturn", 100);
$SQLReturnFromRow 		= getParameter("returnFromRow", 0);
$SQLAdHoc_delimiter 	= getParameter("STMTermChar", ";");
$SQLgetRowCount			= getParameter("getRowCount", ";");
$SaveInHistory 			= strtolower(getParameter("saveInHistory", "false")) == "true" ? true : false;
$SQLAdHoc_AutoCommit	= strtolower(getParameter("commitPerSTMT", "false")) == "true" ? true : false;
$SQLAdHoc_AbortOnFailure= strtolower(getParameter("abortOnFailure", $SQLAdHoc_AutoCommit ? "false" : "true"
													)) == "true" ? true : false;

$displayXML    			= strtolower(getParameter("displayXML",			"false")) == "true" ? true : false;
$displayCLOB   			= strtolower(getParameter("displayCLOB",		"false")) == "true" ? true : false;
$displayXMLinline		= strtolower(getParameter("displayXMLinline",	"false")) == "true" ? true : false;
$displayCLOBinline		= strtolower(getParameter("displayCLOBinline",	"false")) == "true" ? true : false;
$displayBLOB			= strtolower(getParameter("displayBLOB",		"false")) == "true" ? true : false;
$displayDBCLOB			= strtolower(getParameter("displayDBCLOB",		"false")) == "true" ? true : false;

connectionManager::getConnection()->setAutoCommit($SQLAdHoc_AutoCommit);


$returndata = array();
$returndata['returnCode'] = "true";
$returndata['returnValue'] = "";


if($SQLToRun == null)
{
	$returndata['returnCode'] = "false";
	$returndata['returnValue'] = "No SQL recived ";
}
elseif(is_array($SQLToRun))
{
	ksort($SQLToRun);
	if($SaveInHistory)
	{
		$tempData = "";
		foreach($SQLToRun as $value)
		{
			$tempData .= $value . $SQLAdHoc_delimiter . "\n";
		}
		saveSQLToFile($tempData);
	}
	$returndata['returnValue'] = array();
	$returndata['returnValue']['RunTime'] = date('H:i:s l, M j');
	$returndata['returnValue']['TotalRunDuration'] = microtime(true);
	$returndata['returnValue']['AutoCommit'] = $SQLAdHoc_AutoCommit ? "true" : "false";
	$returndata['returnValue']['STMTReceived'] = count($SQLToRun);
	$returndata['returnValue']['STMTRun'] = 0;
	$returndata['returnValue']['STMTReturn'] = array();
	foreach ($SQLToRun as $key=>$localSQLToRun)
	{
	
		$localParameters = isset($SQLParameters[$key]) ? $SQLParameters[$key] : $SQLParameters;
		$localSQLMaxRowReturn = isset($SQLMaxRowReturn[$key]) && is_array($SQLMaxRowReturn) ? $SQLMaxRowReturn[$key] : $SQLMaxRowReturn;
		$localSQLReturnFromRow = isset($SQLReturnFromRow[$key]) && is_array($SQLReturnFromRow) ? $SQLReturnFromRow[$key] : $SQLReturnFromRow;
		$localbindParameters = isset($bindParameters[$key]) ? $bindParameters[$key] : null;

		$localSQLToRun = trim(rawurldecode($localSQLToRun));

		$STMTReturn = extractResults($localSQLToRun, false, $localParameters, $localbindParameters, $localSQLMaxRowReturn, $localSQLReturnFromRow, $displayXML, $displayXMLinline, $displayCLOB, $displayCLOBinline, $displayBLOB, $displayDBCLOB, $DoNotReturnSQL,$returndata['returnValue']['STMTReturn'], $SQLgetRowCount);
		
		$returndata['returnValue']['STMTRun']++;
		$returndata['returnValue']['STMTReturn'][$key] = $STMTReturn;
		if($STMTReturn["statementSucceed"] == false)
		{
			$returndata['returnCode'] = "false";
			if($SQLAdHoc_AbortOnFailure) {
				$returndata['returnValue']['STMT'] = $STMTReturn["STMT"];
				$returndata['returnValue']['STMTMSG'] = $STMTReturn["STMTMSG"];
				break;
			}
		}
	}
	
	$returndata['returnValue']['TotalRunDuration'] = microtime(true) - $returndata['returnValue']['TotalRunDuration'];
}
else 
{
	if($SaveInHistory)
	{
		saveSQLToFile($SQLToRun);
	}
	
	$SQLToRun = trim(rawurldecode($SQLToRun));
	
	$nullArray = array();

	$returndata['returnValue'] = extractResults($SQLToRun, false, $SQLParameters, $bindParameters, $SQLMaxRowReturn, $SQLReturnFromRow, $displayXML, $displayXMLinline, $displayCLOB, $displayCLOBinline, $displayBLOB, $displayDBCLOB, $DoNotReturnSQL, $nullArray, $SQLgetRowCount);

	if($returndata['returnValue']["statementSucceed"] == false)
	{
		$returndata['returnCode'] = "false";
	}
	
	$returndata['returnValue']['TotalRunDuration'] = microtime(true) - $returndata['returnValue']['TotalRunDuration'];
}

if(!$SQLAdHoc_AutoCommit && $returndata['returnCode'] == "false")
{
	connectionManager::getConnection()->rollback();
}
elseif(!$SQLAdHoc_AutoCommit)
{
	connectionManager::getConnection()->commit();
}



echo json_encode($returndata);

function saveSQLToFile($SQLData) {
	
	if(ADHOC_SAVE_HISTORY)
	{
		file_put_contents(QUERY_FILES_DIRECTORY . "adhocHistory/" . time() . "-" . date('l-dS-\of-F-Y--h-i-s--A') . ".sql", $SQLData, FILE_USE_INCLUDE_PATH);
		$fileInDir = scandir(QUERY_FILES_DIRECTORY . "adhocHistory/", 0);
		$tempFiles = array();
		foreach($fileInDir as $afile)
		{
			if(strpos($afile, ".") != 0 && strpos($afile, ".sql") == (strlen($afile) - 6))
			{
				$tempFiles[] = $afile;
			}
		}
		if(ADHOC_HISTORY_MAX_FILES != false)
		{
			if(sizeof($tempFiles) > ADHOC_HISTORY_MAX_FILES)
			{
				$len = sizeof($tempFiles);
				rsort($tempFiles);
				for($i = 10; $i < $len; $i++)
				{
					unlink(QUERY_FILES_DIRECTORY . "adhocHistory/" . $tempFiles[$i]);
				}
			}
		}
	}
}

function extractResults($SQLToRun, $NotUsedWasCursorIndicator, $SQLParameters, $bindParameters, $SQLMaxRowReturn, $SQLReturnFromRow, $displayXML, $displayXMLinline, $displayCLOB, $displayCLOBinline, $displayBLOB, $displayDBCLOB, $DoNotReturnSQL, &$dataPassBack, $SQLgetRowCount)
{
	if($SQLParameters != null)
	{
		foreach ($SQLParameters as $key=>$value)
			$SQLToRun = str_replace("?$key?", $value, $SQLToRun);
	}


	
	if($bindParameters == null)
	{
		$matches = array();
		$numFound = preg_match_all("/\?\!(?:[\w]+\=[^?\&]*[\&]?)*\?/", $SQLToRun, $matches);
		if($numFound > 0)
		{
			$i = 1;
			$bindParameters = array();
			foreach($matches[0] as $match)
			{
				$parameteOptions = array();
				$SQLToRun = str_replace($match, "?", $SQLToRun);
				$match = trim($match, "?!");
				if($match != "")
					parse_str($match, $parameteOptions);
				
				$bindParameters[$i]['name'] = isset($parameteOptions['name']) ?  (preg_match('/^[a-zA-Z0-9_]+$/' , $parameteOptions['name']) ? $parameteOptions['name'] : "p{$i}") : "p{$i}";
				if(isset($parameteOptions['value']))
					$bindParameters[$i]['value'] = $parameteOptions['value'];
				if(isset($parameteOptions['dataType']))
					$bindParameters[$i]['dataType'] = $parameteOptions['dataType'];
				if(isset($parameteOptions['type']))
					$bindParameters[$i]['type'] = $parameteOptions['type'];
				if(isset($parameteOptions['DB2dataType']))
					$bindParameters[$i]['DB2dataType'] = $parameteOptions['DB2dataType'];
				if(isset($parameteOptions['precision']))
					$bindParameters[$i]['precision'] = $parameteOptions['precision'];
				if(isset($parameteOptions['scale']))
					$bindParameters[$i]['scale'] = $parameteOptions['scale'];
				$i++;
			}
		}
	}
	
	if($bindParameters != null && $dataPassBack != null)
	{
		foreach($bindParameters as $key=>&$value)
		{
			if(strtoupper($value['type']) == 'TE_INLINE_BIND')
			{
				$value['type'] = 'DB2_PARAM_IN';
				$dataLocation = explode('.', $value['value']);
				$isValueSet = false;
				if($dataLocation !== false)
				{
					if(count($dataLocation) == 4)
					{
						if(isset($dataPassBack[$dataLocation[0]]["resultSet"][$dataLocation[1]]['data'][$dataLocation[2]][$dataLocation[3]]))
						{
							$isValueSet = true;
							$value['value'] = $dataPassBack[$dataLocation[0]]["resultSet"][$dataLocation[1]]['data'][$dataLocation[2]][$dataLocation[3]];
						}
					}
					
				}
				
				if(!$isValueSet) 
					$value['value'] = null;
			}
		}
	}
	
	$STMTReturn = array();
	if(!$DoNotReturnSQL)
		$STMTReturn["STMT"] = $SQLToRun;
	else 
		$STMTReturn["STMT"] = "";
	$STMTReturn["TotalRunDuration"] = microtime(true);
	$STMTReturn["runDuration"] = 0;
	$STMTReturn["parameters"] = "false";
	$STMTReturn["resultSet"] = array();
	$STMTReturn["numOfResultSet"] = 0;
	$STMTReturn["STMTError"] = "";
	$STMTReturn["STMTMSG"] = "";
	
	$statment = null;
	if($bindParameters == null)
	{
		$statment = new Statement($SQLToRun, false, false, false, $SQLgetRowCount);
		$error = db2_stmt_error();
		if($error == '07001')
		{
			$statment = new Statement($SQLToRun, true, false, false, $SQLgetRowCount);
			$statment->executeStmtWithParameters(null);
		}
	}
	else 
	{
		$statment = new Statement($SQLToRun, true, false, false, $SQLgetRowCount);
		$statment->executeStmtWithParameters($bindParameters);
	}

	
	
	$STMTReturn["runDuration"] = $statment->elapsedTime;

	if($statment->statementSucceed)
	{
		$i = 0;
		do {
			$i++;
			$rowCounter = 0;
			$result = array();
			$result['rowsReturned'] = 0;
				
			$result['data'] = array();
			
			$result['columnsInfo'] = $statment->getColumnInfo();

			if($result['columnsInfo']['num'] == 0)
			{
				$STMTReturn["numOfResultSet"]++;
				$STMTReturn["resultSet"][] = $result;
				continue;
			}

			$resultRow = true;
			
			for(;$SQLReturnFromRow > 0 && $statment->fetchIndexedRow(); $SQLReturnFromRow--) $rowCounter++;
					
			$resultRow = $statment->fetchIndexedRow();
			while($resultRow && $result['rowsReturned'] < $SQLMaxRowReturn)
			{
				$rowCounter++;
				$result['rowsReturned']++;
				$row = array();
				
				for($j=0; $j<$result['columnsInfo']['num']; $j++)
				{
					$value = $resultRow[$j];
					switch($result['columnsInfo']['type'][$j])
					{
						case "xml" :
							$row[] .= $displayXML ? ($displayXMLinline ? $value : base64_encode($value)) : "";
							break;
						case "clob":
							$row[] .= $displayCLOB ? ($displayCLOBinline ? $value : base64_encode($value)) : "";
							break;
						case "blob":
							$row[] .= $displayBLOB ? base64_encode($value) : "";
							break;
						case "dbclob":
							$row[] .= $displayDBCLOB ? base64_encode($value) : "";
							break;
						default:
							$row[] =  $value;
					}
					
				}
				$result['data'][] = $row;
				$resultRow = $statment->fetchIndexedRow();
			}
			$result["rowsInSet"] = $statment->getRowsInResultSet();
			$STMTReturn["numOfResultSet"]++;
			$STMTReturn["resultSet"][] = $result;

			//get next result set if there is one
		}while($statment->nextResultSet());
		
	}
	$STMTReturn["statementSucceed"] = $statment->statementSucceed;
	$STMTReturn["STMTMSG"] = $statment->sqlerror;
	$STMTReturn["STMTError"] = $statment->sqlstate;
	$STMTReturn["parameters"] = $statment->parameters;
	
	$STMTReturn["TotalRunDuration"] = microtime(true) - $STMTReturn["TotalRunDuration"];
	
	return $STMTReturn;
}
?>
