<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/

include_once(PHP_INCLUDE_BASE_DIRECTORY . "JSONEncodeMenu.php");

$menuRoot = MAIN_MENU_ROOT_DIRECTORY;

$rootNode = getParameter('rootCallBack');

$baseMenuFolder = getParameter('baseMenuFolder');
                
$filterList = getParameter('filterList');
                
JSONEncodeMenu::$defaultStage = getParameter('defaultStage', JSONEncodeMenu::$defaultStage);
JSONEncodeMenu::$defaultTarget = getParameter('defaultPanel', JSONEncodeMenu::$defaultTarget);
JSONEncodeMenu::$defaultWindow = getParameter('defaultWindow', JSONEncodeMenu::$defaultWindow);

if($rootNode != null)
{
	$node = new XMLNode();
	if($node->loadXML(file_get_contents($rootNode)) !== false)

	$rootDirectory = trim($node->getAttribute("rootDirectory"));
	$branchDirectory = trim($node->getAttribute("branchDirectory"));
	$filter = trim($node->getAttribute("filter"));

	if($rootDirectory != "")
	{
		$menuRoot = $rootDirectory;
	}
	elseif($branchDirectory != "")
	{
		$filepos = strrpos( $rootNode, "/");
		$menuRoot = substr($rootNode, 0, $filepos) . "/" . $branchDirectory;
	}
	
	if($filter != "")
	{
		if($filterList = null)
		{
			$filterList = array();
		}
		$filterList[] = $filter;
	}
} else if($baseMenuFolder != null)
{
	$menuRoot = $baseMenuFolder;
}

echo "(" . json_encode(JSONEncodeMenu::encodeMenuFolder("", $menuRoot, $filterList)) . ")";

?>