<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/
	require_once(PHP_INCLUDE_BASE_DIRECTORY . "ObjectXMLNode_" . XML_PARSING_ENGINE . ".php");

	loadJSFolder(JS_BASE_DIRECTORY);
	
	loadJSFolder(JS_BASE_DIRECTORY . BASE_LANGUAGE_DIRECTORY . CURRENT_TE_LANGUAGE . "/");
	
	function loadJSFolder($location)
	{
		// if the current expected directory is not a directory return
		if(is_dir($location) === false) return "";
	
		// Acquire a list of files in the directory sorted ascending
		$fileInDir = scandir($location, 0);
		
		sort($fileInDir);
	
		foreach($fileInDir as $currentFile)
		{
			// Look for XML files that start with 'menu_' and end with '.xml' while ignoring case
			if(preg_match('/^jsList_.*\.xml$/i', $currentFile ))
			{
				$fileContent = file_get_contents($location . $currentFile);
				if($fileContent != false)
				{
					$doc = new XMLNode();
					if($doc->loadXML($fileContent) !== false)
					{
		 				if(strcasecmp($doc->nodeName, "jsFileList") == 0)
		 				{
							foreach($doc->childNodes as $file)
							{
								if(strcasecmp($file->nodeName, "file") == 0)
				 				{
				 					$value = trim($file->textContent);
				 					echo "<script type='text/javascript' src='" . $location . $value . "'></script>\n";
				 				}
				 				elseif(strcasecmp($file->nodeName, "compressedFile") == 0)
				 				{
				 					$value = trim($file->textContent);
				 					echo "<script type='application/javascript' src='" . $location . $value . "'></script>\n";
				 				}
				 				elseif(strcasecmp($file->nodeName, "directory") == 0)
				 				{
				 					$value = trim($file->textContent);
				 					loadJSFolder($location . $value . "/");
				 				}
							}
		 				}
					}
				}
			}
		}
	}
?>