<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/

/******************************************************************************
 * VERSION INFORMATION
 *****************************************************************************/

/** DB2 Monitoring Console version number
 * @global string $MAJOR_VERSION
 * @global string $MINOR_VERSION
 * @global string $SUB_VERSION
 */
define("MAJOR_VERSION", 3);

define("MINOR_VERSION", 5);

define("SUB_VERSION", "1086");

/******************************************************************************
 * END - VERSION INFORMATION
 *****************************************************************************/

/******************************************************************************
 * UPGRADE WARNINGS
 *****************************************************************************/
/** Indicates if the user should see warning about problems that might exsist
	due to an upgrade
* @var  boolan SHOW_GENERAL_UPGRADE_WARNING */
define("SHOW_GENERAL_UPGRADE_WARNING", true);
/******************************************************************************
 * END - UPGRADE WARNINGS
 *****************************************************************************/

/*********************************************************************************
 *********************************************************************************
 *********************************************************************************
 
           IT IS NO LONGER RECOMENDED THAT YOU CHANGE CONFIGURATIONS IN
                                   THIS FILE!
  
           To add or edit configuration create the file "config.php" in
           the user preferences folder. Unless changed the directory it 
           will be "./preferences/".
           
           With in the file add the tag '<?php' to the vary top of the
           file. 
           
           Below the tag copy congfigurations from this file into
           your user configuration file and set it there.
           
           This will allow you to upgrade the TE without overwriting your
           custom settings.   
 
 *********************************************************************************
 *********************************************************************************
 *********************************************************************************/

/******************************************************************************
 *  USER PREFERENCES DIRECTORY
 *****************************************************************************/

/** User Configuration folder
* @var  string USER_PREFERENCES_DIRECTORY */
@define("USER_PREFERENCES_DIRECTORY", "./preferences/");


/** User configuration file Import 
 */
if(is_file(USER_PREFERENCES_DIRECTORY . "config.php") && is_readable(USER_PREFERENCES_DIRECTORY . "config.php")) {
		include_once(USER_PREFERENCES_DIRECTORY . "config.php");
}

/******************************************************************************
 * END - USER PREFERENCES DIRECTORY
 *****************************************************************************/

/******************************************************************************
 * GENERAL CONFIGURATION PARAMETERS
 *****************************************************************************/

/** Identifies if the TE is publicly hosted, Items like droping the schema
 * at then end of a tutorial will automaticly be run for you
* @var  string bool DMC_IS_PUBLICLY_HOSTED */
@define("DMC_IS_PUBLICLY_HOSTED", "false");

/** Identifies if the TE should raise a warning before the browser reloads or
*   navigates away from the TE
* @var  bool ENABLE_CONFIRM_LEAVE_VIA_BROWSER_NAVAGATION */
@define("ENABLE_CONFIRM_LEAVE_VIA_BROWSER_NAVIGATION", true);

/** XML Parsing Engine
* @var  string XML_PARSING_ENGINE */
@define("XML_PARSING_ENGINE", "DOM");

/** Speeds up IE by degrading functionality
* @var  boolean IE_SPEED_EXTENSION */
@define("IE_SPEED_EXTENSION", true);

/** Shows warning a warning notifing an IE user how slow there browser really it
* @var  boolean SHOW_IE_PERFORMANCE_WARNING */
@define("SHOW_IE_PERFORMANCE_WARNING", true);

/** enable PHP extension check, This will indicate to users that they do
 * not have the need PHP extension installed.
* @var  boolean ENABLE_PHP_EXTENSION_CHECK */
@define("ENABLE_PHP_EXTENSION_CHECK", true);

/******************************************************************************
 * END - GENERAL CONFIGURATION PARAMETERS
 *****************************************************************************/

/******************************************************************************
 * DB Driver Files - Specifies the driver interface to use
 *****************************************************************************/

/** The ID of the Page who called this link
* @var  string CALLING_PANEL */
@define("DB_CONNECTION", "DBConnection_IBM_DB2.php");

/** The stage who called this link
* @var  string CALLING_PANEL */
@define("DB_STATEMENT", "DBStatement_IBM_DB2.php");


/******************************************************************************
 * END - DB Driver Files
 *****************************************************************************/


/******************************************************************************
 * DEFAULT CONNECTION SETTINGS
 *****************************************************************************/

@define("TE_LANGUAGE", "en_US");

@define("BASE_LANGUAGE_DIRECTORY", "language/");

@define("TE_CHARACTER_SET", "UTF-8");
/** Use of a persistent connection will increases performance but at a 
 * cost. Use of a non persistent connection will add 0.25-2s in time 
 * per action call because a new connection needs to be established each 
 * time. Persistent connection will form a permanent connection to the 
 * database which will no be closed generally unless apache is restarted 
 * (e.g. I have no way to close the connection). There is also a problem 
 * that if the connection is forced off for any reason, there is currently 
 * no internal mechanism to recover and the web server will need to be 
 * restarted. 
* @var  boolean USE_PERSISTENT_CONNECTION */
@define("USE_PERSISTENT_CONNECTION", false);

/** Foces a connection using the default connection information
 * if enabled you can not connect to any other systems
* @var  boolean FORCE_CONNECTION_WITH_DEFAULT */
@define("FORCE_CONNECTION_WITH_DEFAULT", false);

/** Default database name
* @var  string DEFAULT_DB2_DATABASE*/
@define("DEFAULT_DB2_DATABASE", "");

/** Default database the username
* @var  string DEFAULT_DB2_DATABASE_USERNAME */
@define("DEFAULT_DB2_DATABASE_USERNAME", "");

/** Default schema name, if omitted the schema will be set to the username
* @var  string DEFAULT_DB2_DATABASE_SCHEMA */
@define("DEFAULT_DB2_DATABASE_SCHEMA", "");

/** Default host name, only used for direct connections
* @var  string DEFAULT_DB2_DATABASE_HOST_NAME */
@define("DEFAULT_DB2_DATABASE_HOST_NAME", "");

/** Default database port number, only used for direct connections
* @var  string DEFAULT_DB2_DATABASE_PORT_NUMBER */
@define("DEFAULT_DB2_DATABASE_PORT_NUMBER", "");

/** Default password only used when a connection is forced
* @var  string DEFAULT_DB2_DATABASE_PASSWORD */
@define("DEFAULT_DB2_DATABASE_PASSWORD", "");

/** Indicates if the TE should not write out to the connection store file. 
* @var  bool DISABLE_CONNECTION_STORE_FILE_WRITE */
@define('DISABLE_CONNECTION_STORE_FILE_WRITE', false);

/**
 * Default connection store file where connection are saved 
 * @var  string CONNECTION_STORE_FILE
 */
@define("CONNECTION_STORE_FILE", "./connectionStore/connStore.xml");

/**
 * Default connection store file where connection are saved 
 * @var  string CONNECTION_STORE_FILE
 */
@define("FEED_SOURCE_FILE", "./connectionStore/feedSourceList.xml");

/**
 * Indicates if we can save connectionsd 
 * @var  boolean ALLOW_CONNECTION_SAVING
 */
@define("ALLOW_CONNECTION_SAVING", true);

/**
 * Designates a not connected symbol  
 * @var  boolean CONNECTION_SYMBOL
 */
@define("CONNECTED", "Connected");

/**
 * Designates a not connected symbol  
 * @var  boolean CONNECTION_SYMBOL
 */
@define("DISCONNECTED", "Disconnected");

/******************************************************************************
 * END - DEFAULT CONNECTION SETTINGS
 *****************************************************************************/

/******************************************************************************
 * SESSION SETTINGS
 *****************************************************************************/

/**
 * The IP address to only allow connection from or boolean false to disable
 * @var  string LOCK_ON_IP_ADDRESS
 */
@define("LOCK_ON_IP_ADDRESS", false);

/**
 * In addition to the session key verify the users on his user agent
 * @var boolean VERIFY_ON_USER_AGENT
 */
@define("VERIFY_ON_USER_AGENT", true);

/**
 * In addition to the session key verify the users on his IP address
 * @var boolean VERIFY_ON_CLIENT_ADDR
 */
@define("VERIFY_ON_CLIENT_ADDRESS", true);

/**
 * Cycles the session ID of the user, 
 * Good protection against session hijacking. 
 * @var boolean VERIFY_ON_CLIENT_ADDR
 */
@define("CYCLE_SESSION_ID", false);

/**
 * The time in which a given session will time out. Set to boolean false to disable.
 * @var  int SESSION_TIMEOUT_IN_MIN */
@define("SESSION_TIMEOUT_IN_MIN", 30);

/******************************************************************************
 * END - SESSION SETTINGS
 *****************************************************************************/

/******************************************************************************
 * SECURITY SETTINGS
 *****************************************************************************/
/** Show errors that would normaly be suppresed
* @var  boolean ENABLE_VERBOSE */
@define("ENABLE_VERBOSE", false);

/** 
* @var  boolean ALLOW_DEVELOPER_VIEW */
@define("ALLOW_DEVELOPER_VIEW", false);

/** Allows Users to view the base XML used to display a table
* @var  boolean ALLOW_DISPLAY_OF_XML */
@define("ALLOW_DISPLAY_OF_XML", true);

/** Only allows access through a https connection
* @var  boolean FORCE_SECURE_CONNECTION */
@define("FORCE_SECURE_CONNECTION", false);

/** Foces a connection using the default connection information
 * if enabled you can not connect to any other systems
* @var  boolean FORCE_CONNECTION_WITH_DEFAULT */
@define("ENABLE_VIEW_QUERY", true);


/** The Regex used to ensure filenames are valid
* @var  string FILE_VERIFICATION_REGEX */
@define("FILE_VERIFICATION_REGEX", '/^[a-zA-Z0-9_\/-]+$/');


/******************************************************************************
 * END - SECURITY SETTINGS
 *****************************************************************************/

/******************************************************************************
 * BASE FOLDERS AND FILES
 *****************************************************************************/

/** This is the default page that is displayed when opening a new tab
* This file contains a slandered menu 
* @var  string TE_DEFAULT_PAGE */
@define("CUSTOM_TE_NEW_TAB", USER_PREFERENCES_DIRECTORY . "/menu_CUSTOM_TE_NEW_TAB.xml");

/** This is the page that is displayed when first loading the TE
 * This file contains only a XML of a PageWindow
* @var  string TE_HOME_PAGE */
@define("CUSTOM_TE_HOME_PAGE_LAYOUT", "/TE_HOME_PAGE.xml");

/**
 * Base action directory when there is no connection - These action can be run when no connection has been registered 
 * @var  string ACTION_DIRECTORY
 */
@define("ACTION_DIRECTORY_NO_CONNECTION", "./actions/noConnection/");

/**
 * Base action directory for active connection - These action can be run only when you have a active connection to the database
 * @var  string ACTION_DIRECTORY_ACTIVE_CONNECTION
 */
@define("ACTION_DIRECTORY_ACTIVE_CONNECTION", "./actions/activeConnection/");

/**
 * Base table definition directory
 * @var  string TABLE_DEFINITION_DIRECTORY
 */
@define("TABLE_DEFINITION_DIRECTORY", "./tableDefinitions/");

/**
 * Defines the root of the main root menu
 * @var  string MAIN_MENU_ROOT_DIRECTORY
 **/
@define("MAIN_MENU_ROOT_DIRECTORY", "./menu/");

/**
 * Defines the root of the main root menu
 * @var  string MAIN_RIGHT_MENU_ROOT_DIRECTORY
 **/
@define("MAIN_RIGHT_MENU_ROOT_DIRECTORY", "./menu/righthandMenu/");

/**
 * The directory where all saved and predefined
 * queries are stored
 * @var  string QUERY_FILES_DIRECTORY
 */
@define("QUERY_FILES_DIRECTORY", "./queryfiles/");

/**
 * Base directory for all html files
 *
 *
 * DO NOT CHANGE
 *
 * The HTML directory needs to be in the same
 * directory as the CSS directory. Since the
 * HTML files will need to reference to the
 * CSS files and they are not intelligent enough
 * to handle directory changes.
 *
 * @var  string HTML_BASE_DIRECTORY
 */
define("HTML_BASE_DIRECTORY", "./html/");

/**
 * Base directory for all css files
 *
 * The CSS directory needs to be in the same
 * directory as the HTML directory. Since the
 * HTML files will need to reference to the
 * CSS files and they are not intelligent enough
 * to handle directory changes.
 *
 * @var  string CSS_BASE_FILE
 */
@define("CSS_BASE_FILE", "./css/default.css");

/**
 * Base directory for all js files
 *
 * @var  string CSS_BASE_DIRECTORY
 */
@define("JS_BASE_DIRECTORY", "./js/");

/**
 * Base directory for all image files
 *
 *
 * DO NOT CHANGE
 *
 * NOTE: The HTML directory has its' own
 * image directory
 *
 * @var  string IMAGE_BASE_DIRECTORY
 */
define("IMAGE_BASE_DIRECTORY", "./images/");

/**
 * Base directory for all PHP base include files
 * @var  string PHP_INCLUDE_BASE_DIRECTORY
 */
@define("PHP_INCLUDE_BASE_DIRECTORY", "./base/");

/** Default action processor
* @var  string ACTION_PROCESSOR */
@define("ACTION_PROCESSOR", "action.php");

/** Default menu processor
* @var  string MENU_PROCESSOR */
@define("MENU_PROCESSOR", ACTION_PROCESSOR . "?action=menu");

/**
 * Base directory for all tutorials
 *
 * DO NOT CHANGE
 *
 * @var  string TUTORIAL_BASE_DIRECTORY
 */
define("TUTORIAL_BASE_DIRECTORY", "./tutorials/");

/**
 * Base directory for all tutorials
 * @var  string TUTORIAL_BASE_DIRECTORY
 */
@define("ACTION_SCRIPTS_BASE_DIRECTORY", "./actionScripts/");

/** used to aquier you current connection status and connection information.
* @var  string CONNECTION_VERIFIER */
@define("CONNECTION_VERIFIER", ACTION_PROCESSOR . "?action=DBConnectionCheck&returnType=JSON");


/******************************************************************************
 * END -  BASE FOLDERS AND FILES
 *****************************************************************************/

/******************************************************************************
 * TABLE DISPLAY SETTINGS
 *****************************************************************************/
/** The maximum number of rows to check if exists when the row count does not work 
* @var  integer SQL_MAX_ROW_LOOK_AHEAD */
@define("SQL_MAX_ROW_LOOK_AHEAD", 500);

/** Default width of an icon
* @var  integer DEFAULT_ICON_WIDTH */
@define("DEFAULT_ICON_WIDTH", 20);

/** Maximum number of characters in long fields.
* @var  int LONG_FIELD_MAX */
@define("LONG_FIELD_MAX", 60);

/** Number of table row alternating colors
* @var  array NUMBER_OF_TABLE_ALT_COLORS
*/
@define("NUMBER_OF_TABLE_ALT_COLORS", 2);

/** Table row alternating colors #1
* @var  array TABLE_ALT_COLORS_0
*/
@define("TABLE_ALT_COLORS_0", 'id="TableRowA"');

/** Table row alternating colors #2
* @var  array TABLE_ALT_COLORS_1
*/
@define("TABLE_ALT_COLORS_1", 'id="TableRowB"');

/** Table title row color
* @var  array TABLE_TITLE_COLOR
*/
@define("TABLE_TITLE_COLOR", 'id="TableTitlerRow"');

/******************************************************************************
 * END - TABLE DISPLAY SETTINGS
 *****************************************************************************/


/******************************************************************************
 * Ad Hoc SQL SETTINGS
 *****************************************************************************/

/** 
* @var  boolean JAVA_SQL_ENABLED */
@define("JAVA_SQL_ENABLED", false);
/** 
* @var  boolean SSH2_ENABLED */
@define("SSH2_ENABLED", true);

/** 
* @var  boolean AD_HOC_DISPLAY_XML */
@define("AD_HOC_DISPLAY_XML", false);

/** 
* @var  boolean AD_HOC_DISPLAY_XML_AS_INLINE */
@define("AD_HOC_DISPLAY_XML_AS_INLINE", false);

/** 
* @var  boolean AD_HOC_DISPLAY_CLOB */
@define("AD_HOC_DISPLAY_CLOB", false);

/** 
* @var  boolean AD_HOC_DISPLAY_CLOB_AS_INLINE */
@define("AD_HOC_DISPLAY_CLOB_AS_INLINE", false);

/** 
* @var  boolean AD_HOC_DISPLAY_BLOB */
@define("AD_HOC_DISPLAY_BLOB", false);

/** 
* @var  boolean AD_HOC_DISPLAY_DBCLOB */
@define("AD_HOC_DISPLAY_DBCLOB", false);

/** 
* @var  char AD_HOC_TERMINATION_CHAR */
@define("AD_HOC_TERMINATION_CHAR", ";");

/** 
* @var boolean AD_HOC_CURSOR */
@define("AD_HOC_USER_FORWARD_ONLY_CURSOR", true);

/** 
* @var boolean AD_HOC_COMMIT_PER_STMT */
@define("AD_HOC_COMMIT_PER_STMT", false);

/** 
* @var integer AD_HOC_NUMBER_OF_ROWS_TO_RETURN */
@define("AD_HOC_NUMBER_OF_ROWS_TO_RETURN", 100);

/** 
* @var integer SHELL_COMMAND_MAX_RUN_TIME */
@define("SHELL_COMMAND_MAX_RUN_TIME", 10);

/** 
* @var integer SHELL_COMMAND_TERM_CHAR */
@define("SHELL_COMMAND_TERM_CHAR", "");

/** 
* @var string AD_HOC_SCRIPT_MODE */
@define("AD_HOC_SCRIPT_MODE", "SQL");
/******************************************************************************
 * END - Ad Hoc SQL SETTINGS
 *****************************************************************************/


/******************************************************************************
 * Start - Floating Window Options
 *****************************************************************************/
/** 
* @var integer DEFAULT_FLOATING_WINDOW_HEIGHT */
@define("DEFAULT_FLOATING_WINDOW_HEIGHT", 500);

/** 
* @var integer DEFAULT_FLOATING_WINDOW_WIDTH */
@define("DEFAULT_FLOATING_WINDOW_WIDTH", 700);

/******************************************************************************
 * END - Floating Window Options
 *****************************************************************************/

/**
* This line initialize the session it should be the last thing to be done in this file
*/
require_once(PHP_INCLUDE_BASE_DIRECTORY . "initializeSession.php");