<?php
/*******************************************************************************
 *  Copyright IBM Corp. 2007 All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *********************************************************************************/

include_once("./config.php");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta http-equiv="Content-Style-Type" content="text/css; charset=UTF-8"/>
<link rel="stylesheet" type="text/css" media="all" href="<?php echo CSS_BASE_FILE; ?>"/>

<?php

	echo "<title>" . connectionManager::titleString() . "</title>\n\n";
	
	include_once(PHP_INCLUDE_BASE_DIRECTORY . "HTMLEncodeJSList.php");
	
	include_once(PHP_INCLUDE_BASE_DIRECTORY . "HTMLEncodeActionList.php");
?>

<script type="text/javascript">

YAHOO.widget.Chart.SWFURL = "<?php echo JS_BASE_DIRECTORY; ?>/YUI/chart/assets/charts.swf";

var CLIENT_ACTIONS = $H();

var GLOBAL_CONSTANTS = $H();
var DB2MC_SERVER = location.href.substr(0, location.href.lastIndexOf('/')); 
GLOBAL_CONSTANTS.set("DB2MC_SERVER", DB2MC_SERVER.replace("http://", ""));

<?php
writeJSConstant(
		array(
			'DMC_IS_PUBLICLY_HOSTED',
			'FORCE_CONNECTION_WITH_DEFAULT',
			'HTML_BASE_DIRECTORY',
			'IMAGE_BASE_DIRECTORY',
			'ACTION_PROCESSOR',
			'MENU_PROCESSOR',
			'TUTORIAL_BASE_DIRECTORY',
			'CONNECTION_VERIFIER',
			'DEFAULT_FLOATING_WINDOW_HEIGHT',
			'DEFAULT_FLOATING_WINDOW_WIDTH',
			'CONNECTED',
			'DISCONNECTED',
			'IE_SPEED_EXTENSION',
			'SHOW_IE_PERFORMANCE_WARNING',
			'JAVA_SQL_ENABLED',
			'SSH2_ENABLED',
			'AD_HOC_DISPLAY_XML',
			'AD_HOC_DISPLAY_XML_AS_INLINE',
			'AD_HOC_DISPLAY_CLOB',
			'AD_HOC_DISPLAY_CLOB_AS_INLINE',
			'AD_HOC_DISPLAY_BLOB',
			'AD_HOC_DISPLAY_DBCLOB',
			'AD_HOC_TERMINATION_CHAR',
			'AD_HOC_USER_FORWARD_ONLY_CURSOR',
			'AD_HOC_COMMIT_PER_STMT',
			'AD_HOC_NUMBER_OF_ROWS_TO_RETURN',
			'SHELL_COMMAND_MAX_RUN_TIME',
			'SHELL_COMMAND_TERM_CHAR',
			'AD_HOC_SCRIPT_MODE',
			'DEFAULT_ICON_WIDTH',
			'LONG_FIELD_MAX',
			'ENABLE_VIEW_QUERY',
			'ALLOW_DISPLAY_OF_XML',
			'ALLOW_DEVELOPER_VIEW',
			'ENABLE_VERBOSE',
			'MAJOR_VERSION',
			'MINOR_VERSION',
			'SUB_VERSION'
		)
	);
?>

var CONNECTED_DATABASE = null; 
GLOBAL_CONSTANTS.set("CONNECTED_DATABASE", null);
var CONNECTED_DATABASE_VERSION = null; 
GLOBAL_CONSTANTS.set("CONNECTED_DATABASE_VERSION", null);

var TE_HOME_PAGE = (<?php
	if(is_file(USER_PREFERENCES_DIRECTORY . CUSTOM_TE_HOME_PAGE_LAYOUT) && is_readable(USER_PREFERENCES_DIRECTORY . CUSTOM_TE_HOME_PAGE_LAYOUT))
	{
		echo json_encode(JSONEncodeMenu::encodePageWindowFromFile(USER_PREFERENCES_DIRECTORY . CUSTOM_TE_HOME_PAGE_LAYOUT));
	}
	else if(is_file(USER_PREFERENCES_DIRECTORY . "default/" . CUSTOM_TE_HOME_PAGE_LAYOUT) && is_readable(USER_PREFERENCES_DIRECTORY . "default/" . CUSTOM_TE_HOME_PAGE_LAYOUT))
	{	
		echo json_encode(JSONEncodeMenu::encodePageWindowFromFile(USER_PREFERENCES_DIRECTORY . "default/" . CUSTOM_TE_HOME_PAGE_LAYOUT));
	}
?>);

Event.observe(window, 'load', function() {

	new windowStage('SuperStage', NO_TASK_BAR, 0, 0, 0, 0, NO_TITLE_BAR, NO_NAV_BAR, NO_TITLE_BAR_OPTIONS, WINDOW_IS_FULL);
	$('PageBody').insert(STAGE_activeStages.get('SuperStage').show());
	
	new windowStage('FloatingStage', NO_TASK_BAR, 0, 0, 0, 0, WINDOW_CONTROLS_INSIDE_OF_TITLE, NAV_BACK_BUTTON | NAV_FORWARD_BUTTON | NAV_RELOAD_BUTTON, TITLE_BAR_CLOSE_BUTTON, WINDOW_IS_SIZABLE);
	$('PageBody').insert(STAGE_activeStages.get('FloatingStage').show());

	var layout = (<?php echo json_encode(JSONEncodeMenu::encodePageWindowFromFile(USER_PREFERENCES_DIRECTORY . "default/TE_CORE_LAYOUT.xml")); ?>);
	
	loadNewPageLayout(layout);
	
	changeWorkArea();

	$('PageBody').observe('click', function() {
		if(!mouseIsOverContextBase)
		{
			if(visibleFloatingObject != null && AllowAutoClosingOfFloatingObject)
			{
				visibleFloatingObject.close();
			}
			AllowAutoClosingOfFloatingObject = true;
		}
	});

	$('PageBody').observe('mouseup', function() {
		Releaseme();
		$(GENERAL_BLANK_POPUP.elementUniqueID + "_Container").setStyle({"display": "none"});
	});

	$('PageBody').observe('contextmenu', function() {
		return false;
	});
	
	var GENERAL_BLANK_POPUP = new floatingPanel('GENERAL_BLANK_POPUP', 'RAW', 'Nothing to See', null, true, false, null, 350, 10);
	GENERAL_BLANK_POPUP.draw();
	
	localWindowResize();

	OpenBlankWindow("DefaultStage");
	
	if(Prototype.Browser.IE && SHOW_IE_PERFORMANCE_WARNING)
	{
		openModalAlert("<?php echo PHP_INCLUDE_BASE_DIRECTORY . BASE_LANGUAGE_DIRECTORY .  TE_LANGUAGE . "/index_IE_warning.html";?>"
						, "URL", null, null);
	}
	
});


generalKeyCommands = function(event) {
	if(event.keyCode == Event.KEY_ESC)
	{
		closeOpenFloatingObject();
	}	
};

stopPropagation = function(event){
	Event.stop(event);
};

<?php
//Used to stop users from accidentally leaving the page and losing all there work. 
if(ENABLE_CONFIRM_LEAVE_VIA_BROWSER_NAVIGATION)
{
	echo '
window.onbeforeunload = function confirmLeaveVIAbrowserNavigation() {
	return "All open pages within the Technology Explorer will be lost if you leave the page.";
};
';
}
?>

//On window scroll move scroll bars back to the top. Stop accidental scrolling of the entire application.
window.onscroll = function (e) {
	document.documentElement.scrollTop = 0;
	document.documentElement.scrollLeft = 0;
	return false;
};
</script>

</head>

<body id="PageBody" onkeypress="generalKeyCommands(event);" onResize="localWindowResize()" onselectstart="return false">
<?php
	readfile(PHP_INCLUDE_BASE_DIRECTORY . BASE_LANGUAGE_DIRECTORY .  TE_LANGUAGE . "/index_error.html");
?>
</body>
</html>