/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
function openModalForm(data, type, callingActionStack, parameters)
{
	if(type == null)
		type = "RAW";
	new modalPanelForm("alertModalPanel_" + getGUID(), type, data, false, callingActionStack, parameters);
}
var modalPanelForm = Class.create(modalPanel, {
	initialize: function($super, myID, Type, Data, hideMenuBar, callingActionStack, parameters) {
		this.buttonA = Object.isString(parameters['buttonOK']) ? parameters['buttonOK'] : (Object.isString(parameters['buttonA']) ? parameters['buttonA'] : 'Ok');
		this.buttonB = Object.isString(parameters['buttonCancel']) ? parameters['buttonCancel'] : (Object.isString(parameters['buttonB']) ? parameters['buttonB'] : 'Cancel');
		if(parameters != null)
		{
			var OtherButtons = $H();
			var tempHash = new Hash(parameters);
			tempHash.each(function(item) {
				if(item.key.substring(0,7).toLowerCase() == "button_")
				{
					OtherButtons.set(item.key.substring(7), item.value);
				}
			});
			this.OtherButtons = OtherButtons;
		}
		this.minLeft = 0;
		this.minRight = 0;
		$super(myID, Type, Data, hideMenuBar, callingActionStack, parameters);
	},
	modalPanelControls: function () {
		var output = "";
		var elementUniqueID = this.elementUniqueID;
		output += "<table align='right' style='width:100%;position:static;'><tr><td></td>";
		output += "<td style='text-align:right;width:5px'><button onClick=\"activeModalPanel.get('" + elementUniqueID + "').returnCallOK();\">" + this.buttonA.replace(/ /g, '&nbsp;') + "</button></td>";
		if(this.OtherButtons != null)
		{
			this.OtherButtons.each(function(item) {
			output += "<td style='text-align:right;width:5px'><button onClick=\"activeModalPanel.get('" + elementUniqueID + "').returnCall('" + item.key + "');\">" + item.value.replace(/ /g, '&nbsp;') +"</button></td>";
			});
		}
		output += "<td style='text-align:right;width:5px'><button selected onClick=\"activeModalPanel.get('" + elementUniqueID + "').destroy();\">" + this.buttonB.replace(/ /g, '&nbsp;') + "</button></td>";
		output += "</tr></table>";
		return output;
	},
	modalPanelLeft: function () {
		return "";
	},
	modalPanelRight: function() {
		return "";
	},
	returnCallOK: function() {
		if(this.CallingActionStack != null)
		{
			try{
					this.CallingActionStack.localVariables.result.returnCode= 'true';
			}catch (e){
			}
		}
		this.destroy();
	},
	returnCall: function(returnValue) {
		if(this.CallingActionStack != null)
		{
			try{
					this.CallingActionStack.localVariables.result.returnCode= returnValue;
			}catch (e){
			}
		}
		this.destroy();
	}
});