/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
var activeContextWindow = null;
var allContextWindows = $H();
var contextIDCounter = 0;
var menuWaitingToOpen = null;
var mouseIsOverContextBase = false;

var closeGivenContextNodeChild = function(nodeName) {
		var parentNode = allContextWindows.get(nodeName);
		if(parentNode != null)
		{
			if(parentNode.openChildNode != null)
			{
				parentNode.openChildNode.close();
			}
			parentNode.openChildNode = null;
		}
};
var closeContextMenu = function() {
	if(activeContextWindow != null)
		activeContextWindow.close();
};
var contextNode = Class.create({
	initialize: function(myID, nodeValue, nodeAction, subNodes, subNodeDirection) {
		this.elementID = myID;
		this.elementValue = nodeValue;
		this.elementActionScript = nodeAction;
		this.elementSubNodes = subNodes;
		this.elementSubNodeDirection = subNodeDirection;
	}
});
var createContextMenu = function(baseContainer, baseNodes, nodeDirection, parentStageID, parentWindowID, parentPanelID, menuExpansionType, listStyleType) {
	menuExpansionType = menuExpansionType == null || menuExpansionType == "" ? true : (menuExpansionType.toLowerCase() == "internal" ? false : true);
	getPanel(parentStageID,parentWindowID,parentPanelID).registerNestedObject(baseContainer, new contextBase(baseContainer, null, EMBEDDED_CONTEXT_WINDOW, baseNodes, nodeDirection, true, CENTER, CENTER, parentStageID, parentWindowID, parentPanelID, menuExpansionType, listStyleType));
};
var createContextMenuOnPanelObject = function(baseContainer, baseNodes, nodeDirection, panelObject) {
	panelObject.registerNestedObject(baseContainer, new contextBase(baseContainer, null, EMBEDDED_CONTEXT_WINDOW, baseNodes, nodeDirection, true, CENTER, CENTER));
};
var delayContextBaseOpen = function(ID, theDelay)
{
	if(menuWaitingToOpen != null)
	{
		//clearTimeout(menuWaitingToOpen);
	}
	menuWaitingToOpen = setTimeout("allContextWindows.get(\"" + ID + "\").open();", theDelay);
};

var contextBase = Class.create(basePageElement, {
	initialize: function($super, parentContainer, parentNode, isEmbedded, baseNodes, nodeDirection, rootNode, submenuVerticalPosition, submenuHorizontalPosition, parentStageID, parentWindowID, parentPanelID, menuExpansionType, listStyleType) {
		if (menuWaitingToOpen != null) {
			clearTimeout(menuWaitingToOpen);
		}
		var myID = parentNode == null ? "CONTEXTBASE_" + ++contextIDCounter : parentNode;
		$super(myID, "CONTEXTBASE");
		this.parentStageID = parentStageID;
		this.parentWindowID = parentWindowID;
		this.parentPanelID = parentPanelID;
		this.elementParent = parentContainer;
		this.baseNodes = baseNodes;
		this.callBackNode = null;
		this.isEmbedded = isEmbedded;
		this.isRootNode = rootNode;
		this.nodeDirection = nodeDirection;
		this.windowIsVisible = false;
		this.menuText = "";
		this.setEmpty();
		this.submenuVerticalPosition = submenuVerticalPosition;
		this.submenuHorizontalPosition = submenuHorizontalPosition;
		this.childNodes = $H();
		this.openChildNode = null;
		this.menuExpansionType = menuExpansionType == null ? true : menuExpansionType;
		this.listStyleType = listStyleType == null || listStyleType == "" ? "none" : listStyleType;
		allContextWindows.set(this.elementUniqueID, this);
		if (Object.isString(this.baseNodes)) {
			this.callBackNode = this.baseNodes;
			this.getMenu();
		}
		else if (Object.isArray(this.baseNodes)) {
			this.draw();
		}
		else if (this.baseNodes != null) {
			if (this.baseNodes.nodeType == "DELAYLOADBRANCH") {
				this.callBackNode = this.baseNodes;
				this.getMenu();
			}
		}
	},
	
	getRootNode: function()
	{
		var parent = allContextWindows.get(this.elementParent);
		if(parent != null)
		{
			if(parent.isEmbedded && parent.isRootNode)
				return this.elementName;
			return parent.getRootNode();
		}
		return null;
	},
	
	getMenu: function() {
		if (this.callBackNode == null)
			return;
		this.setEmpty();
		var parameters = new Object();
		var thisObject = this;
		if(Object.isString(this.callBackNode))
			parameters.baseMenuFolder = this.callBackNode;
		else
			parameters.rootCallBack = this.callBackNode.rootCallBack;
		parameters.returntype = "JSON";
		new Ajax.Request(MENU_PROCESSOR, {
			'parameters': parameters,
			'method': 'post',
			'onSuccess': function(transport) {
				thisObject.baseNodes = transport.responseJSON;
				thisObject.draw();

			},
			'onFailure': function(transport) {
				thisObject.baseNodes = [{
					elementID: 'LEAF',
					elementValue: 'ERROR LOADING MENU',
					elementActionScript: '',
					elementSubNodes: null,
					elementSubNodeDirection: null
}];
					thisObject.draw();
				},
				'onException': function(transport,exception)
				{
					thisObject.baseNodes = [{
						elementID: 'LEAF',
						elementValue: 'EXCEPTION OCCURRED LOADING MENU : ' + exception,
						elementActionScriptScript: '',
						elementSubNodes: null,
						elementSubNodeDirection: null
}];
						thisObject.draw();
			}
		});
	},
	close: function() {
		if(this.menuExpansionType)
		{
			if (this.openChildNode != null) {
				this.openChildNode.close();
				this.openChildNode = null;
			}
			var thisNode = $(this.elementUniqueID + "_TopNode");
			if (thisNode != null) {
				thisNode.remove();
				this.windowIsVisible = false;
			}
			if (activeContextWindow != null)
				if (activeContextWindow.elementUniqueID == this.elementUniqueID)
				activeContextWindow = null;
			if (visibleFloatingObject != null)
				if (visibleFloatingObject.elementUniqueID == this.elementUniqueID)
				visibleFloatingObject = null;
		}
		else
		{
			var thisNode = $(this.elementUniqueID + "_TopNode");
			if(thisNode != null)
				thisNode.remove();
		}
	},
	open: function() {
		if(this.menuExpansionType)
		{
			var parentNode = allContextWindows.get(this.elementParent);
			if (parentNode != null) {
				if (parentNode.openChildNode != null) {
					parentNode.openChildNode.close();
				}
				parentNode.openChildNode = this;
			}
			AllowAutoClosingOfFloatingObject = true;
			if (!this.isEmbedded && this.isRootNode) {
				closeOpenFloatingObject();
				activeContextWindow = this;
				visibleFloatingObject = this;
			}
			if (!this.isEmbedded) {
				$("PageBody").insert(this.menuText);
			}
			var thisNode = $(this.elementUniqueID + "_TopNode");
			
			if (thisNode != null) {
				thisNode.show();
				this.nodeFilter();
				if (!this.isEmbedded) {
					this.position();
				}
			}
		}
		else
		{
			var thisNode = $(this.elementUniqueID + "_TopNode");
			
			if(thisNode == null)
			{
				var parentNode = allContextWindows.get(this.elementParent);
				if (parentNode != null) {
					if (parentNode.openChildNode != null) {
						parentNode.openChildNode.close();
					}
					parentNode.openChildNode = this;
				}
				var thisNode = $(this.elementUniqueID);
				
				if (thisNode != null) {
					thisNode.insert(this.menuText);
				}
				 var thisNode = $(this.elementUniqueID + "_TopNode");
				
				if (thisNode != null)
				{
					thisNode.show();
					this.nodeFilter();
				}
			}
			else
				thisNode.remove();
		}
		this.windowIsVisible = true;
	},
	nodeFilter: function() {
		var version = null;
		var fixPack = null;
		if(ACTIVE_DATABASE_CONNECTION_OBJECT != null)
		{
			if(ACTIVE_DATABASE_CONNECTION_OBJECT['dataServerInfo'] != null)
			{
				version = ACTIVE_DATABASE_CONNECTION_OBJECT['dataServerInfo']['dataServerVersion'];
				fixPack = ACTIVE_DATABASE_CONNECTION_OBJECT['dataServerInfo']['dataServerFixpack'];
			}
		}
		if(this.baseNodes != null)
		{
			var i = 0;
			var Node = null;
			var nodeElement = null;
			for(i = 0; i<this.baseNodes.length; i++)
			{
				Node = this.baseNodes[i];
				if(Node == null) continue;
				nodeElement = $(Node.internalID);
				if(nodeElement == null)
				{
					continue;	
				}
				
				if(version != null)
				{
					if(Node.minVersion != 0)
					{
						if(	Node.minVersion > version)
						{
							nodeElement.hide();
							continue;
						}	
						if(	Node.minVersion = version)
						{
							if(Node.minFixPack != 0)
							{
								if(Node.minFixPack > fixPack)
								{
									nodeElement.hide();
									continue;
								}
							}	
						}
					}
					if(Node.maxVersion != 0)
					{
						if(Node.maxVersion < version)
						{
							nodeElement.hide();
							continue;
						}	
					}
				}
				nodeElement.show();
			}
			
		}
	},
	position: function() {
		var mainContainer = $(this.elementUniqueID + "_TopNode");
		if (mainContainer == null) {
			return;
		}
		if (mainContainer.getStyle("display") != "block") {
			return;
		}
		var buttonOffset = 0;
		var buttonWidth = 0;
		var buttonHeight = 0;
		
		var parentElement = $(this.elementUniqueID);
		if(parentElement != null)
		{
			buttonOffset = parentElement.cumulativeOffset();
			buttonWidth = parentElement.getWidth();
			buttonHeight = parentElement.getHeight();
		}
		else {
			buttonLeft = CORE_Current_Mouse_X;
			buttonTop = CORE_Current_Mouse_Y;
			buttonOffset = {
				left: buttonLeft,
				top: buttonTop
			};
		}

		var sizingObject = {
			WindowPositionTop: false,
			WindowPositionLeft : false,
			windowHeight	 : pageHeight,
			windowWidth		: pageWidth,
			buttonOffset	 : buttonOffset,
			buttonWidth		: buttonWidth,
			buttonHeight	 : buttonHeight,
			spButtonLeft	 : buttonOffset.left,
			spButtonRight	: pageWidth - (buttonOffset.left + buttonWidth),
			spButtonCenterV	: buttonOffset.left + (buttonWidth/2),
			spButtonTop		: buttonOffset.top,
			spButtonBottom	 : pageHeight - (buttonOffset.top + buttonHeight),
			spButtonCenterH	: buttonOffset.top + (buttonHeight/2),
			containerWidth	 : mainContainer.getWidth(),
			containerHeight	: mainContainer.getHeight()
		};
		var Menulocation = ( this.submenuHorizontalPosition != null ? this.submenuHorizontalPosition : RIGHT ) + "." + (this.submenuVerticalPosition != null ? this.submenuVerticalPosition : BOTTOM);
		switch(Menulocation)
		{
			case RIGHT + "." + TOP:
				if(menuPosition.RT(sizingObject)) break;
				if(menuPosition.RB(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case RIGHT + "." + BOTTOM:
				if(menuPosition.RB(sizingObject)) break;
				if(menuPosition.RT(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case RIGHT + "." + CENTER:
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case LEFT + "." + TOP:
				if(menuPosition.LT(sizingObject)) break;
				if(menuPosition.LB(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case LEFT + "." + BOTTOM:
				if(menuPosition.LB(sizingObject)) break;
				if(menuPosition.LT(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case LEFT + "." + CENTER:
				if(menuPosition.LC(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case CENTER + "." + TOP:
				if(menuPosition.CT(sizingObject)) break;
				if(menuPosition.CB(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case CENTER + "." + BOTTOM:
				if(menuPosition.CB(sizingObject)) break;
				if(menuPosition.CT(sizingObject)) break;
				if(menuPosition.RC(sizingObject)) break;
				menuPosition.RCI(sizingObject);
				break;
			case CENTER + "." + CENTER:
				menuPosition.CC(sizingObject);
				break;
		}
		mainContainer.setStyle({ "top": sizingObject.WindowPositionTop + "px", "left": sizingObject.WindowPositionLeft + "px", "zIndex" :getTopZindex()});
	},
			
			destroy: function() {
				if (this.childNode != null)
					this.childNode.each(function(aContextMenu) {
						aContextMenu.value.destroy();
					});
				allContextWindows.unset(this.elementUniqueID);
				if ($(this.elementUniqueID + "_TopNode") != null)
					$(this.elementUniqueID + "_TopNode").remove();
			},
			setEmpty: function() {
				buildTextForMenu = "";
				 if(!this.menuExpansionType && !this.isEmbedded) {
					buildTextForMenu += "<div class='contextBaseWindow' style='display:none;padding-left:5px;'";
				} else if (this.isEmbedded) {
					buildTextForMenu += "<span class='contextBaseWindow' style='display:block;position:static;'";
				}
				else {
					buildTextForMenu += "<div class='contextBaseWindow' style='display:none;z-index:" + getTopZindex() + ";position:absolute;border: 1px solid #a4a4a4;left:0px;top:0px;'";
				}
				buildTextForMenu += " id='" + this.elementUniqueID + "_TopNode'";
				buildTextForMenu += " onmouseout='if(menuWaitingToOpen != null){clearTimeout(menuWaitingToOpen);} mouseIsOverContextBase=false;' onmouseover='mouseIsOverContextBase=true;'>";
				buildTextForMenu += "<img style='float:none;' src='images/loadingpage_small_transparent.gif'/>";
				if(!this.menuExpansionType) {
					buildTextForMenu += "</div>";
				} else if (this.isEmbedded && !this.isEmbedded) {
					buildTextForMenu += "</span>";
					$(this.elementParent).update(buildTextForMenu);
				}
				else {
					buildTextForMenu += "</div>";
				}
				this.menuText = buildTextForMenu;
			},
			draw: function() {
				var ID;
				var buildTextForMenu = "";
				var isEmbedded = this.isEmbedded;
				var isRootNodes = (this.isEmbedded) ? true : false;
				var offset = { left: 0, top: 0 };
				var elementParent = this.elementParent;
				var menuCSSClass = "contextBaseLIMenu";
				var linkCSSClass = "contextBaseLILink";
				var verticalPosition = BOTTOM;
				var horizontalPosition = RIGHT;
				var childNodes = this.childNodes;
				if (isEmbedded || !this.menuExpansionType) {
					menuCSSClass = "contextRootLIMenu";
					linkCSSClass = "contextRootLILink";
				}
				buildTextForMenu += "";
				if(!this.menuExpansionType && !isEmbedded) {
					buildTextForMenu += "<div class='contextBaseWindow' style='display:none;padding-left:5px;'";
				} else if (isEmbedded) {
					buildTextForMenu += "<span class='contextBaseWindow' style='display:block;'";
				} else {
					buildTextForMenu += "<div class='contextBaseWindow' style='display:none;z-index:" + getTopZindex() + ";position:absolute;border: 1px solid #a4a4a4;left:0px;top:0px;'";
				}
				buildTextForMenu += " id='" + this.elementUniqueID + "_TopNode'";
				if (isEmbedded) {
					verticalPosition = BOTTOM;
					horizontalPosition = LEFT;
				}
				
				buildTextForMenu += " onmouseout='if(menuWaitingToOpen != null){clearTimeout(menuWaitingToOpen);} mouseIsOverContextBase=false;' onmouseover='mouseIsOverContextBase=true;'";
				buildTextForMenu += ">";
				
				buildTextForMenu += "<ol style='list-style-type:" + this.listStyleType + "' class='";
				if (this.nodeDirection)
					buildTextForMenu += 'contextBaseULVertical';
				else
					buildTextForMenu += 'contextBaseULHorizontal';
				buildTextForMenu += "' >";
				var localMenuText = "";
				if(this.baseNodes != null)
				{
					var i = 0;
					var Node = null;
					var tag = null;
					var nodeType = null;
					var nodeElementID = null;
					for(i = 0; i<this.baseNodes.length; i++)
					{
						Node = this.baseNodes[i];
						if(Node == null) continue;
						tag = "a"
						
						var versionNote = "";
						
						if(Node.minVersion != 0 && Node.minVersion != null)
						{
							versionNote = " (" + Node.minVersion;
							
							if(Node.minFixPack != 0 && Node.minFixPack != null)
								versionNote += "fp" + Node.minFixPack;
								
							if(Node.maxVersion != 0 && Node.maxVersion != null)
								versionNote += "-" + Node.maxVersion;
							else
								versionNote += "+";
							versionNote += ") ";
						} else if(Node.maxVersion != 0 && Node.maxVersion != null)
							versionNote = " (" + Node.maxVersion + "-) ";
							

						Node.internalID = ++contextIDCounter + "_contextNode";
						if(Node == null) return;
						
						nodeType = Node.nodeType;
						nodeElementID = Node.elementID == null ? "MENUNODE_" + ++contextIDCounter : Node.elementID;
						
						if (nodeType == null) {
							nodeType = nodeElementID;
						}
						nodeType = nodeType.toUpperCase();
						if (nodeType == "LINE") {
							if(Node.elementValue != null && Node.elementValue != 'none')
								localMenuText += "<li class='contextBaseBreak' id='" + Node.internalID + "'><font class='contextBaseBreakText'>" + Node.elementValue + versionNote + "</font></li>";
							else
								localMenuText += "<li class='contextBaseBreakNoText id='" + Node.internalID + "'>&nbsp;</li>";
						}
						else if (nodeType == "BRANCH" || nodeType == "DELAYLOADBRANCH") {
							var internalNode = Node;
							if(nodeType == "BRANCH")
								internalNode = Node.elementSubNodes;
							var LocalAction = "";
							if(this.menuExpansionType)
							{
								LocalAction += " onMouseOver='";
								if (isEmbedded) {
									LocalAction += "if(activeContextWindow != null && !allContextWindows.get(\"" + Node.internalID + "\").windowIsVisible){";
								}
								LocalAction += "delayContextBaseOpen(\"" +Node.internalID + "\"";
								if (isEmbedded) {
									LocalAction += ", 0);";
								}
								else {
									LocalAction += ", 500);";
								}
								if (isEmbedded) {
									LocalAction += "}";
								}
								LocalAction += "' ";
							}
							LocalAction += " onmousedown='";
							if (isEmbedded && this.menuExpansionType) {
								LocalAction += "if(activeContextWindow == null){";
							}
							LocalAction += "allContextWindows.get(\"" +Node.internalID + "\").open();";
							if (isEmbedded && this.menuExpansionType) {
								LocalAction += "}else{closeOpenFloatingObject();}'";
							}
							else {
								LocalAction += "'";
							}
							var newContextMenuNode = new contextBase(this.elementUniqueID, Node.internalID, false, internalNode, VERTICAL, isRootNodes, verticalPosition, horizontalPosition, this.parentStageID, this.parentWindowID, this.parentPanelID, this.menuExpansionType, this.listStyleType);
							childNodes.set( Node.internalID, newContextMenuNode);
							
							localMenuText += "<li class='" + menuCSSClass + "' id='" + Node.internalID + "' valign='center'><a id='" + nodeElementID + "' " + LocalAction + " >" + Node.elementValue + versionNote + "</a></li>";
						}
						else if (nodeType == "LEAF") {
							var LocalAction = "";
							var elementAction = Node.elementAction;
							if (isEmbedded || !this.menuExpansionType) {
								LocalAction += " onMouseOver='if(activeContextWindow != null) {closeGivenContextNodeChild(\"" + elementParent + "\");}' ";
							}
							if (elementAction == "" || elementAction == null) {
								
								
								if(Node.elementActionScript != null)
								{										
									elementAction = 'onClick="runClientAction(\'' + Node.internalID + '\', allContextWindows.get(\'' + this.elementUniqueID + '\').baseNodes[' + i + '].elementActionScript, null, \'' +Node.internalID + '\', null, null, \'' + this.parentStageID + '\', \'' + this.parentWindowID + '\', \'' + this.parentPanelID + '\', null);"';
								}
								else if(Node.elementFloatingLink != null)
								{
									var DisplayPoint = "null";
									if(this.isEmbedded && this.isRootNode)
									{
										DisplayPoint = Node.internalID;
									}
									else
									{
										DisplayPoint = this.getRootNode();
									}
																				//myID,                            Type,                                  Data,                          parentTrigger,hideMenuBar,                          reloadOnConnectionChange,                          panelHeaders,                          baseWidth,                          baseHeight,                         loadContentOnShow,                          reloadContentOnShow
									var floatingPanelObject = new floatingPanel(Node.internalID + "_floatingPanel", Node.elementFloatingLink.ContentType, Node.elementFloatingLink.data, DisplayPoint, Node.elementFloatingLink.hideMenuBar, Node.elementFloatingLink.reloadOnConnectionChange, Node.elementFloatingLink.panelHeaders, Node.elementFloatingLink.baseWidth, Node.elementFloatingLink.baseHight, Node.elementFloatingLink.loadContentOnShow, Node.elementFloatingLink.reloadContentOnShow);
									getPanel(this.parentStageID,this.parentWindowID, this.parentPanelID).registerNestedObject(floatingPanelObject);
									floatingPanelObject.draw();
									
									elementAction = 'onClick="FLOATINGPANEL_activeFloatingPanels.get(\'' + Node.internalID + '_floatingPanel\').show_and_size(' + (DisplayPoint != null ? "'" + DisplayPoint + "'" : DisplayPoint) + ');"';
									
								}
								else if(Node.elementLinkList != null || Node.elementPageWindows != null)
								{
									elementAction = 'onClick="loadPage(allContextWindows.get(\'' + this.elementUniqueID + '\').baseNodes[' + i + '].elementPageWindows, allContextWindows.get(\'' + this.elementUniqueID + '\').baseNodes[' + i + '].elementLinkList);"';
								}
							}
							if (elementAction == "" || elementAction == null) {
								linkCSSClass = "contextBase";
								tag = "span";
								elementAction = "";
							}
							localMenuText += "<li onclick='closeContextMenu();' class='" + linkCSSClass + "' id='" +Node.internalID + "' valign='center'><" + tag + " id='" + nodeElementID + "' " + elementAction + LocalAction + " >" + Node.elementValue +versionNote + "</" + tag + "></li>";
						}
					}
				}
				buildTextForMenu += localMenuText;
				buildTextForMenu += "</ol>";
				if(!this.menuExpansionType && !isEmbedded) {
					buildTextForMenu += "</div>"
				} else if (isEmbedded) {
					buildTextForMenu += "</span>";
					$(this.elementParent).update(buildTextForMenu);
				} else {
					buildTextForMenu += "</div>";
				}
				this.menuText = buildTextForMenu;
				if (this.windowIsVisible == true) {
					this.close();
					this.open();
				}
			}
});

var menuPosition = {
	
	RT : function(sizingObject) {
		if(sizingObject.spButtonRight > sizingObject.containerWidth && (sizingObject.spButtonTop + sizingObject.buttonHeight) > sizingObject.containerHeight ) {
			sizingObject.WindowPositionTop = (sizingObject.spButtonTop + sizingObject.buttonHeight) - sizingObject.containerHeight;
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft + sizingObject.buttonWidth;
			return true;
		} else if(sizingObject.spButtonLeft > sizingObject.containerWidth && (sizingObject.spButtonTop + sizingObject.buttonHeight) > sizingObject.containerHeight ) {
			sizingObject.WindowPositionTop = (sizingObject.spButtonTop + sizingObject.buttonHeight) - sizingObject.containerHeight;
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft - sizingObject.containerWidth;
			return true;
		}
		return false;
	},
	RB : function(sizingObject) {
		if(sizingObject.spButtonRight > sizingObject.containerWidth && (sizingObject.spButtonBottom + sizingObject.buttonHeight) > sizingObject.containerHeight ) {
			sizingObject.WindowPositionTop = sizingObject.spButtonTop;
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft + sizingObject.buttonWidth;
			return true;
		} else if(sizingObject.spButtonLeft > sizingObject.containerWidth && (sizingObject.spButtonBottom + sizingObject.buttonHeight) > sizingObject.containerHeight ) {
			sizingObject.WindowPositionTop = sizingObject.spButtonTop;
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft - sizingObject.containerWidth;
			return true;
		}
		return false;
	},
	RC : function(sizingObject) {
		var containterHalfSize = (sizingObject.containerHeight/2) +1;
		var buttonHalfHight = (sizingObject.buttonHeight/2);
		if(sizingObject.spButtonRight > sizingObject.containerWidth) {
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft + sizingObject.buttonWidth;
		} else if(sizingObject.spButtonLeft > sizingObject.containerWidth) {
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft - sizingObject.containerWidth;
		}
		if(sizingObject.WindowPositionLeft != false) {
			if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop) && containterHalfSize < (buttonHalfHight + sizingObject.spButtonBottom)) {
				sizingObject.WindowPositionTop = (buttonHalfHight + sizingObject.spButtonTop) - containterHalfSize;
			} else if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop)) {
				sizingObject.WindowPositionTop = 0;
			} else {
				sizingObject.WindowPositionTop = sizingObject.windowHeight - sizingObject.containerHeight;
			}
			return true;	
		}
		return false;
	},
	RCI : function(sizingObject) {
		if( sizingObject.spButtonLeft > sizingObject.spButtonRight) {
			sizingObject.WindowPositionLeft = 0;
		} else {
			sizingObject.WindowPositionLeft = sizingObject.windowWindow - sizingObject.containerWidth;
		}
		if(sizingObject.WindowPositionLeft != false) {
			if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop) && containterHalfSize < (buttonHalfHight + sizingObject.spButtonBottom)) {
				sizingObject.WindowPositionTop = (buttonHalfHight + sizingObject.spButtonTop) - containterHalfSize;
			} else if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop)) {
				sizingObject.WindowPositionTop = 0;
			} else {
				sizingObject.WindowPositionTop = sizingObject.windowHeight - sizingObject.containerHeight;
			}
			return true;	
		}
		return false;
	},
	LT : function(sizingObject) {
		if(sizingObject.spButtonTop > sizingObject.containerHeight) {
			var containterHalfSize = (sizingObject.containerWidth/2) +1;
			var buttonHalfWidth = (sizingObject.buttonWidth/2);
			sizingObject.WindowPositionTop = sizingObject.spButtonTop - sizingObject.containerHeight;
			if((sizingObject.spButtonRight + sizingObject.buttonWidth) > sizingObject.containerWidth) {
				sizingObject.WindowPositionLeft = sizingObject.spButtonLeft;
			} else if((sizingObject.spButtonLeft + sizingObject.buttonWidth) > sizingObject.containerWidth) {
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + sizingObject.buttonWidth) - sizingObject.containerWidth;
			} else if((sizingObject.spButtonLeft + buttonHalfWidth) > containterHalfSize && (sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) { 
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + buttonHalfWidth) - containterHalfSize;
			} else if((sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) {
				sizingObject.WindowPositionLeft = sizingObject.windowWidth - sizingObject.containerWidth;
			} else {
				sizingObject.WindowPositionLeft = 0;
			}
			return true;
		}
		return false;
	},
	LB : function(sizingObject) {
		var containterHalfSize = (sizingObject.containerWidth/2) +1;
		var buttonHalfWidth = (sizingObject.buttonWidth/2);
		if(sizingObject.spButtonBottom > sizingObject.containerHeight) {
			sizingObject.WindowPositionTop = sizingObject.spButtonTop + sizingObject.buttonHeight;
			if((sizingObject.spButtonRight + sizingObject.buttonWidth) > sizingObject.containerWidth) {
				sizingObject.WindowPositionLeft = sizingObject.spButtonLeft;
			} else if((sizingObject.spButtonLeft + sizingObject.buttonWidth) > sizingObject.containerWidth) {
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + sizingObject.buttonWidth) - sizingObject.containerWidth;
			} else if((sizingObject.spButtonLeft + buttonHalfWidth) > containterHalfSize && (sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) { 
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + buttonHalfWidth) - containterHalfSize;
			} else if((sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) {
				sizingObject.WindowPositionLeft = sizingObject.windowWidth - sizingObject.containerWidth;
			} else {
				sizingObject.WindowPositionLeft = 0;
			}
			return true;
		}
		return false;
	},
	LC : function(sizingObject) {
		var containterHalfSize = (sizingObject.containerHeight/2) +1;
		var buttonHalfHight = (sizingObject.buttonHeight/2);
		if(sizingObject.spButtonRight > sizingObject.containerWidth) {
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft - sizingObject.containerWidth;
		} else if(sizingObject.spButtonLeft > sizingObject.containerWidth) {
			sizingObject.WindowPositionLeft = sizingObject.spButtonLeft + sizingObject.buttonWidth;
		}
		if(sizingObject.WindowPositionLeft != false) {
			if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop) && containterHalfSize < (buttonHalfHight + sizingObject.spButtonBottom)) {
				sizingObject.WindowPositionTop = (buttonHalfHight + sizingObject.spButtonTop) - containterHalfSize;
			} else if(containterHalfSize < (buttonHalfHight + sizingObject.spButtonTop)) {
				sizingObject.WindowPositionTop = 0;
			} else {
				sizingObject.WindowPositionTop = sizingObject.windowHeight - sizingObject.containerHeight;
			}
			return true;	
		}
		return false;
	},
	CT : function(sizingObject) {
		if(sizingObject.spButtonTop > sizingObject.containerHeight) {
			var containterHalfSize = (sizingObject.containerWidth/2) +1;
			var buttonHalfWidth = (sizingObject.buttonWidth/2);
			sizingObject.WindowPositionTop = sizingObject.spButtonTop - sizingObject.containerHeight;
			if((sizingObject.spButtonLeft + buttonHalfWidth) > containterHalfSize && (sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) { 
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + buttonHalfWidth) - containterHalfSize;
			} else if((sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) {
				sizingObject.WindowPositionLeft = sizingObject.windowWidth - sizingObject.containerWidth;
			} else {
				sizingObject.WindowPositionLeft = 0;
			}
			return true;
		}
		return false;
	},
	CB : function(sizingObject) {
		var containterHalfSize = (sizingObject.containerWidth/2) +1;
		var buttonHalfWidth = (sizingObject.buttonWidth/2);
		if(sizingObject.spButtonBottom > sizingObject.containerHeight) {
			sizingObject.WindowPositionTop = sizingObject.spButtonTop + sizingObject.buttonHeight;
			if((sizingObject.spButtonLeft + buttonHalfWidth) > containterHalfSize && (sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) { 
				sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + buttonHalfWidth) - containterHalfSize;
			} else if((sizingObject.spButtonRight + buttonHalfWidth) > containterHalfSize) {
				sizingObject.WindowPositionLeft = sizingObject.windowWidth - sizingObject.containerWidth;
			} else {
				sizingObject.WindowPositionLeft = 0;
			}
			return true;
		}
		return false;	
	},
	CC : function(sizingObject) {
		
		var containterHalfHight = (sizingObject.containerHeight/2) +1;
		var buttonHalfHight = (sizingObject.buttonHeight/2);
		var containterHalfWidth = (sizingObject.containerWidth/2) +1;
		var buttonHalfWidth = (sizingObject.buttonWidth/2);

		if(containterHalfHight < (buttonHalfHight + sizingObject.spButtonTop) && containterHalfHight < (buttonHalfHight + sizingObject.spButtonBottom)) {
			sizingObject.WindowPositionTop = (buttonHalfHight + sizingObject.spButtonTop) - containterHalfHight;
		} else if(containterHalfHight < (buttonHalfHight + sizingObject.spButtonTop)) {
			sizingObject.WindowPositionTop = 0;
		} else {
			sizingObject.WindowPositionTop = sizingObject.windowHeight - sizingObject.containerHeight;
		}
		
		if((sizingObject.spButtonLeft + buttonHalfWidth) > containterHalfWidth && (sizingObject.spButtonRight + buttonHalfWidth) > containterHalfWidth) { 
			sizingObject.WindowPositionLeft = (sizingObject.spButtonLeft + buttonHalfWidth) - containterHalfWidth;
		} else if((sizingObject.spButtonRight + buttonHalfWidth) > containterHalfWidth) {
			sizingObject.WindowPositionLeft = sizingObject.windowWidth - sizingObject.containerWidth;
		} else {
			sizingObject.WindowPositionLeft = 0;
		}
		return false;	
	}	
};