/*******************************************************************************
*Copyright IBM Corp. 2007 All rights reserved.
*
*Licensed under the Apache License, Version 2.0 (the "License");
*you may not use this file except in compliance with the License.
*You may obtain a copy of the License at
*
*	http://www.apache.org/licenses/LICENSE-2.0
*
*Unless required by applicable law or agreed to in writing, software
*distributed under the License is distributed on an "AS IS" BASIS,
*WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*See the License for the specific language governing permissions and
*limitations under the License.
*********************************************************************************/
var panel = Class.create(basePageElement, {
	initialize: function($super, myID, dealyLoad, panelTitle, PrimaryContainer, Type, Data, overflow, panelHeaders, POSTDATA) {
		$super(myID, "PANEL");
		PrimaryContainer = PrimaryContainer == null ? false : PrimaryContainer;
		PrimaryContainer = Object.isString(PrimaryContainer) ? (PrimaryContainer.toLowerCase() == "true" ? true : false) : PrimaryContainer;
		this.PrimaryContainer = PrimaryContainer === true ? true : false;
		this.TYPE = Type.toUpperCase();
		this.DATA = Data == null ? "" : Data;
		this.URL = null;
		this.overflow = overflow == null ? "auto" : overflow;
		this.IsFirstLoad = true;
		this.panelTitle = panelTitle == null ? null : decodeURIComponent(panelTitle);
		this.rawTitleBarLayout = "";
		this.panelInformation = null;
		this.POSTDATA = POSTDATA == null ? new Object() : POSTDATA;
		this.nestedObject = $H();
		this.pageHeaders = panelHeaders == null ? null : panelHeaders;
		this.reloadScope = panelHeaders != null ? (panelHeaders.scope != "" ? panelHeaders.scope.toLowerCase() : "inherit") : "inherit";
		this.refreshTimeOut = -1;
		this.refreshType = "silentReload";
		this.refreshCallback = null;
		this.refreshCallBackTimer = null;
		this.dealyLoad = dealyLoad == null ? false : dealyLoad;
		this.localPanelConstants = $H();
		this.localLayoutContainer = null;
		this.pageState = new Object();
	},
	registerNestedObject: function(ID, Object) {
		if(Object == null)
		{
			Object = ID;
			ID = Object.elementName;
		}
		if(Object != null)
		{
			this.nestedObject.set(ID, Object);
			Object.parentWindowID = this.parentWindowID;
			Object.parentStageID = this.parentStageID;
			if(Object.elementType != null)
			{
				var window = getWindow(this.parentStageID, this.parentWindowID);
				if(window != null)
					window.addWindowContainer(Object.elementName, Object);
			}
		}
	},
	setContainer: function(container, otherInfo) {
		this.registerNestedObject(container.elementName, container);
		this.localLayoutContainer = container;
	},
	load: function(Type, Data, panelHeader, POSTDATA, pageState) {
		this.pageState = pageState == null ? new Object() : pageState
		this.panelHeader = panelHeader;
		this.POSTDATA = POSTDATA == null ? new Object() : POSTDATA;
		
		if (this.refreshCallBackTimer != null)
			clearTimeout(this.refreshCallBackTimer);
		this.refreshTimeOut = -1;
		this.refreshType = "silentReload";
		this.refreshCallback = null;
		this.refreshCallBackTimer = null;
		
		this.TYPE = Type.toUpperCase();
		this.DATA = Data;
		this.IsFirstLoad = true;
		this.fullReloadOfPage();
	},
	loadURL: function() {
		var parentWindow = getWindow(this.parentStageID, this.parentWindowID);
		if (parentWindow != null) {
			if (parentWindow.WindowContainers.get(this.elementName) != null) {
				parentWindow.forwardURLHist = new Array();
				parentWindow.forwardURLHist.push(new Array(getWindow(this.parentStageID, this.parentWindowID).WindowConfiguration, new Array(new Array(this.elementName, "URL", escape($("URL_" + this.elementUniqueID).value)))));
				parentWindow.historyGoForward();
			}
		}
	},
	
	reloadPage: function(refresh) {
		if (this.refreshType.toLowerCase() == "reload" || this.refreshType.toLowerCase() == "silentreload") {
			this.fullReloadOfPage(refresh);
		}
		else if (this.refreshType.toLowerCase() == "table") {
			updateFunction(this.URL, this.parentStageID, this.parentWindowID, this.elementName, this.elementUniqueID);
		}
		else if (this.refreshType.toLowerCase() == "callback") {
			eval(this.refreshCallback);
		}
		else
		{
			this.fullReloadOfPage(refresh);
		}
	},
	
	fullReloadOfPage: function(refresh) {
		if (this.dealyLoad == true) {
			this.dealyLoad = false;
			this.setContent("<table width='100%' height='100%'cellspacing='0' cellpadding='0' align='center' valign='center'><tr><td align='center'><button onclick='getPanel(\"" + this.parentStageID + "\",\"" + this.parentWindowID + "\",\"" + this.elementName + "\").fullReloadOfPage()'>Load Page</button></td></tr></table>", null);
			return;
		}
		if (this.refreshCallBackTimer != null)
			clearTimeout(this.refreshCallBackTimer);
		this.refreshCallBackTimer = null;
		var thisObject = this;
		var POSTDATA = this.POSTDATA;
		POSTDATA.USE_CONNECTION = null;
		var URL = this.DATA;
		var TYPE = this.TYPE;
		var myID = this.elementName;
		var parentWindowID = this.parentWindowID;
		var parentStageID = this.parentStageID;
		var elementUniqueID = this.elementUniqueID;
		var PrimaryContainer = this.PrimaryContainer == null ? true : this.PrimaryContainer;
		var i = 0;
		var parentWindow = getWindow(this.parentStageID, this.parentWindowID);
		
		if(this.localLayoutContainer != null)
		{
			parentWindow.WindowContainers.unset(this.localLayoutContainer.elementName);
			this.localLayoutContainer.destroy();
		}
		
		this.nestedObject.each(function(pair) {
			if (pair.value != null)
			{
				if(pair.value.elementType != null && parentWindow != null)
					parentWindow.WindowContainers.unset(pair.value.elementName);
				pair.value.destroy();
			}
		});
		
		this.nestedObject = $H();
		if (URL == "" || URL == null) {
			this.setContent("", null);
			return;
		}
		
		if (TYPE.toUpperCase() == "URL" || TYPE.toUpperCase() == "LINK") {
			
			if (this.TYPE.toUpperCase() == "LINK") {
				var link = {};
				if (Object.isString(this.DATA)) {
					link = eval("(" + this.DATA + ")");
				}
				else {
					link = this.DATA;
				}
				
				
				TYPE = link.type.toUpperCase();
				URL = link.data;
				if (link.formList != null && this.IsFirstLoad) {
					this.IsFirstLoad = false;
					for (i = 0; i < link.formList.length; i++) {
						if ($(link.formList[i]) != null) {
							var param = $(link.formList[i]).serialize(true);
							var keys = Object.keys(param);
							keys.each(function(key) {
								POSTDATA[key] = param[key];
							});
						}
					}
				}
				if(!Object.isString(URL))
				{
					var LinkData = URL;
					URL = "";
					if(LinkData.baseDirectory != null)
					{
						URL = LinkData.baseDirectory;
					}
					if(LinkData.address == null)
					{
						TYPE = "action";
						URL = ACTION_PROCESSOR;
					}
					else
					{
						URL += LinkData.address;
					}
					
					var keys = Object.keys(LinkData.parameters);
					keys.each(function(key) {
						POSTDATA[key] = LinkData.parameters[key];
					});
					
				}
			}


			if ($("URL_" + this.elementUniqueID) != null) {
				$("URL_" + this.elementUniqueID).value = URL;
			}
			
			if (URL.substring(0, 7).toUpperCase() == 'FILE://' || URL.substring(0, 8).toUpperCase() == 'HTTPS://' || URL.substring(0, 7).toUpperCase() == 'HTTP://' || URL.substring(0, 6).toUpperCase() == 'FTP://') {
					getWindow(parentStageID, parentWindowID).setLoading(myID);
					URL = encodeURIandNormaMessage(URL);
					thisObject.setContent('<iframe name="' + this.elementUniqueID + '_Object_To_Fit_To_Panel" id="' + this.elementUniqueID + '_Object_To_Fit_To_Panel" onunload="getWindow(\'' + parentStageID + '\', \'' + parentWindowID + '\').setLoading(\'' + myID + '\');" onLoad="getWindow(\'' + parentStageID + '\', \'' + parentWindowID + '\').setDoneLoading(\'' + myID + '\');" src="' + URL + '" frameborder="0" style="position:absolute;z-index:10;height:100%;width:100%;"></iframe><div id="title">External Information</div>', 'Web page', "", "hidden");
			}
			else {
				POSTDATA.primaryContainer = this.PrimaryContainer;
				POSTDATA.uniqueID = this.elementUniqueID;
				POSTDATA.stageID = this.parentStageID;
				POSTDATA.windowID = this.parentWindowID;
				POSTDATA.panelID = this.elementName;
				
				
				if(POSTDATA.USE_CONNECTION == null)
				{
					if(POSTDATA.useConnectWithTag != null)
					{
						POSTDATA.USE_CONNECTION = getConnectionWithTag(POSTDATA.useConnectWithTag);
					}
					if(POSTDATA.USE_CONNECTION == null)
					{
						POSTDATA.USE_CONNECTION = ACTIVE_DATABASE_CONNECTION;
					}
				}
				
				var ClientActionFound = false;
				if (this.pageHeaders != null) {
					POSTDATA.refreshEnabled = this.pageHeaders.refreshEnabled;
				}
				else {
					POSTDATA.refreshEnabled = "false";
				}
				if(TYPE.toUpperCase() == "ACTION")
				{
					var action = CORE_CLIENT_ACTIONS.get(POSTDATA.action);
					if(action != null)
					{
						ClientActionFound = true;
						new action(POSTDATA)
					}
				}
				
			 	if(!ClientActionFound)
				{
					var loadIconSize = (this.width < 50 || this.height < 50) ? "_small" : "";
					this.URL = URL;
					new Ajax.Request(URL, {
						'parameters': POSTDATA,
						'method': 'post',
						'onCreate': function() {
							var window = getWindow(parentStageID, parentWindowID);
							if (window != null && (thisObject.refreshType.toLowerCase() == "reload"))
								window.setLoading(myID);
							if (!refresh || (thisObject.refreshType.toLowerCase() == "reload"))
								thisObject.setContent("<table id='" + elementUniqueID + "_Object_To_Fit_To_Panel' style='width:" + thisObject.width + "px;height:" + thisObject.height + "px;position:static;'cellspacing='0' cellpadding='0' align='center' valign='center'><tr><td align='center'><img style='float:none;' src='images/loadingpage" + loadIconSize + ".gif'/></td></tr></table>", null, "", "hidden");
						},
						'onSuccess': function(transport) {
							var window = getWindow(parentStageID, parentWindowID);
							if (window != null)
								window.setDoneLoading(myID);
							thisObject.setContent(transport.responseText, null);
							thisObject.setReload();
						},
						'onFailure': function(transport) {
							var window = getWindow(parentStageID, parentWindowID);
							if (window != null)
								window.setDoneLoading(myID);
							thisObject.setContent(transport.responseText, "Error Loading Page");
						},
						'onException': function(transport,exception)
						{
							alert(exception);
							return;
						}
					});
				}
			}
		}
		else if (TYPE == "RAW") {
			this.setContent(URL, null);
		}
		else if (TYPE == "LAYOUT") {
			var baseObject = setupContainer(this, this.DATA, null);
			$(elementUniqueID).setStyle({ "overflow": "hidden" });
			this.setContent(baseObject.draw(), null, null, "hidden");
			baseObject.setWidth(this.width);
			baseObject.setHeight(this.height);
			baseObject.fullReloadOfPage();
		}
		else {
			this.setContent("", null);
		}
		if (POSTDATA["DO_NOT_SAVE_LOCAL_POSTDATA"] == "true")
			this.POSTDATA = new Object();
	},
	loadLayout: function(layout) {
		var baseObject = setupContainer(this, layout, null);
		if ($(this.elementUniqueID) != null)
			$(this.elementUniqueID).setStyle({ "overflow": "hidden" });
		this.setContent(baseObject.draw(), null, null, "hidden");
		baseObject.reloadPage();
		baseObject.setWidth(this.width);
		baseObject.setHeight(this.height);
	},
	setOverflow: function(overflowValue) {
		$(this.elementUniqueID).setStyle({ 'overflow': overflowValue });
	},
	setContent: function(Content, Title, PanelInformation, overflow, LeftMenu) {
		this.clearPanel();
		this.hideAddressBar();
		var contentHolder = $(this.elementUniqueID)
		overflow = overflow == null ? this.overflow : overflow;
		if (contentHolder != null) {
			contentHolder.setStyle({ "overflow": overflow });
			if (Content != null && contentHolder != null) {
				contentHolder.update(Content);
			}
		}
		if (Title == null && contentHolder != null) {
			try
			{
				var theDataObjectChildren = contentHolder.select('div[id="title"]');
				if (theDataObjectChildren.size() > 0) {
					Title = theDataObjectChildren[0].innerHTML;
				}
			}
			catch(e)
			{
				if(ENABLE_VERBOSE)
					alert(e);
			}
		}		
		if (Title == null)
			Title = this.panelTitle;
		if (Title == null)
			Title = "";
		//CHROME FIX: This try/catch is to get the YUI package working in the tutorial framework.
		try
		{
			Title = Title.replace(/ /g, '&nbsp;');		
			if (PanelInformation == null && contentHolder != null) {
				var theDataObjectChildren = contentHolder.select("div[id='panelInformation']");
				if (theDataObjectChildren.size() > 0) {				
					PanelInformation = theDataObjectChildren[0].innerHTML;				
				}
			}
			if (PanelInformation == null)
				PanelInformation = this.panelInformation;
			if (PanelInformation == null)
				PanelInformation = "";
	
			if (LeftMenu == null && contentHolder != null) {
				var theDataObjectChildren = contentHolder.select("div[id='pageLeftMenu']");
				if (theDataObjectChildren.size() > 0) {
					LeftMenu = theDataObjectChildren[0].innerHTML;
				}
			}
		} 
		catch (e)
		{
			if(ENABLE_VERBOSE)
				alert(e);
		}

		if (this.PrimaryContainer) {
			var window = getWindow(this.parentStageID, this.parentWindowID);
			if (window != null)
			{
				window.PrimaryContainerName = this.elementName;
				if(window.windowOptionType != NO_TITLE_BAR_OPTIONS && window.windowOptionType != TAB_PERSISTENCE_FLAG)
				{
					window.setWindowTitle(Title, LeftMenu, PanelInformation);
				}
				else
				{
					window.setWindowTitle(Title);
					if((LeftMenu != "" && LeftMenu != null) || (PanelInformation != "" && PanelInformation != null))
						this.setWindowTitle(Title, LeftMenu, PanelInformation);
				}
			}
			else
			{
				this.setWindowTitle(Title, LeftMenu, PanelInformation);
			}
		}
		else 
		{
			this.setWindowTitle(Title, LeftMenu, PanelInformation);
		}
		this.showAddressBar();
		this.setHeight(this.height);
		changeWorkArea();
	},
	setReload: function() {
		if (this.refreshCallBackTimer != null)
			clearTimeout(this.refreshCallBackTimer);
		this.refreshCallBackTimer = null;
		
		if(!ACTIVE_DATABASE_CONNECTION_AUTHENTICATED )
		{
			this.refreshCallBackTimer = setTimeout("getPanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "').setReload()", this.refreshTimeOut * 1000);
		}
		else if (this.pageHeaders != null) {
			if (this.pageHeaders.refreshEnabled && this.refreshTimeOut != -1) {
				this.refreshCallBackTimer = setTimeout("getPanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "').doReload()", this.refreshTimeOut * 1000);
			}
		}
	},
	autoReloadUpdate: function() {
		if (this.pageHeaders != null) {
			if (this.pageHeaders.refreshEnabled && this.reloadScope == "inherit") {
				this.refreshTimeOut = getWindow(this.parentStageID, this.parentWindowID).refreshTimeOut;
				if (this.refreshCallBackTimer != null) {
					clearTimeout(this.refreshCallBackTimer);
				}
				
				if(!ACTIVE_DATABASE_CONNECTION_AUTHENTICATED) 
				{
					this.refreshCallBackTimer = setTimeout("getPanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "').setReload()", this.refreshTimeOut * 1000);
				} 
				else if (this.refreshTimeOut != -1) 
				{
					this.refreshCallBackTimer = setTimeout("getPanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "').doReload()", this.refreshTimeOut * 1000);
				}
			}
		}
	},
	updateReloadTime: function(reloadTime) {
		this.refreshTimeOut = reloadTime;
		this.setReload();
	},
	doReload: function() {
		if (this.refreshCallBackTimer != null)
			clearTimeout(this.refreshCallBackTimer);
		this.refreshCallBackTimer = null;
		if (this.refreshType.toLowerCase() == "reload" || this.refreshType.toLowerCase() == "silentreload") {
			this.fullReloadOfPage(true);
		}
		else if (this.refreshType.toLowerCase() == "table") {
			updateFunction(this.URL, this.parentStageID, this.parentWindowID, this.elementName, this.elementUniqueID);
			this.setReload();
		}
		else if (this.refreshType.toLowerCase() == "callback") {
			eval(this.refreshCallback);
			this.setReload();
		}
	},
	clearPanel: function() {
		var panelContent = $(this.elementUniqueID);
		var addyTitleBar = $("AddyBar_" + this.elementUniqueID);
		if (panelContent != null) {
			panelContent.update("");
		}
		if (addyTitleBar != null) {
			addyTitleBar.update(this.rawTitleBarLayout);
		}
	},
	setWindowTitle: function(newTitle, leftMenu, PanelInformation) {
		//"AddyBar_" + this.elementUniqueID
		var panelTitle = $("panelTitle_" + this.elementUniqueID);
		var panelMenu = $("panelMenuRight_" + this.elementUniqueID);
		if (PanelInformation == null)
			PanelInformation = "";
		if (panelTitle != null) {
			if (PanelInformation != "") {
				newTitle = "<table><tr><td>" + newTitle + "</td><td><img style='float:none' id='{$pageID}_PageInformationButton' onMouseUp=\"stopPropagation(event);\" onMouseDown='show_GENERAL_BLANK_POPUP(null, decodeURIComponent(\"<div style=\\\"padding:10px;width:350px\\\">" + escape(PanelInformation) + "</div>\"));' src=\"images/info.gif\"/></td></tr></table>";
			}
			panelTitle.update(newTitle);
		}
		if (panelMenu != null && leftMenu != null) {
			if(Object.isArray(leftMenu))
			{
				createContextMenu("panelMenuRight_" + this.elementUniqueID, leftMenu , HORIZONTAL, this.parentStageID, this.parentWindowID, this.elementName);
			}
			else
			{
				panelMenu.update(leftMenu);
			}
		}
	},
	sizeWidth: function(Amount) {
		var frame = $(this.elementUniqueID);
		var iframe = $(this.elementUniqueID + '_Object_To_Fit_To_Panel');
		var minWidth = 0;
		this.width += Amount;
		this.width = ((this.width > minWidth) ? this.width : minWidth);
		if (frame != null) {
			frame.setStyle({ "width": this.width + "px" });
		}
		if (iframe != null) {
			iframe.setStyle({ "width": this.width + "px" });
		}
		this.nestedObject.each(function(aObject) {
			aObject.value.sizeWidth(Amount);
		});
		return this.width;
	},
	sizeHeight: function(Amount) {
		var frame = $(this.elementUniqueID);
		var iframe = $(this.elementUniqueID + '_Object_To_Fit_To_Panel');
		var offsetHeight = 0;
		var addyBar = $("AddyBar_" + this.elementUniqueID);
		if (addyBar != null) {
				offsetHeight = addyBar.getHeight() + 1;
		}
		this.height += Amount;
		this.height = ((this.height > offsetHeight) ? this.height : offsetHeight);
		if (frame != null) {
			frame.setStyle({ "height": (this.height - offsetHeight) + "px" });
		}
		if (iframe != null) {
			iframe.setStyle({ "height": (this.height - offsetHeight) + "px" });
		}
		this.nestedObject.each(function(aObject) {
			aObject.value.sizeHeight(Amount);
		});
		return this.height;
	},
	setWidth: function(Amount) {
		var frame = $(this.elementUniqueID);
		this.width = Amount;
		this.width = ((this.width > 0) ? this.width : 0);
		if (frame != null) {
			frame.setStyle({ "width": this.width + "px" });
		}
		else
		{
			var iframe = $(this.elementUniqueID + '_Object_To_Fit_To_Panel');
			if (iframe != null) {
				iframe.setStyle({ "width": this.width + "px" });
			}
		}
		this.nestedObject.each(function(aObject) {
			aObject.value.setWidth(Amount);
		});
		return this.width;
	},
	setHeight: function(Amount) {
		var frame = $(this.elementUniqueID);
		var offsetHeight = 0;
		var addyBar = $("AddyBarTable_" + this.elementUniqueID);
		if (addyBar != null) {
			 offsetHeight = addyBar.getHeight() + 1;
		}
		this.height = Amount;
		this.height = ((this.height > offsetHeight) ? this.height : offsetHeight);
		if (frame != null) {
			frame.setStyle({ "height": (this.height - offsetHeight) + "px" });
		}
		else
		{
			var iframe = $(this.elementUniqueID + '_Object_To_Fit_To_Panel');
			if (iframe != null) {
				iframe.setStyle({ "height": (this.height - offsetHeight) + "px" });
			}
		}
		Amount = this.height - offsetHeight;
		this.nestedObject.each(function(aObject) {
			aObject.value.setHeight(Amount);
		});
		return this.height;
	},
	show_hide_contents: function() {
		BarItemClick(this.parentStageID, this.parentWindowID + "_" + this.elementName);
	},
	moveLeft: function(Amount) {
		this.nestedObject.each(function(aObject) {
			aObject.value.moveLeft(Amount);
		});
	},
	moveTop: function(Amount) {
		this.nestedObject.each(function(aObject) {
			aObject.value.moveTop(Amount);
		});
	},
	destroy: function() {
		var test = this.nestedObject.toArray();
		var parentWindow = getWindow(this.parentStageID, this.parentWindowID);
		if(this.localLayoutContainer != null)
		{
			parentWindow.WindowContainers.unset(this.localLayoutContainer.elementName);
			this.localLayoutContainer.destroy();
		}
		this.nestedObject.each(function(pair) {
			if (pair.value != null)
			{
				if(pair.value.elementType != null && parentWindow != null)
					parentWindow.WindowContainers.unset(pair.value.elementName);
				pair.value.destroy();
			}
		});
		this.nestedObject = $H();
		var addybar = $("AddyBar_" + this.elementUniqueID);
		var rootnode = $(this.elementUniqueID);
		if(addybar != null)
			addybar.remove();
		if(rootnode != null)
			rootnode.remove();
	},
	hideAddressBar: function() {
		var addybar = $("AddyBar_" + this.elementUniqueID);
		if (addybar != null)
			addybar.hide();
	},
	showAddressBar: function() {
		var addybar = $("AddyBar_" + this.elementUniqueID);
		if (addybar != null)
			addybar.show();
	},
	draw: function() {
		this.elementUniqueID = this.parentStageID + "_" + this.parentWindowID + "_" + this.elementName;
		output = "";
		output += "<div id=\"AddyBar_" + this.elementUniqueID + "\" onmouseover=\"setActivePanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "');\" onMouseDown=\"RaiseToTop('" + this.parentStageID + "','" + this.parentWindowID + "')\" class='panelTitleBar' style=\"display:none;width:100%;\" >\n";
		this.rawTitleBarLayout = "<table id=\"AddyBarTable_" + this.elementUniqueID + "\" cellpadding=\"0\" cellspacing=\"0\" style=\"height:0px;width:100%;min-height:0px;max-height:0px;\">\n";
		this.rawTitleBarLayout += "<tr style=\"height:0px;width:100%;min-height:0px;max-height:0px;\"><td align=leftstyle='width:0px;min-height:0px;max-height:0px;' id='panelMenuLeft_" + this.elementUniqueID + "'>\n";
		this.rawTitleBarLayout += "</td><td style='width:100%;padding-left:10px;min-height:0px;max-height:0px;'><NOBR id='panelTitle_" + this.elementUniqueID + "'>";
		this.rawTitleBarLayout += "</NOBR></td><td align=right style='width:0px;min-height:0px;max-height:0px;' id='panelMenuRight_" + this.elementUniqueID + "'>";
		this.rawTitleBarLayout += "</td><td align=right style='width:0px;min-height:0px;max-height:0px;' class='pageWindowPageMenu' id='timingMenu_" + this.elementUniqueID + "'>";
		if (this.pageHeaders != null && this.reloadScope != "inherit") {
			if (this.pageHeaders.refreshEnabled) {
				this.refreshTimeOut = -1;
				var timeVisible = true;
				var timeOptions = [1, 5, 15, 30, 60, 120, 300, 600];
				var countdownVisible = true;
				var displayTimeInfo = "";
				if (this.pageHeaders.autoRefreshControls != null) {
					if (this.pageHeaders.autoRefreshControls.time != null && this.pageHeaders.autoRefreshControls.time != "")
						this.refreshTimeOut = this.pageHeaders.autoRefreshControls.time;
					if (this.pageHeaders.autoRefreshControls.timeVisible != null && this.pageHeaders.autoRefreshControls.timeVisible != "")
						timeVisible = this.pageHeaders.autoRefreshControls.timeVisible;
					if (this.pageHeaders.autoRefreshControls.timeOptions != null && this.pageHeaders.autoRefreshControls.timeOptions != "")
						timeOptions = this.pageHeaders.autoRefreshControls.timeOptions;
					if (this.pageHeaders.autoRefreshControls.countdownVisible != null && this.pageHeaders.autoRefreshControls.countdownVisible != "")
						countdownVisible = this.pageHeaders.autoRefreshControls.countdownVisible;
				}
				timeOptions.unshift(-1);
				if (this.pageHeaders.showRefreshControl == true || timeVisible) {
					displayTimeInfo += "<table cellpadding='0' cellspacing='0'><tr>";
					if (timeVisible) {
						displayTimeInfo += "<td><nobr>&nbsp;&nbsp;Refresh Time</nobr></td><td><select onchange='getPanel(\"" + this.parentStageID + "\",\"" + this.parentWindowID + "\",\"" + this.elementName + "\").updateReloadTime(this.value);'>";
						var timeOptionLength = timeOptions.length;
						for (i = 0; i < timeOptionLength; i++) {
							displayTimeInfo += "<option value='" + timeOptions[i] + "' ";
							if (timeOptions[i] == this.refreshTimeOut) {
								displayTimeInfo += "selected";
								this.updateReloadTime(timeOptions[i]);
							}
							displayTimeInfo += ">";
							if (timeOptions[i] != -1) {
								var timeInMin = Math.floor(timeOptions[i] / 60);
								if (timeInMin != 0)
									displayTimeInfo += timeInMin + "m ";
								displayTimeInfo += (timeOptions[i] % 60) + "s";
							}
							else {
								displayTimeInfo += "Off";
							}
							displayTimeInfo += "</option>";
						}
						displayTimeInfo += "</select></td>";
					}
					if (this.pageHeaders.showRefreshControl == true) {
						displayTimeInfo += "<td><button onclick='getPanel(\"" + this.parentStageID + "\",\"" + this.parentWindowID + "\",\"" + this.elementName + "\").doReload()'>Refresh</button></td>";
					}
					displayTimeInfo += "</tr></table>";
				}

				var window = getWindow(this.parentStageID, this.parentWindowID);
				if (window != null)
				{
					if (this.PrimaryContainer && window.windowOptionType != NO_NAV_BAR) {
						if (getWindow(this.parentStageID, this.parentWindowID).pageHeaders == null) {
							$('rightInformationMenu_' + getWindow(this.parentStageID, this.parentWindowID).elementUniqueID).update(displayTimeInfo);
						}
						else {
							this.reloadScope = "inherit";
						}
					}
					else {
						this.rawTitleBarLayout += displayTimeInfo;
					}
				}
				else {
					this.rawTitleBarLayout += displayTimeInfo;
				}
				this.autoReloadUpdate();
			}
		}
		this.rawTitleBarLayout += "</td></tr>\n";
		this.rawTitleBarLayout += "</table>\n";
		output += this.rawTitleBarLayout;
		output += "</div>\n";
		output += "<div class=\"panel\" id=\"" + this.elementUniqueID + "\" onmouseover=\"setActivePanel('" + this.parentStageID + "','" + this.parentWindowID + "','" + this.elementName + "');\" onMouseDown=\"RaiseToTop('" + this.parentStageID + "','" + this.parentWindowID + "')\" style=\"position:relative;width:" + this.width + "px; height:" + this.height + "px;overflow:" + this.overflow + ";\" >";
		if (this.TYPE == "RAW") {
			output += this.DATA;
		}
		output += "</div>\n";
		return output;
	}
});
