/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/

var STAGE_activeStages = $H();


var embeddedStage = Class.create(basePageElement, {
	initialize: function($super, myID, taskBarStyle, fromTop, fromBotton, fromLeft, fromRight, titleBarType, windowOptionType, windowControlTypes, sizable) {
		$super(myID, "STAGE");
		this.positionType = "static";
		STAGE_activeStages.set(myID, this);
		this.taskBarStyle = Object.isString(taskBarStyle) ? eval(taskBarStyle) :taskBarStyle;
		this.fromTop = fromTop;
		this.fromBotton = fromBotton;
		this.fromLeft = fromLeft;
		this.fromRight = fromRight;
		this.EndScroll = true;
		this.scrollAcceleration = 0;
	 /* Window Title Types
	 * 0 - no title bar
	 * 1 - Window Controls outside of title
	 * 2 - Window Controls inside of title
	 *****************/
	this.titleBarType = Object.isString(titleBarType) ? eval(titleBarType) : titleBarType;
	/* Window Navigation Types (Add the numbers to get all the controls you want)
	 * 0 - no Navigation bar
	 * 1 - back button
	 * 2 - forward button
	 * 4 - reload
	 * 8 - address bar
	 *****************/
	this.windowOptionType = Object.isString(windowOptionType) ? eval(windowOptionType) : windowOptionType;
	/* Window Control Types (Add the numbers to get all the controls you want)
	 * 1 - Question Menu // not avalible at this time
	 * 2 - Minimize
	 * 4 - Hide
	 * 8 - Close
	 *****************/
	this.windowControlTypes = Object.isString(windowControlTypes) ? eval(windowControlTypes) : windowControlTypes;
	/* Window Sizing Options
	 * 1 - Window IS Sizable
	 * 2 - Window IS Fixed
	 * 3 - Window Clings To It Container
	 *****************/
	this.sizable = Object.isString(sizable) ? eval(sizable) : sizable;
	this.PageWindows = $H();
	this.ActiveWindow = ({
												stageID : "",
												windowID : ""
	});
	this.ActivePanel = ({
			windowID : "",
			panelID : ""
	});
	this.WidthOffset = 0;
	if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR ) ) != 0)
		this.WidthOffset = 25;
	this.HeightOffset = 0;
	if((this.taskBarStyle & ( TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		this.HeightOffset = 25;
		
	this.LOCAL_STAGE_VARIABLES = $H();
		
	},
	draw: function() {
		return this.show();
	},
	show: function() {
	var buildStage = "<table class='stageBase' id='" + this.elementName + "' cellpadding='0' cellspacing='0'>";
			buildStage +="<tr>";
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + LEFT_BLOCK_TASK_BAR + TOP_BLOCK_TASK_BAR ) ) != 0)
			{
				if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR ) ) != 0)
				{
					buildStage +="<td id='" + this.elementName + "_MenuBar_Table_cell' valign='top'>";
				}
				else
				{
					buildStage +="<td id='" + this.elementName + "_MenuBar_Table_cell' >";
				}
				buildStage += this.buildTaskBar();
				buildStage +="</td>";
			}
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + TOP_BLOCK_TASK_BAR ) ) != 0)
			{
				buildStage +="</tr>";
				buildStage +="<tr>";
			}
			buildStage +="<td valign='top'>";
			buildStage +="<div id='" + this.elementName + "_ContentWindow' class='stageContentContainer' style=\"position:static;background-color:white;width:" + (this.width - this.WidthOffset) + "px;height:" + (this.height - this.HeightOffset) + "px;\"></div>";
			buildStage +="</td>";
			if((this.taskBarStyle & ( BOTTOM_BLOCK_TASK_BAR) ) != 0)
			{
				buildStage +="</tr>";
				buildStage +="<tr>";
			}
			if((this.taskBarStyle & ( RIGHT_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
			{
				if((this.taskBarStyle & ( RIGHT_BLOCK_TASK_BAR ) ) != 0)
				{
					buildStage +="<td id='" + this.elementName + "_MenuBar_Table_cell' valign='top'>";
				}
				else
				{
					buildStage +="<td id='" + this.elementName + "_MenuBar_Table_cell'>";
				}
				buildStage += this.buildTaskBar();
				buildStage +="</td>";
			}
			buildStage +="</tr>";
			buildStage +="</table>";
		return buildStage;
	},
	buildTaskBar: function()
	{
		var buildStage = "";
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		{
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
			{
				buildStage +="<table id='" + this.elementName + "_MenuBar_Tab_Table' style='display: none;width:100%;' cellpadding='0' cellspacing='0'>";
			}
			else
			{
				buildStage +="<table id='" + this.elementName + "_MenuBar_Tab_Table' style='display: none;height:100%;' cellpadding='0' cellspacing='0'>";
			}
			buildStage +="<tr>";
		}
		else if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR ) ) != 0)
		{
			buildStage +="<table id='" + this.elementName + "_MenuBar_Table' style='height:100%;' cellpadding='0' cellspacing='0' bgcolor='white'>";
			buildStage +="<tr>";
		}
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
		{
			if((this.taskBarStyle & ( ALLOW_NEW_PANEL ) ) != 0)
			{
				buildStage +="<td style='width:10px;' id='" + this.elementName + "_MenuBar_NewTab'>";
				buildStage +="<img src='images/new_page.gif' onclick='OpenBlankWindow(\"" + this.elementName + "\")'>";
				buildStage +="</td>";
			}
			buildStage +="<td>";
			buildStage +="<table id='" + this.elementName + "_MenuBar_Table' style='width:100%;' class='stageTabAreaHeight' cellpadding='0' cellspacing='0'>";
			buildStage +="<tr>";
			buildStage +="<td id='" + this.elementName + "_MenuBar_Backward_Button' style='display:none;width:10px;'>";
			buildStage +="<img onmousedown=\"STAGE_activeStages.get('" + this.elementName + "').startScrollLeft()\" onmouseout=\"STAGE_activeStages.get('" + this.elementName + "').EndScrolling()\" onmouseup=\"STAGE_activeStages.get('" + this.elementName + "').EndScrolling()\" src='images/bw_nav_s.gif'/>";
			buildStage +="</td>";
		}
		buildStage +="<td>";
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		{
			buildStage +="<div style='width:200px;' class='stageTabMainScrollArea' id='" + this.elementName + "_MenuBar' onMouseUp='Releaseme()'>";
		}
		else
		{
			buildStage +="<div id='" + this.elementName + "_MenuBar' onMouseUp='Releaseme()'>";
		}
		buildStage +="<table cellpadding='0' cellspacing='0'>";
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		{
			buildStage +="<tbody>";
			buildStage +="<tr id='" + this.elementName + "_MenuBar_Content'>";
			buildStage +="</tr>";
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR) ) != 0)
			{
				buildStage +="<tr id='" + this.elementName + "_MenuBar_Content_UnderLine'>";
				buildStage +="</tr>";
			}
			buildStage +="</tbody>";
		}
		else if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR ) ) != 0)
		{
			buildStage +="<tbody id='" + this.elementName + "_MenuBar_Content'>";
			buildStage +="</tbody>";
		}
		buildStage +="</table>";
		buildStage +="</div>";
		buildStage +="</td>";
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
		{
			buildStage +="<td id='" + this.elementName + "_MenuBar_Forward_Button' style='display:none;' style='width:10px;' align='right'>";
			buildStage +="<img onmousedown=\"STAGE_activeStages.get('" + this.elementName + "').startScrollRight()\" onmouseout=\"STAGE_activeStages.get('" + this.elementName + "').EndScrolling()\" onmouseup=\"STAGE_activeStages.get('" + this.elementName + "').EndScrolling()\" src='images/fw_nav_s.gif'/>";
			buildStage +="</td>";
			buildStage +="</tr>";
			buildStage +="</table>";
			buildStage +="</td>";
			buildStage +="</tr>";
			buildStage +="<tr>";
			buildStage +="<td>";
			buildStage +="<div class=\"tabBarUnderline\" />";
			buildStage +="</td>";
		}
		buildStage +="</tr>";
		buildStage +="</table>";
		//buildStage +="</div>";
		return buildStage;
		//$(this.elementName + "_MenuBar_Forward_Button").hide()
	},
	addTaskBar: function(ID, pageID, title, windowType) {
		if((this.taskBarStyle & ( TOP_TAB_TASK_BAR + LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR + TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		{
			var mainTag = 'td';
			if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR ) ) != 0)
			{
				mainTag = 'tr';
			}
			var barToAdd = new Element(mainTag, { 'id'		: "MenuBar_" + pageID,
																	'onMouseDown':"BarItemClick('" + this.elementName + "','" + ID + "')"
			});
			var BuildBarHTML = "";
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
			{
				BuildBarHTML +="<table class='stageTabHeight' cellpadding=0 cellspacing=0><tr>";
				BuildBarHTML +="<td class='stageTabLeftSideWidth' onMouseDown=\"BarItemClick('" + this.elementName + "','" + ID + "');\"><img id=\"MenuBarTitleLeft_" + pageID + "\" src=\"images/Lefttitlebar.gif\"/></td>";
				BuildBarHTML +="<td id=\"MenuBarTitle_" + pageID + "\" class=\"TitleBar_Title\" style=\"background:url('images/titlebar.gif');\" onMouseDown=\"BarItemClick('" + this.elementName + "','" + ID + "');\">";
				BuildBarHTML +="<table cellpadding=\"0\" cellspacing=\"0\">";
				BuildBarHTML +="<tr>";
				BuildBarHTML +="<td width='1px' id='WindowLoadingInfo_" + pageID + "'></td>";
				if((this.windowOptionType & ( TAB_PERSISTENCE_FLAG ) ) != 0 && windowType != CAN_NOT_CLOSE)
				{
					BuildBarHTML +="<td width='1px'><input type='checkbox' title='Do not auto close window.' id='persistWindow_" + pageID + "' value='true'/></td>";
				}
				BuildBarHTML +="<td>";
				BuildBarHTML +="<div class='stageMenuBarContent_Tabs' id=\"WindowBarTitleHolder_" + pageID + "\">";
			}
			else
			{
				BuildBarHTML +="<td width='1px' id='WindowLoadingInfo_" + pageID + "'></td>";
				if((this.windowOptionType & ( TAB_PERSISTENCE_FLAG ) ) != 0 && windowType != CAN_NOT_CLOSE)
				{
					BuildBarHTML +="<td width='1px'><input type='checkbox' title='Do not auto close window.' id='persistWindow_" + pageID + "' value='true'/></td>";
				}
				BuildBarHTML +="<td>";
				BuildBarHTML +="<div class='stageMenuBarContent_Basic' id=\"WindowBarTitleHolder_" + pageID + "\">";
			}
			BuildBarHTML +="<span class='stageMenuBarContent_Title' id=\"WindowBarTitle_" + pageID + "\">" + (title == "" ? "No Title" : title) +"</span>";
			BuildBarHTML +="<div style=\"vertical-align: middle;position:static; width:100%; height:100%; left:0px; top:0px; \"></div>";
			BuildBarHTML +="</div>";
			BuildBarHTML +="</td>";
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
			{
				if(windowType != CAN_NOT_CLOSE)
				{
					BuildBarHTML +="<td align=\"right\" valign=\"top\" class='TitleBarElements_Close'>";
					BuildBarHTML +="<img src=\"images/close_s.gif\"onclick=\"getWindow('" + this.elementName + "','"+ ID + "').destroy()\"/>";
					BuildBarHTML +="</td>";
				}
				BuildBarHTML +="</tr>";
				BuildBarHTML +="</table>";
				BuildBarHTML +="</td>";
				BuildBarHTML +="<td class='stageTabRightSideWidth' onMouseDown=\"BarItemClick('" + this.elementName + "','" + ID + "');\"><img id=\"MenuBarTitleRight_" + pageID + "\" src=\"images/righttitlebar.gif\"/></td>";
				BuildBarHTML +="</tr></table>";
			}
			barToAdd.insert(BuildBarHTML);
			$(this.elementName + '_MenuBar_Content').insert(barToAdd);
			$(this.elementName + '_MenuBar').scrollLeft = $(this.elementName + '_MenuBar').scrollWidth;
			this.showTaskBarButtons();
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
			{
				if((this.taskBarStyle & ( ALLOW_NEW_PANEL ) ) == 0)
				{
					if(this.PageWindows.keys().size() > 1)
					{
						var titlebar = $(this.elementName + "_MenuBar_Tab_Table");
						titlebar.show();
						this.HeightOffset = titlebar.getHeight();
						this.PageWindows.each(function(Window) {
							var tabTitle = $("WindowBarTitle_" + Window.value.elementUniqueID);
							var tabTitleHolder = $("WindowBarTitleHolder_" + Window.value.elementUniqueID);
							if(tabTitle != null)
							{
								if(tabTitleHolder != null)
								{
									var tabTempTitle = tabTitle.innerHTML;
									var tabTitleHoderWidth = tabTitleHolder.getWidth();
									while(tabTitleHolder.scrollWidth > tabTitleHoderWidth && tabTempTitle.length > 10)
									{
										tabTempTitle = tabTempTitle.substring(0, tabTempTitle.length - 4) + "...";
										tabTitle.update(tabTempTitle);
									}
								}
							}
					});
					}
					else
					{
						$(this.elementName + "_MenuBar_Tab_Table").hide();
						this.HeightOffset = 0;
					}
					changeWorkArea();
				}
			}
		}
	},
	closeTaskBar: function(pageWindowToClose) {
		var mentBarTab = $('MenuBar_' + pageWindowToClose.elementUniqueID);
		if(mentBarTab != null)
			mentBarTab.remove();
		if(this.ActiveWindow.windowID == pageWindowToClose.elementName)
		{
			var lastWindow = null;
			var pageWindowsKeys = this.PageWindows.keys();
			var pageWindowsKaysSize = pageWindowsKeys.size();
			if(pageWindowsKaysSize > 1)
			{
				lastWindow = pageWindowsKeys[pageWindowsKaysSize-2];
				for(i = pageWindowsKaysSize-1; i >= 0 && pageWindowsKeys[i] != pageWindowToClose.elementName; i--)
				{
					lastWindow = pageWindowsKeys[i];
				}
				var nextActiveWindow = this.PageWindows.get(lastWindow);
				setActivePanel(nextActiveWindow.parentStageID, nextActiveWindow.elementName, nextActiveWindow.activePanel);
				RaiseToTop(nextActiveWindow.parentStageID, nextActiveWindow.elementName);
			}
		}
		this.PageWindows.unset(pageWindowToClose.elementName);
		this.showTaskBarButtons();
		if((this.taskBarStyle & ( ALLOW_NEW_PANEL | TOP_TAB_TASK_BAR ) ) == ALLOW_NEW_PANEL | TOP_TAB_TASK_BAR)
		{
			if(this.PageWindows.keys().size() <= 1 && $(this.elementName + "_MenuBar_Tab_Table") != null)
			{
				$(this.elementName + "_MenuBar_Tab_Table").hide();
				this.HeightOffset = 0;
			}
		}
		changeWorkArea();
	},
	reloadPage: function() {
		this.PageWindows.each(function(ID) {
			if(ID != null)
			{
				ID.value.reloadPage();
			}
		});
	},
	showTaskBarButtons: function() {
		var menubar = $(this.elementName + '_MenuBar');
		if(menubar != null)
		{
			if((this.taskBarStyle & ( TOP_TAB_TASK_BAR ) ) != 0)
			{
				if(menubar.scrollWidth <this.width)
				{
					$(this.elementName + "_MenuBar_Forward_Button").hide();
					$(this.elementName + "_MenuBar_Backward_Button").hide();
					menubar.setStyle({"width": (this.width) + "px"});
				}
				else if(menubar.scrollWidth > this.width )
				{
					$(this.elementName + "_MenuBar_Forward_Button").show();
					$(this.elementName + "_MenuBar_Backward_Button").show();
					menubar.setStyle({"width": (this.width-($(this.elementName + "_MenuBar_Backward_Button").getWidth() + $(this.elementName + "_MenuBar_Forward_Button").getWidth())) + "px"});
				}
				menubar.scrollLeft = menubar.scrollWidth ;
			}
		}
	},
	size: function() {
		return;
	},
	sizeContent: function() {
		if(WINDOW_IS_FULL != this.sizable)
			return;
		if($(this.elementName) == null)
			return;
		var contentWidth = $(this.elementName).getWidth();
		var contentHeight = $(this.elementName).getHeight();
		contentWidth -= this.WidthOffset;
		contentHeight -= this.HeightOffset;
		var window = this.PageWindows.get(this.ActiveWindow.windowID);
		if(window != null)
		{
			window.setWidth(contentWidth);
			window.setHeight(contentHeight);
		}
	},
	destroy: function() {
		this.myParent = null;
		this.PageWindows.each(function(ID) {
			if(ID != null)
			{
				ID.value.destroy();
			}
		});
		this.PageWindows = $H();
		if($(this.elementName) != null)
			$(this.elementName).remove();
		STAGE_activeStages.unset(this.elementName);
	},
	EndScrolling: function() {
		this.EndScroll = true;
	},
	startScrollLeft: function() {
		if(!this.taskBarStyle)
			return;
		this.scrollAcceleration = 1;
		this.EndScroll = false;
		this.scrollLeft();
	},
	scrollLeft: function() {
		if(this.EndScroll)
			return;
		this.scrollAcceleration +=0.2;
		$(this.elementName + '_MenuBar').scrollLeft += -(this.scrollAcceleration);
		setTimeout("STAGE_activeStages.get('" + this.elementName + "').scrollLeft()", 10);
	},
	startScrollRight: function() {
		if(!this.taskBarStyle)
			return;
		this.scrollAcceleration = 1;
		this.EndScroll = false;
		this.scrollRight();
	},
	scrollRight: function() {
		if(this.EndScroll)
			return;
		this.scrollAcceleration +=0.2;
		$(this.elementName + '_MenuBar').scrollLeft += (this.scrollAcceleration);
		setTimeout("STAGE_activeStages.get('" + this.elementName + "').scrollRight()", 10);
	},
	startScrollUp: function() {
		if(!this.taskBarStyle)
			return;
		this.scrollAcceleration = 1;
		this.EndScroll = false;
		this.scrollUp();
	},
	scrollUp: function() {
		if(this.EndScroll)
			return;
		this.scrollAcceleration +=0.2;
		$(this.elementName + '_MenuBar').scrollTop += (this.scrollAcceleration);
		setTimeout("STAGE_activeStages.get('" + this.elementName + "').scrollUp()", 10);
	},
	startScrollDown: function() {
		if(!this.taskBarStyle)
			return;
		this.scrollAcceleration = 1;
		this.EndScroll = false;
		this.scrollDown();
	},
	scrollDown: function() {
		if(this.EndScroll)
			return;
		this.scrollAcceleration +=0.2;
		$(this.elementName + '_MenuBar').scrollTop -= (this.scrollAcceleration);
		setTimeout("STAGE_activeStages.get('" + this.elementName + "').scrollDown()", 10);
	},
sizeWidth: function(Amount) {
		var contentWindow = $(this.elementName + '_ContentWindow');
		this.width += Amount;
		if(contentWindow != null)
			contentWindow.setStyle({"width" : (this.width- ( this.fromLeft + this.fromRight + this.WidthOffset )) + "px"});
		this.showTaskBarButtons();
		var contentWidth = this.width- ( this.fromLeft + this.fromRight + this.WidthOffset );
		if(contentWidth < 0)
			contentWidth = 0;
		var window = this.PageWindows.get(this.ActiveWindow.windowID);
		if(window != null)
		{
			window.setWidth(contentWidth);
		}
		return this.width;
},
sizeHeight: function(Amount) {
		var contentWindow = $(this.elementName + '_ContentWindow');
		var titlebar = $(this.elementName + "_MenuBar_Tab_Table");
		if(titlebar != null)
		{
			if(titlebar.visible())
			{
				this.HeightOffset = titlebar.getHeight();
			}
			else
			{
				this.HeightOffset = 0;
			}
		}
		this.height += Amount;
		if(contentWindow != null)
			contentWindow.setStyle({"height": (this.height - ( this.fromBotton + this.fromTop + this.HeightOffset) ) + "px"}); //Remove height of menubar
		var contentHeight = this.height - ( this.fromBotton + this.fromTop + this.HeightOffset);
		if(contentHeight < 0)
			contentHeight = 0;
		var window = this.PageWindows.get(this.ActiveWindow.windowID);
		if(window != null)
		{
			window.setHeight(contentHeight);
		}
		return this.height;
},
setWidth: function(Amount) {
		var contentWindow = $(this.elementName + '_ContentWindow');
		this.width = Amount;
		if(contentWindow != null)
			contentWindow.setStyle({"width" : (this.width- ( this.fromLeft + this.fromRight + this.WidthOffset )) + "px"});
		this.showTaskBarButtons();
		this.sizeContent();
		var contentWidth = this.width- ( this.fromLeft + this.fromRight + this.WidthOffset );
		if(contentWidth < 0)
			contentWidth = 0;
		var window = this.PageWindows.get(this.ActiveWindow.windowID);
		if(window != null)
		{
			window.setWidth(contentWidth);
		}
		return this.width;
},
setHeight: function(Amount) {
		var contentWindow = $(this.elementName + '_ContentWindow');
		var titlebar = $(this.elementName + "_MenuBar_Tab_Table");
		if(titlebar != null)
		{
			if(titlebar.visible())
			{
				this.HeightOffset = titlebar.getHeight();
			}
			else
			{
				this.HeightOffset = 0;
			}
		}
		this.height = Amount;
		if(contentWindow != null)
			contentWindow.setStyle({"height": (this.height - ( this.fromBotton + this.fromTop + this.HeightOffset) ) + "px"}); //Remove height of menubar
		var contentHeight = this.height - ( this.fromBotton + this.fromTop + this.HeightOffset);
		if(contentHeight < 0)
			contentHeight = 0;
		var window = this.PageWindows.get(this.ActiveWindow.windowID);
		if(window != null)
		{
			window.setHeight(contentHeight);
		}
},
moveLeft: function(Amount) {
	this.PageWindows.each(function(aObject) {
		aObject.value.moveLeft(Amount);
		});
},
moveTop: function(Amount) {
	this.PageWindows.each(function(aObject) {
		aObject.value.moveTop(Amount);
		});
},
	BarItemClick: function(ID) {
		if((this.taskBarStyle & ( LEFT_BLOCK_TASK_BAR + RIGHT_BLOCK_TASK_BAR + TOP_BLOCK_TASK_BAR + BOTTOM_BLOCK_TASK_BAR ) ) != 0)
		{
			if($("Body_" + this.elementName + "_" + ID).getStyle("display") == "block")
			{
				//$("Body_" + this.elementName + "_" + ID).setStyle({ "display": "none"});
				SetBarState(this.elementName + "_" + ID, 0);
			}
			else
			{
				$("Body_" + this.elementName + "_" + ID).setStyle({ "display": "block"});
				SetBarState(this.elementName + "_" + ID, 1);
				RaiseToTop(this.elementName, ID);
			}
		}
		else
			RaiseToTop(this.elementName, ID);
	},
	closeAllWindows: function() {
		this.PageWindows.each(function(ID) {
			if(ID != null)
			{
				if(ID.value.windowType != CAN_NOT_CLOSE)
				{
					if($("persistWindow_" + ID.value.elementUniqueID) == null)
					{
						ID.value.destroy();
					}
					else if($F("persistWindow_" + ID.value.elementUniqueID) != 'true')
					{
						ID.value.destroy();
					}
				}
			}
		});
	}
});