/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
var basePageElement = Class.create({
	initialize: function(myID, myType) {
		this.elementParent = null;
		this.elementName = myID;
		this.elementType = this.elementType == null ? myType : this.elementType;
		this.elementUniqueID = myID;
		this.parentStageID = "";
		this.parentWindowID = "";
		this.width = 0;
		this.height = 0;
		this.minWidth= this.minWidth == null ? 200 : this.minWidth;
		this.minHeight= this.minHeight == null ? 10 : this.minHeight;
	},
	autoReloadUpdate: function() {
		//Treat as abstract function
	},
	reloadPage: function() {
	//Treat as abstract function
	},
	resizeStart: function() {
		//Treat as abstract function
	},
	resizeEnd: function() {
		//Treat as abstract function
	},
	sizeWidth: function(Amount) {
		//Treat as abstract function
	},
	sizeHeight: function(Amount) {
		//Treat as abstract function
	},
	setWidth: function(Amount) {
		//Treat as abstract function
	},
	setHeight: function(Amount) {
		//Treat as abstract function
	},
	moveLeft: function(Amount) {
		//Treat as abstract function
	},
	moveTop: function(Amount) {
		//Treat as abstract function
	},
	destroy: function() {
		this.myParent = null;
	},
	draw: function() {
		return "";
	},
	redraw: function() {
		this.draw();
	},
	sizeToChild: function(childsName) {
		return null;
	}
});