/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
var AdHocSQLWindows = $H();
CORE_CLIENT_ACTIONS.set("ADHOC", Class.create(basePageElement, {
	initialize: function($super, callParameters) { //StageID, WindowID, PanelID, PageID, AdHocLong) {
		$super(callParameters.uniqueID, "ADHOC");

				
		this.callParameters = callParameters;
		
		this.primaryContainerID = callParameters.primaryContainer;
		
		this.AdHocLong = callParameters.AdHocLong == null ? false : callParameters.AdHocLong;	
		
		this.parentStageID = callParameters.stageID;
		this.parentWindowID = callParameters.windowID;
		this.parentPanelID = callParameters.panelID;
		
		this.LoadSQLData 	= callParameters.LoadSQLData;
		this.LoadSQLData = this.LoadSQLData == null ? "" : this.LoadSQLData;
		
		AdHocSQLWindows.set(this.elementUniqueID, this);

		this.IDCounter = 0;
		this.VerticalSplit = false;
		this.MessageWindow = "RESULTS";
		this.LocalStage = this.elementUniqueID + '_RESULT_STAGE';
		this.scriptMode = "SQL";
		this.AllreadyRunning = false;
		this.resultSetStorageHolder = null;
		this.resultSetStorageName = null;
		
		this.draw();
		
		try
		{
			var window = null;
			if(!this.AdHocLong)
			{
				window = getWindow(this.parentStageID,this.parentWindowID);
			}
			else
			{
				window = getWindow(this.elementUniqueID + '_RESULT_STAGE', this.elementUniqueID + '_ADHOC_TEXT_WINDOW');
			}
			if(window != null)
			{
				var panel = window.WindowContainers.get(this.elementUniqueID + "_ADHOC_TEXT_PANEL");
				if(panel != null)
				{
					panel.registerNestedObject(this.elementUniqueID, this);
				}
			}
		}
		catch(e)
		{
			alert(e);
		}
		this.setWidth(0);
		this.setHeight(0);

		var layout = ({
			target	: "RESULTS",
			raiseToTop:"",
			windowStage : this.elementUniqueID + '_RESULT_STAGE',
			raiseToTop: false,
			windowType: CAN_NOT_CLOSE,
			content	 : {
								type:"panel",
								name:"main",
								PrimaryContainer:true,
								ContentType:"RAW",
								data:"<div id='title'>Console</div><pre><code><div id='" + this.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN' class='SQL_RESULTS_THIS_RUN'></div></code></pre><pre><code><div id='" + this.elementUniqueID + "_SQL_RESULT_RETURN_OLD' class='SQL_RESULTS_OLD'></div></code></pre>"
							}
		});
		loadNewPageLayout(layout);
		$(this.elementUniqueID + "_EditQuery").hide();
		if(this.AdHocLong)
		{
			RaiseToTop(this.elementUniqueID + '_RESULT_STAGE', this.elementUniqueID + '_ADHOC_TEXT_WINDOW');
		}
	},
	
	draw: function() {

		var layout = null;
		
		if(!this.AdHocLong)
		{
			layout = ({
							type:"splitPane",
							direction:"h",
							maxSize:22,
							allowResize:false,
							panelA: {
									type:"panel",
									name:this.elementUniqueID + "_ADHOC_TOP_MENU",
									overflow:"hidden",
									PrimaryContainer:false,
									ContentType:"RAW",
									data:'<table style="width:100%;height:25px;" class="contextRootBase" cellpadding="0" cellspacing="0"><tbody><tr><td valign="top" style="text-align:left;width:5px;" id="' + this.elementUniqueID + '_AdhocOptionMenu" class="contextMenuBox"></td><td valign="top" style="text-align:left;width:5px;" id="' + this.elementUniqueID + '_AdhocActionMenu" class="contextMenuBox"></td><td>&nbsp;&nbsp;</td></tr></tbody></table>'
								},
							panelB: {
									type:"splitPane",
									direction:"h",
									splitPercent:0.5,
									allowResize:true,
									panelA: {
												type:"panel",
												name:this.elementUniqueID + "_ADHOC_TEXT_PANEL",
												overflow:"hidden",
												PrimaryContainer:true,
												ContentType:"RAW",
												data:'<div id="title">Ad hoc SQL</div><table id="' + this.elementUniqueID + '_SQL_TEXT_CONTAINER" style="width:50px;height:50px;" class="AdhocBase" cellpadding="0" cellspacing="0"><tbody><tr><td><textarea id="' + this.elementUniqueID + '_SQL_TEXT_FRAME" name="' + this.elementUniqueID + '_SQL_TEXT_FRAME" class="ADHOC_TEXTBOX">' + this.LoadSQLData + '</textarea><div id="' + this.elementUniqueID + '_SQL_HTML_FRAME" class="ADHOC_HTMLBOX" style="display:none;"></div></td></tr></tbody></table>'
											},
										panelB: {
													type				:"stage",
													name				: this.elementUniqueID + "_RESULT_STAGE",
													HasMenuBarContainer : TOP_TAB_TASK_BAR, 
													top					: 0, 
													botton				: 0, 
													left				: 0,
													right				: 0,
													titleBarType		: NO_TITLE_BAR,
													windowOptionType	: NO_NAV_BAR, 
													windowControlTypes	: NO_TITLE_BAR_OPTIONS,
													sizable				: WINDOW_IS_FULL
											}
								}
			});
			
			getWindow(this.parentStageID,this.parentWindowID).WindowContainers.get(this.parentPanelID).loadLayout(layout);
		}
		else 
		{
			layout = ({
						type:"splitPane",
						direction:"h",
						maxSize:22,
						allowResize:false,
							panelA: {
									type:"panel",
									name:this.elementUniqueID + "_ADHOC_TOP_MENU",
									overflow:"hidden",
									PrimaryContainer:true,
									ContentType:"RAW",
									data:'<table style="width:100%;height:25px;" class="contextRootBase" cellpadding="0" cellspacing="0"><tbody><tr><td valign="top" style="text-align:left;width:5px;" id="' + this.elementUniqueID + '_AdhocOptionMenu" class="contextMenuBox"></td><td valign="top" style="text-align:left;width:5px;" id="' + this.elementUniqueID + '_AdhocActionMenu" class="contextMenuBox"></td><td>&nbsp;&nbsp;</td></tr></tbody></table>'
								},
							panelB: {
										type				:"stage",
										name				: this.elementUniqueID + "_RESULT_STAGE",
										HasMenuBarContainer : TOP_TAB_TASK_BAR, 
										top					: 0, 
										botton				: 0, 
										left				: 0,
										right				: 0,
										titleBarType		: NO_TITLE_BAR,
										windowOptionType	: NO_NAV_BAR, 
										windowControlTypes	: NO_TITLE_BAR_OPTIONS,
										sizable				: WINDOW_IS_FULL
								}
			});

			getWindow(this.parentStageID,this.parentWindowID).WindowContainers.get(this.parentPanelID).loadLayout(layout);
			
			
			layout = ({
				target	: this.elementUniqueID + "_ADHOC_TEXT_WINDOW",
				raiseToTop: "",
				windowStage : this.elementUniqueID + "_RESULT_STAGE",
				windowType: CAN_NOT_CLOSE,
				content	 : {
											type:"panel",
											name:this.elementUniqueID + "_ADHOC_TEXT_PANEL",
											PrimaryContainer:true,
											overflow:"hidden",
											ContentType:"RAW",
											data:'<div id="title">Ad Hoc Text</div>' +
													'<table id="' + this.elementUniqueID + '_SQL_TEXT_CONTAINER" style="width:50px;height:50px;" class="AdhocBase" cellpadding="2" cellspacing="0">' +
															'<tbody>' +
																'<tr>' +
																	'<td>' +
																		'<textarea id="' + this.elementUniqueID + '_SQL_TEXT_FRAME" name="' + this.elementUniqueID + '_SQL_TEXT_FRAME" class="ADHOC_TEXTBOX">' + this.LoadSQLData + '</textarea>' +
																		'<div id="' + this.elementUniqueID + '_SQL_HTML_FRAME" class="ADHOC_HTMLBOX" style="display:none;"></div>' +
																	'</td>' +
																'</tr>' +
															'</tbody>' +
													'</table>'
			}});
			
			loadNewPageLayout(layout);
		}
		
		getWindow(this.parentStageID,this.parentWindowID).WindowContainers.get(this.parentPanelID).hideAddressBar();
	
createContextMenu(this.elementUniqueID + '_AdhocOptionMenu', [
{
	nodeType: "branch",
	elementID : "branch",
	elementValue : "File",
	elementAction : '',
	elementSubNodes : [
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_OPEN",
	elementValue : "Open...",
	elementAction : 'onClick="AdHocSQLWindows.get(\'' + this.elementUniqueID + '\').openFile();"',
	elementSubNodes : [],
	elementSubNodeDirection : HORIZONTAL
},
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_SAVE",
	elementValue : "Save...",
	elementAction : 'onClick="AdHocSQLWindows.get(\'' + this.elementUniqueID + '\').saveFile();"',
	elementSubNodes : [],
	elementSubNodeDirection : HORIZONTAL
}
	],
	elementSubNodeDirection : HORIZONTAL
},
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_AdhocExecutionHistory",
	elementValue : "History",
	elementAction : 'onClick="FLOATINGPANEL_activeFloatingPanels.get(\'' + this.elementUniqueID + '_AdhocExecutionHistory\').show_and_size();"',
	elementSubNodes : [],
	elementSubNodeDirection : HORIZONTAL
},
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_AdhocOptionsButton",
	elementValue : "Options...",
	elementAction : 'onClick="FLOATINGPANEL_activeFloatingPanels.get(\'' + this.elementUniqueID + '_AdhocOptions\').show_and_size();"',
	elementSubNodes : null,
	elementSubNodeDirection : HORIZONTAL
}
], HORIZONTAL, this.parentStageID, this.parentWindowID, this.parentPanelID);

createContextMenu(this.elementUniqueID + '_AdhocActionMenu', [
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_Execute",
	elementValue : "Run",
	elementAction : "onclick=\"AdHocSQLWindows.get('" + this.elementUniqueID + "').play();\"",
	elementSubNodes : null,
	elementSubNodeDirection : null
},
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_ClearResults",
	elementValue : "Clear&nbsp;results",
	elementAction : "onclick=\"AdHocSQLWindows.get('" + this.elementUniqueID + "').clearResults();\"",
	elementSubNodes : null,
	elementSubNodeDirection : null
},
{
	nodeType: "leaf",
	elementID : this.elementUniqueID + "_EditQuery",
	elementValue : "Edit&nbsp;Query",
	elementAction : "onclick=\"AdHocSQLWindows.get('" + this.elementUniqueID + "').enableEditing();\"",
	elementSubNodes : null,
	elementSubNodeDirection : null
}
], HORIZONTAL, this.parentStageID, this.parentWindowID, this.parentPanelID);


	var AdhocFormText = '<form id="' + this.elementUniqueID + '_adhocForm" target="main" action="action.php?action=AdHocSQL%2FprocessAdHoc" style="width:300px;" method="POST">' +
						'<span id="discriptionText"><h1>Ad Hoc SQL Options</h1></span>';

	if(JAVA_SQL_ENABLED || SSH2_ENABLED)
	{
		AdhocFormText += '<div style="padding:5px;"><h2>Ad Hoc mode:</h2><table><tr><td align="center">'+
						'<input id="' + this.elementUniqueID + '_OptionScriptModeSQL" onchange="AdHocSQLWindows.get(\'' + this.elementUniqueID + '\').changeScriptMode(\'SQL\')" class="Adhoc" type="radio" size="1" name="scriptMode" checked value="SQL" />'+
						'</td><td>SQL script</td>';
		if(JAVA_SQL_ENABLED)
		{
		AdhocFormText += '<td align="center">' +
						'<input id="' + this.elementUniqueID + '_OptionScriptModeJSQL" onchange="AdHocSQLWindows.get(\'' + this.elementUniqueID + '\').changeScriptMode(\'JSQL\')" class="Adhoc" type="radio" size="1" name="scriptMode" value="JSQL" />' +
						'</td><td>SQL script (Java Driver)</td>';
		}
	
		if(SSH2_ENABLED)
		{
		AdhocFormText += '<td align="center">' +
						'<input id="' + this.elementUniqueID + '_OptionScriptModeSSH" onchange="AdHocSQLWindows.get(\'' + this.elementUniqueID + '\').changeScriptMode(\'SHELL\')" class="Adhoc" type="radio" size="1" name="scriptMode" value="SHELL" />' +
						'</td><td>Shell script</td>';
		}
		AdhocFormText += '</tr></table>'
	}
	AdhocFormText += '<div id="' + this.elementUniqueID + '_SHELLOptions" style="display:none;">' +
						'<h2>Script Execution Settings:</h2>' +
							'<table><tr><td align="center">' +
								'	<input id="' + this.elementUniqueID + '_OptionMaxRunTime" class="Adhoc" type="text" size="3" name="maxRunTime" value="' + (this.callParameters.shellMaxRunTime != null ? this.callParameters.shellMaxRunTime : SHELL_COMMAND_MAX_RUN_TIME) +'"align="center"/>' +
							'</td><td>Maximum run time</td><td align="center">' +
								'<input id="' + this.elementUniqueID + '_OptionShellTermChar" class="Adhoc" type="text" size="3" name="termCharater" value="' +(this.callParameters.shellTermChar != null ? this.callParameters.shellTermChar :AD_HOC_TERMINATION_CHAR) + '"align="center"/>' +
							'</td><td>Statement termination character</td></tr></table></div>' +
								'<div id="' + this.elementUniqueID + '_SQLOptions">' +
									'<h2>Query Execution Settings:</h2>' +
										'<table><tr><td align="center">' +
											'<input id="' + this.elementUniqueID + '_OptionCommit" class="Adhoc" type="checkbox" size="1" name="commitPerSTMT" ' + ((this.callParameters.commitPerStmt != null ? this.callParameters.commitPerStmt : AD_HOC_COMMIT_PER_STMT) ? "checked" : "") + ' value="true" />' +
										'</td><td>Commit per statement</td></tr><tr><td align="center">' +
											'<input id="' + this.elementUniqueID + '_OptionTermChar" class="Adhoc" type="text" size="1" name="STMTermChar" value="' + (this.callParameters.termChar != null ? this.callParameters.termChar : AD_HOC_TERMINATION_CHAR) + '"align="center"/>' +
										'</td><td>Statement termination character</td></tr><tr><td align="center">' +
											'<input id="' + this.elementUniqueID + '_OptionRows" type="text" size="10" name="maxRowReturn" value="' + (this.callParameters.numRowReturned != null ? this.callParameters.numRowReturned : AD_HOC_NUMBER_OF_ROWS_TO_RETURN) + '"align="center"/>' +
										'</td><td>Number of rows returned</td></tr><tr><td align="center">' +
											'<input id="' + this.elementUniqueID + '_OptionDefaultSchema" type="text" size="10" name="schema" value="' + (this.callParameters.schema != null ? this.callParameters.schema : "" ) + '"align="center"/>' +
										'</td><td>Default schema</td></tr></table>' +
									'<h2>Retrieve full data for:</h2>' +
							'<table><tr><td>' +
								'<input id="' + this.elementUniqueID + '_OptionXML" class="Adhoc" type="checkbox" name="displayXML" ' + ((this.callParameters.xml != null ? this.callParameters.xml : AD_HOC_DISPLAY_XML)? "checked" : "") + ' value="true" />' +
							'</td><td>XML</td><td>' +
								'<input id="' + this.elementUniqueID + '_OptionXMLinline" class="Adhoc" type="checkbox" name="displayXMLinline"' + ((this.callParameters.xmlinline != null ? this.callParameters.xmlinline : AD_HOC_DISPLAY_XML_AS_INLINE) ? "checked" : "") + ' value="true" />' +
							'</td><td>inline</td></tr><tr><td>' +
								'<input id="' + this.elementUniqueID + '_OptionCLOB" class="Adhoc" type="checkbox" name="displayCLOB" ' + ((this.callParameters.clob != null ? this.callParameters.clob : AD_HOC_DISPLAY_CLOB) ? "checked" : "") + ' value="true" />' +
							'</td><td>CLOB</td><td>' +
								'<input id="' + this.elementUniqueID + '_OptionCLOBinline" class="Adhoc" type="checkbox" name="displayCLOBinline" ' + ((this.callParameters.clobinline != null ? this.callParameters.clobinline : AD_HOC_DISPLAY_CLOB_AS_INLINE) ? "checked" : "") + ' value="true" />' +
							'</td><td>inline</td></tr><tr><td>' +
								'<input id="' + this.elementUniqueID + '_OptionBLOB" class="Adhoc" type="checkbox" name="displayBLOB" ' + ((this.callParameters.blob != null ? this.callParameters.blob : AD_HOC_DISPLAY_BLOB) ? "checked" : "") + ' value="true" />' +
							'</td><td>BLOB</td><td></td><td></td></tr><tr><td>' +
								'<input id="' + this.elementUniqueID + '_OptionBDCLOB" class="Adhoc" type="checkbox" name="displayDBCLOB" ' + ((this.callParameters.dbclob != null ? this.callParameters.dbclob : AD_HOC_DISPLAY_DBCLOB) ? "checked" : "") + ' value="true" />' +
							'</td><td>DBCLOB</td><td></td><td></td></tr></table></div></form></div>'
					
	var AdhocOptions = new floatingPanel(this.elementUniqueID + '_AdhocOptions', 'RAW', AdhocFormText, this.elementUniqueID + "_AdhocOptionsButton");
	getPanel(this.parentStageID, this.parentWindowID, this.parentPanelID).registerNestedObject(AdhocOptions);
	AdhocOptions.draw();

	
	var AdhocExecutionHistory = new floatingPanel(this.elementUniqueID + '_AdhocExecutionHistory', 'RAW', 
	'<table style="width:200px;"><tr><td>' + 
		'<span>SQL submitted at:</span>' +
			'<ul TYPE=DISC id="' + this.elementUniqueID + '_AdhocExecutionHistory_List" class="AdhocExecutionHistory">' +
			'</ul>' + 
	'</td></tr></table>', this.elementUniqueID + "_AdhocExecutionHistory", true);
	getPanel(this.parentStageID, this.parentWindowID, this.parentPanelID).registerNestedObject(AdhocExecutionHistory);
	AdhocExecutionHistory.draw();
	
	},
	openFile:function()
	{
		var tempParamObject = $H();
		tempParamObject.set('RUN_ACTION', 'OPENFILE');
		runClientAction(this.elementName + "_AdHocOpenFile", GLOBAL_ACTION_SCRIPT_STORE.get('AD_HOC_ACTION_SCRIPTS'), this.elementUniqueID, null, null,tempParamObject,this.parentStageID, this.parentWindowID, this.parentPanelID, this.elementName);
	},
	saveFile:function()
	{
		var tempParamObject = $H();
		tempParamObject.set('SQL_TEXT', $(this.elementUniqueID + '_SQL_TEXT_FRAME').value);
		tempParamObject.set('RUN_ACTION', 'SAVEFILE');
		runClientAction(this.elementName + "_AdHocSaveFile", GLOBAL_ACTION_SCRIPT_STORE.get('AD_HOC_ACTION_SCRIPTS'), this.elementUniqueID, null, null,tempParamObject,this.parentStageID, this.parentWindowID, this.parentPanelID, this.elementName);
	},
	
	destroy: function() {
		try
		{
			var window = null;
			if(!this.AdHocLong)
			{
				window = getWindow(this.parentStageID,this.parentWindowID);
			}
			else
			{
				window = getWindow(this.elementUniqueID + '_RESULT_STAGE', this.elementUniqueID + '_ADHOC_TEXT_WINDOW');
			}
			if(window != null)
			{
				window.WindowContainers.unset(this.elementUniqueID + "_ADHOC_TEXT_PANEL");
			}
		}
		catch(e)
		{
		}
		AdHocSQLWindows.unset(this.elementUniqueID);
	},
	enableEditing: function() {
		$(this.elementUniqueID + "_SQL_HTML_FRAME").hide();
		$(this.elementUniqueID + "_EditQuery").hide();
		$(this.elementUniqueID + "_SQL_TEXT_FRAME").show();
	},
	analyzeQuery: function(queryText, statmentTermChar) {
		var charSplit = queryText.split("");
		var currentStatment = {
			paramCount:0,
			serverQuery:""
		};
		var statmentSet = [];
		var currentChar = "";
		var inQuote = false;
		var lastCharWasEscape = false;
		var lastWasSingalQuote = false;
		var quoteType = "";
		
		charSplit = charSplit.reverse();
		while(currentchar = charSplit.pop())
		{
			if(currentchar == statmentTermChar && !inQuote)
			{
				lastCharWasEscape = false;
				lastWasSingalQuote = false;
				if(!currentStatment.serverQuery.match(/^\s*$/))
					statmentSet.push(currentStatment);
				currentStatment = {
							paramCount:0,
							serverQuery:""
						};
			}
			else if(currentchar == "\\")
			{
				lastCharWasEscape = !lastCharWasEscape;
				lastWasSingalQuote = false;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "\"" && !inQuote)
			{
				lastWasSingalQuote = false;
				quoteType = "\"";
				inQuote = true;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "'" && !inQuote)
			{
				lastCharWasEscape = false;
				quoteType = "'";
				inQuote = true;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == '"' && !inQuote)
			{
				lastWasSingalQuote = false;
				lastCharWasEscape = false;
				quoteType = '"';
				inQuote = true;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == quoteType && inQuote && (!lastCharWasEscape) )
			{
				quoteType = "";
				inQuote = false;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "?" && !inQuote)
			{
				lastCharWasEscape = false;
				lastWasSingalQuote = false;
				currentStatment.paramCount++;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "/" && charSplit.length > 0 && !inQuote)
			{
				if(charSplit[charSplit.length-1] == '/')
				{
					currentchar = charSplit.pop();
					while(charSplit.pop() != "\n" && charSplit.length > 0);
					continue;
				}
				else if(charSplit[charSplit.length-1] == '*')
				{
					currentchar = charSplit.pop();
					while(currentchar = charSplit.pop())
					{
						if(currentchar == '*' && charSplit.length > 0)
						{
							if(charSplit[charSplit.length-1] == '/')
							{
								currentchar = charSplit.pop()
								break;
							}
						}
					}
					continue;
				}
				
				lastWasSingalQuote = false;
				lastCharWasEscape = false;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "-" && charSplit.length > 0 && !inQuote && !lastCharWasEscape)
			{
				if(charSplit[charSplit.length-1] == '-')
				{
					currentchar = charSplit.pop();
					while(charSplit.pop() != "\n" && charSplit.length > 0);
					continue;
				}
				
				lastWasSingalQuote = false;
				lastCharWasEscape = false;
				currentStatment.serverQuery += currentchar;
			}
			else if(currentchar == "<" && charSplit.length > 2 && !inQuote && !lastCharWasEscape)
			{
				if(charSplit[charSplit.length-1] == '!' && charSplit[charSplit.length-2] == '-' && charSplit[charSplit.length-3] == '-')
				{
					charSplit.pop();
					charSplit.pop();
					currentchar = charSplit.pop();
					while(currentchar = charSplit.pop())
					{
						if(currentchar == '-' && charSplit.length > 1)
						{
							if(charSplit[charSplit.length-1] == '-' && charSplit[charSplit.length-2] == '>')
							{
								charSplit.pop();
								currentchar = charSplit.pop();
								break;
							}
						}
					}
					continue;
				}
				
				lastWasSingalQuote = false;
				lastCharWasEscape = false;
				currentStatment.serverQuery += currentchar;
			}
			else
			{
				lastWasSingalQuote = false;
				lastCharWasEscape = false;
				currentStatment.serverQuery += currentchar;
			}
		}
		if(!currentStatment.serverQuery.match(/^\s*$/))
			statmentSet.push(currentStatment);
		return statmentSet;
	},
	play: function() {
		//LOCAL_STAGES.get(this.LocalStage).closeAllWindows();
		if(this.AllreadyRunning)
			return;
		this.AllreadyRunning = true;
		if(this.scriptMode == "SHELL")
			this.executScript(this.elementUniqueID);
		else if(this.scriptMode == "SQL")
			this.executeQuery(this.elementUniqueID, ACTION_PROCESSOR + "?action=executeSQL");
		else if(this.scriptMode == "JSQL")
		{
			var thisObject = this;
			new Ajax.Request( ACTION_PROCESSOR + "?action=javaService%2Fupdate", {
				'onSuccess': function(transport) {
					var setJavaConnection = transport.responseText;
					new Ajax.Request(setJavaConnection, {
					'onSuccess': function(transport) {
						thisObject.executeQuery(thisObject.elementUniqueID, "../Executor/ExecutorService");
					}
					});
				}
			});
		}
	},
	executeQuery: function(outputStage, service) {
		var adhocStore = "";
		var thisObject = this;
		var parameters = new Object();
		parameters.pageID = this.elementUniqueID;
		parameters.stageID = this.parentStageID;
		parameters.windowID = this.parentWindowID;
		parameters.panelID = this.parentPanelID;
		parameters.resultStageID = outputStage;
		parameters.USE_CONNECTION = ACTIVE_DATABASE_CONNECTION;
		//this.adhocEditor.saveHTML();
		var adHocSQLText = $(this.elementUniqueID + '_SQL_TEXT_FRAME').value;
		var adHocSQLOptions = $(this.elementUniqueID + '_adhocForm').serialize(true);
		RaiseToTop(this.elementUniqueID + '_RESULT_STAGE', "RESULTS");
		var currentTime = new Date();
		currentTime = (currentTime.getHours()%12) + ":" + (currentTime.getMinutes() < 10 ? "0" + currentTime.getMinutes() : currentTime.getMinutes())+ ":" + (currentTime.getSeconds() < 10 ? "0" + currentTime.getSeconds() : currentTime.getSeconds()) + (currentTime.getHours() > 11 ? " PM" : " AM" );
		$(this.elementUniqueID + "_AdhocExecutionHistory_List").insert({top:"<li><a title=\"" + adHocSQLText.replace(/"/g, "&quot;")+ "\" onclick=\"$('" + this.elementUniqueID + "_SQL_TEXT_FRAME').value = decodeURIComponent('" + escape(adHocSQLText) + "'); closeOpenFloatingObject();\">" + currentTime + "</a></li>"});
		var queryPack = this.analyzeQuery(adHocSQLText, adHocSQLOptions.STMTermChar);
		$i = 0;
		queryPack.each(function(item) {
			parameters['SQL[' + $i + ']'] = item.serverQuery;
			$i++;
		});
		keys = Object.keys(adHocSQLOptions);
		keys.each(function(key){
			parameters[key] = adHocSQLOptions[key];
		});
		parameters["returntype"] = 'JSON';
		new Ajax.Request( service, {
				'parameters': parameters,
			'method': 'post',
			'onCreate': function() {
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				var OldResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_OLD");
				if($(parameters.pageID) != null)
				{
					var tempHTML = CurrentResultHolder.innerHTML;
					CurrentResultHolder.update("");
					OldResultHolder.insert({top:tempHTML});
					var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
					adhocStore = mainResultArea.innerHTML;
					mainResultArea.update("<table width='100%' height='100%'cellspacing='0' cellpadding='0' align='center' valign='center'><tr><td align='center'><img style='float:none;' src='images/loadingpage.gif'/></td></tr></table>");
					mainResultArea.scrollTop = 0;
				}
			},
			'onSuccess': function(transport) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					var results = transport.responseJSON;
					var totalResultSets = 0;
					if(results != null)
					{
						if(thisObject.resultSetStorageHolder != null && thisObject.resultSetStorageName != null && thisObject.resultSetStorageName != "")
						{
							thisObject.resultSetStorageHolder.set(thisObject.resultSetStorageName, results);
						}
						if(Object.isString(results.returnValue))
						{
							CurrentResultHolder.update("<table class='adhocErrorTable'><tr><td align='center'>" + results.returnValue + "</td></tr></table><hrclass='adhocInnerLine'/>");
						}
						else
						{
							var resultText = "";
							resultText = "<table class='adhocReturnTable'>";
							if(results.returnValue.RunTime != null)
								resultText += "<tr><td width='150px'><b>Time</b></td><td width='3px'>:</td><td>" + results.returnValue.RunTime + "</td></tr>";
							if(results.returnValue.AutoCommit != null)
								resultText += "<tr><td width='150px'><b>Auto commit</b></td><td width='3px'>:</td><td>" + ((results.returnValue.AutoCommit == "true") ? "ON" : "OFF") + "</td></tr>";
							if(results.returnValue.TotalRunDuration != null)
								resultText += "<tr><td width='150px'><b>Total time</b></td><td width='3px'>:</td><td>" + formateTimeForDisplay(results.returnValue.TotalRunDuration) + "</td></tr>";
							if(results.returnValue.STMTRun != null && results.returnValue.STMTReceived != null)
								resultText += "<tr><td width='150px'><b>Statement executed</b></td><td width='3px'>:</td><td>" + results.returnValue.STMTRun + " of " + results.returnValue.STMTReceived + "</td></tr>";;
							var STMTNum = 0;
							var numOfStatments = results.returnValue.STMTReturn.length;
							results.returnValue.STMTReturn.each( function (stmtNode) {
								STMTNum++;
								resultText +="</table>";
								var StatementResult = true;
								var numOfResultSets = stmtNode.resultSet.length;
								stmtNode.STMTMSG = stmtNode.STMTMSG == null ? "" : stmtNode.STMTMSG;
								stmtNode.STMTError = stmtNode.STMTError == null ? "" : stmtNode.STMTError;
								StatementResult = "";
								if(stmtNode.STMTError == "" && stmtNode.STMTMSG == "" && stmtNode.statementSucceed)
								{
									StatementResult = "<b style='color:green;'>SUCCEEDED</b>";
								}
								else if((stmtNode.STMTError != "" || stmtNode.STMTMSG != "") && stmtNode.statementSucceed)
								{
									StatementResult = "<b style='color:orange;'>SUCCEEDED WITH WARNING</b>";
								}
								else if(stmtNode.STMTError == "" && stmtNode.STMTMSG == "" && !stmtNode.statementSucceed)
								{
									StatementResult = "<b style='color:red;'>FAILED WITH NO WARNING</b>";
								}
								else
								{
									StatementResult = "<b style='color:red;'>FAILED</b>";
								}
								var errorMSG = stmtNode.STMTMSG.escapeHTML();
								if(errorMSG != "" && errorMSG != null)
								{
									var errorResults = /\s([a-zA-Z][a-zA-Z][a-zA-Z])([0-9]+)([a-zA-Z]?)(\s?)/i.exec(errorMSG);
									if(errorResults)
									{
										while(errorResults[2].length != 5)
											errorResults[2] = "0" + errorResults[2];
										var errorCodeLink = "<a onclick='OpenURLInFloatingWindow(\"http://publib.boulder.ibm.com/infocenter/db2luw/v9r5/topic/com.ibm.db2.luw.messages."
													+ errorResults[1].toLowerCase()
													+ ".doc/doc/m" + errorResults[1].toLowerCase()
													+ errorResults[2] + errorResults[3].toLowerCase() + ".html?noframes=true\")'>" + errorResults[0] + "</a>";
										errorMSG = errorMSG.replace(errorResults[0], errorCodeLink);
									}
								}
								resultText += "<div class='adhocStmt'>";
								resultText += "<b>Statement&nbsp;" + STMTNum + "</b>&nbsp;&nbsp;&nbsp;"+ StatementResult + "<br/>";
								if(stmtNode.STMT != "")
								{
									resultText += "<div class='adhocStmtDisplay'><pre><code>" + codeHighlight("DB2_SQL", stmtNode.STMT, null, null, null, null) + "</code></pre></div>";
								}
								if(numOfResultSets > 1)
									resultText += "<b>Result&nbsp;sets&nbsp;returned:</b>&nbsp;&nbsp;" + numOfResultSets + "<br/>";
								if(stmtNode.STMTError != "")
									resultText += "<b>Return&nbsp;code:</b>&nbsp;&nbsp;" + stmtNode.STMTError + "<br/>";
								if(errorMSG != "")
									resultText += "<b>Return&nbsp;message</b><br/><div class='adhocStmtDisplay'>" + errorMSG + "</div>";
								if (stmtNode.runDuration != null && stmtNode.TotalRunDuration != null)
									resultText += "<b>Time:</b>&nbsp;&nbsp;" + formateTimeForDisplay(stmtNode.TotalRunDuration) + " / " + formateTimeForDisplay(stmtNode.runDuration) + "&nbsp;&nbsp;&nbsp;&nbsp;(Total&nbsp;/&nbsp;Data&nbsp;server)&nbsp;&nbsp;" + Math.round((10000-(stmtNode.runDuration/stmtNode.TotalRunDuration)*10000))/100.0 + "% overhead<br/>";
								if(stmtNode.parameters != null)
								{
									try
									{
										var QueryParameters = new Hash(stmtNode.parameters);
										resultText += "<b>Parameters</b><br/>";
										QueryParameters.each(function(AParameter) {
											resultText += "<div class='adhocStmtDisplay'>" + AParameter.key + ":<br/><div class='adhocStmtDisplay'>" + AParameter.value + "</div>" + "</div>";
										});
									}
									catch(e)
									{
									}
								}
								resultText += "</div>"
								resultText +="<hr class='adhocInnerLine'/>";
								var LOBLinkBasePart1 = '<form id="' + thisObject.elementUniqueID + '_';
								var LOBLinkBasePart2 = '" target="_blank" action="' + DB2MC_SERVER + "/" + ACTION_PROCESSOR + '?action=echoBase64" method="POST"><input type="hidden" name="data" value="';
								var LOBLinkBasePart3 = '"><input type="hidden" name="type" value="';
								var LOBLinkBasePart4 = '"><img onclick="submiteFormToNewWindowInStage(\'' + thisObject.elementUniqueID + '_';
								var LOBLinkBasePart5 = '\',\'FloatingStage\')" src="images/sout.gif"></form>';
							if(numOfResultSets != 0)
							 {
									var ResultNum = 0;
									stmtNode.resultSet.each( function(resultSet) {
										totalResultSets++;
										if(resultSet.data.length == 0 && resultSet.columnsInfo.num == 0)
										{
											thisObject.AllreadyRunning = false;
											return;
										}
										ResultNum++;
										var RAWdata = "<div id='title'>Result " + STMTNum + " of " + results.returnValue.STMTReceived + (numOfResultSets > 1 ? " (" + ResultNum + "/" + numOfResultSets + ")" : "" ) + "</div>";
										thisObject.IDCounter++;
										if(ALLOW_DISPLAY_OF_XML)
										{
											try {
												RAWdata += '<div id="pageLeftMenu"><form style="float:left;margin-bottom:0px;" id="' + thisObject.elementUniqueID + '_' + thisObject.IDCounter + '" target="_blank" action="' + DB2MC_SERVER + "/" + ACTION_PROCESSOR + '?action=echo" method="POST"><textarea name="data" style="display:none;">' + Object.toHTML(thisObject.buildTableDefinitionFromResultSet(stmtNode.STMT, resultSet.columnsInfo)) + '</textarea><input type="hidden" name="type" value="xml">Generate&nbsp;table&nbsp;definition&nbsp;XML:&nbsp;&nbsp;&nbsp;<a onclick="submiteFormToNewWindowInStage(\'' + thisObject.elementUniqueID + '_' + thisObject.IDCounter + '\',\'' + thisObject.parentStageID + '\')" src="images/sout.gif">View&nbsp;&nbsp;&nbsp;</a><a onclick="submiteFormToNewWindowInStage(\'' + thisObject.elementUniqueID + '_' + thisObject.IDCounter + '\',\'' + thisObject.parentStageID + '\', \'' + DB2MC_SERVER + "/" + ACTION_PROCESSOR + '?action=echo&saveAsFile=adhockTableDef.xml\', true)" src="images/sout.gif">Save&nbsp;&nbsp;&nbsp;</a></form></div>';
											} catch(e){
												alert(e);
											}
										}
										RAWdata += "<table cellpadding='5'><tr id='TableTitlerRow'><td></td>";
										var i = 0;
										for(i = 0; i < resultSet.columnsInfo.num ; i++)
										{
											RAWdata += "<td><b>" + resultSet.columnsInfo.name[i] + "</b><br/>(" + resultSet.columnsInfo.type[i] + ")</td>";
										}
										RAWdata += "</tr>";
										var rowID = "";
										var rowCount = 0;
										resultSet.data.each(function (dataRow) {
											rowCount++;
											rowID = rowID == "TableRowA" ? "TableRowB" : "TableRowA";
											RAWdata += "<tr id='" + rowID + "'><td>" + rowCount + "</td>";
											var i = 0;
											for(i = 0; i < resultSet.columnsInfo.num ; i++)
											{
												thisObject.IDCounter++;
												try
												{
													switch(resultSet.columnsInfo.type[i])
													{
														case "xml":
															RAWdata += "<td><pre><code>";
															if ( parameters.displayXML) {
																if(parameters.displayXMLinline)
																{
																		if(Object.isString(dataRow[i]))
																	{
																		RAWdata += dataRow[i].escapeHTML();
																	}
																	else
																	{
																		if(dataRow[i] != null)
																		{
																			RAWdata += dataRow[i].escapeHTML();
																		}
																		else
																		{
																			RAWdata += "<font style='color:red;font-weight: bold;'>null</font>";
																		}
																	}
																}
																else
																{
																	RAWdata += LOBLinkBasePart1 + thisObject.IDCounter + LOBLinkBasePart2 + dataRow[i] + LOBLinkBasePart3 + "xml" + LOBLinkBasePart4 + thisObject.IDCounter + LOBLinkBasePart5;
																}
															}
															else
															{
																RAWdata += "(XML)";
															}
															RAWdata += "</code></pre></td>";
															break;
														case "clob":
															RAWdata += "<td><pre><code>";
															if ( parameters.displayCLOB) {
																if(parameters.displayCLOBinline)
																{
																	if(Object.isString(dataRow[i]))
																	{
																		RAWdata += dataRow[i].escapeHTML();
																	}
																	else
																	{
																		if(dataRow[i] != null)
																		{
																			RAWdata += dataRow[i].escapeHTML();
																		}
																		else
																		{
																			RAWdata += "<font style='color:red;font-weight: bold;'>null</font>";
																		}
																	}
																}
																else
																{
																	RAWdata += LOBLinkBasePart1 + thisObject.IDCounter + LOBLinkBasePart2 + dataRow[i] + LOBLinkBasePart3 + "clob" + LOBLinkBasePart4 + thisObject.IDCounter + LOBLinkBasePart5;
																}
															}
															else
															{
																RAWdata += "(CLOB)";
															}
															RAWdata += "</code></pre></td>";
															break;
														case "blob":
															RAWdata += "<td>" + ( parameters.displayBLOB ? (LOBLinkBasePart1 + thisObject.IDCounter + LOBLinkBasePart2 + dataRow[i] + LOBLinkBasePart3 + "blob" + LOBLinkBasePart4 + thisObject.IDCounter + LOBLinkBasePart5) : "(BLOB)") + "</td>";
															break;
														case "dbclob":
															RAWdata += "<td>" + ( parameters.displayDBCLOB ? (LOBLinkBasePart1 + thisObject.IDCounter + LOBLinkBasePart2 + dataRow[i] + LOBLinkBasePart3 + "dbclob" + LOBLinkBasePart4 + thisObject.IDCounter + LOBLinkBasePart5) : "(DBCLOB)") + "</td>";
															break;
														default:
															RAWdata += "<td>";
																	if(Object.isString(dataRow[i]))
																	{
																		RAWdata += "<pre><code>" + dataRow[i].escapeHTML() + "</code><pre>";
																	}
																	else
																	{
																		if(dataRow[i] != null)
																		{
																			RAWdata += "<pre><code>" + dataRow[i] + "</code><pre>";
																		}
																		else
																		{
																			RAWdata += "<font style='color:red;font-weight: bold;'>null</font>";
																		}
																	}
															 RAWdata += "</td>";
															 break;
													}
												}
												catch(E)
												{
														RAWdata += "<td><a onclick='loadNewPageLayout(({target:\"_blank\", windowStage:\"" + parameters.stageID + "\", raiseToTop:\"y\", content:{ type:\"panel\", name:\"Menu\", PrimaryContainer:true,ContentType:\"RAW\",data:\"" + encodeURIComponent(dataRow[i]) + "\"}}));' style='color:red;'>ERROR</a></td>";
												}
											}
											RAWdata += "</td></tr>";
										});
										RAWdata += "</table>";
										OpenWindow({"target":"_blank","windowStage": parameters.pageID + "_RESULT_STAGE","raiseToTop":"y","content":{"type":"panel","name":"main","PrimaryContainer":true,"ContentType":"RAW","data": RAWdata }}, NORMAL);
									});
								}
							});
							resultText += "</tr></table><br/>";
							if(totalResultSets > 1 || numOfStatments > 1)
							{
								RaiseToTop(thisObject.elementUniqueID + '_RESULT_STAGE', "RESULTS");
							}
							CurrentResultHolder.update("" + resultText);
						}
					}
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			},
			'onFailure': function(transport) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					CurrentResultHolder.insert({top:"" + transport.responseText + "\n<hr class='adhocInnerLine'/>"});
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			},
			'onException': function(transport,exception) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					CurrentResultHolder.insert({top:"Exception while loading table data"+exception + "\n<hr class='adhocInnerLine'/>"});
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			}
			});
	},
	executScript: function(outputStage) {
		var adhocStore = "";
		var thisObject = this;
		var parameters = new Object();
		parameters.pageID = this.elementUniqueID;
		parameters.stageID = this.parentStageID;
		parameters.windowID = this.parentWindowID;
		parameters.panelID = this.parentPanelID;
		parameters.resultStageID = outputStage;
		parameters.USE_CONNECTION = ACTIVE_DATABASE_CONNECTION;
		RaiseToTop(this.elementUniqueID + '_RESULT_STAGE', "RESULTS");
		//this.adhocEditor.saveHTML();
		var adHocSQLText = $(this.elementUniqueID + '_SQL_TEXT_FRAME').value;
		var adHocSQLOptions = $(this.elementUniqueID + '_adhocForm').serialize(true);
		var currentTime = new Date();
		currentTime = (currentTime.getHours()%12) + ":" + (currentTime.getMinutes() < 10 ? "0" + currentTime.getMinutes() : currentTime.getMinutes())+ ":" + (currentTime.getSeconds() < 10 ? "0" + currentTime.getSeconds() : currentTime.getSeconds()) + (currentTime.getHours() > 11 ? " PM" : " AM" );
		$(this.elementUniqueID + "_AdhocExecutionHistory_List").insert({top:"<li><a title=\"" + adHocSQLText.replace(/"/g, "&quot;")+ "\" onclick=\"$('" + this.elementUniqueID + "_SQL_TEXT_FRAME').value = decodeURIComponent('" + encodeURIComponent(adHocSQLText) + "'); closeOpenFloatingObject();\">" + currentTime + "</a></li>"});
		parameters['SHELL'] = adHocSQLText;
		parameters["returntype"] = 'JSON';
		parameters["maxRunTime"] = adHocSQLOptions['maxRunTime'];
		parameters["termCharater"] = adHocSQLOptions['termCharater'];
		new Ajax.Request( ACTION_PROCESSOR + "?action=executeShell", {
				'parameters': parameters,
			'method': 'post',
			'onCreate': function() {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				var OldResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_OLD");
				if($(parameters.pageID) != null)
				{
					var tempHTML = CurrentResultHolder.innerHTML;
					CurrentResultHolder.update("");
					OldResultHolder.update(tempHTML + OldResultHolder.innerHTML);
					adhocStore = mainResultArea.innerHTML;
					mainResultArea.update("<table width='100%' height='100%' cellspacing='0' cellpadding='0' align='center' valign='center'><tr><td align='center'><img style='float:none;' src='images/loadingpage.gif'/></td></tr></table>");
					mainResultArea.scrollTop = 0;
				}
			},
			'onSuccess': function(transport) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					var results = transport.responseJSON;
					if(results != null)
					{
						if(results.flagGeneralError == true)
						{
							CurrentResultHolder.insert({top:"<table class='adhocErrorTable'><tr><td align='center'>" + results.returnValue + "</td></tr></table><hrclass='adhocInnerLine'/>"});
						}
						else if(results.returnCode == false)
						{
							CurrentResultHolder.insert({top:"<table class='adhocErrorTable'><tr><td align='center'>" + results.message + "</td></tr></table><hrclass='adhocInnerLine'/>"});
						}
						else
						{
							var resultText = "<table class='adhocReturnTable'>"
							+"<tr><td width='150px'>Return message</td><td width='3px'>:</td><td>" + results.message + "</td></tr>"
							+"<tr><td width='150px'>Result summary</td><td width='3px'>:</td><td><hr/>";
							results.returnValue.each( function (stmtNode) {
								stmtNode.output = stmtNode.output.replace("\n\r","<br/>");
								stmtNode.output = stmtNode.output.replace("\n","<br/>");
								resultText +="<table class='adhocStmt'>";
								resultText += "<tr><td width='150px'>Command executed</td><td width='3px'>:</td><td>" + stmtNode.command + "</td></tr>";
								resultText += "<tr><td width='150px'>Result output</td><td width='3px'>:</td><td>" + stmtNode.output + "</td></tr>";
								resultText += "</table>";
								resultText +="<hr/>";
							});
							resultText += "</td></tr></table>";
							CurrentResultHolder.insert({top:resultText + "<hr/>"});
						}
					}
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			},
			'onFailure': function(transport) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					CurrentResultHolder.insert({top:"" + transport.responseText + "\n<hr/>"});
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			},
			'onException': function(transport) {
				var mainResultArea = $(thisObject.elementUniqueID + "_RESULT_STAGE_RESULTS_main");
				mainResultArea.update(adhocStore);
				var CurrentResultHolder = $(thisObject.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN");
				if(CurrentResultHolder != null)
				{
					CurrentResultHolder.insert({top:"" + transport.responseText + "\n<hr/>"});
					mainResultArea.scrollTop = 0;
				}
				thisObject.AllreadyRunning = false;
			}
			});
	},
	clearResults: function() {
		$(this.elementUniqueID + "_SQL_RESULT_RETURN_THIS_RUN").update("");
		$(this.elementUniqueID + "_SQL_RESULT_RETURN_OLD").update("");
		STAGE_activeStages.get(this.LocalStage).closeAllWindows();
	},
sizeWidth: function(Amount) {
	this.setWidth(Amount);
},
sizeHeight: function(Amount) {
	this.setHeight(Amount);
},
setWidth: function(Amount) {
	var offsetAmount = 20;
	var adHocTextContainer = $(this.elementUniqueID + "_SQL_TEXT_CONTAINER");
	var adHocTextArea = $(this.elementUniqueID + "_SQL_TEXT_FRAME");
	var adHocHTMLArea = $(this.elementUniqueID + "_SQL_HTML_FRAME");
	if(!this.AdHocLong)
	{
		var adHocTopFrame = $(this.parentStageID + "_" + this.parentWindowID + "_" + this.elementUniqueID + "_ADHOC_TEXT_PANEL");
	}
	else
	{
		var adHocTopFrame = $(this.elementUniqueID + '_RESULT_STAGE_' + this.elementUniqueID + '_ADHOC_TEXT_WINDOW_' + this.elementUniqueID + '_ADHOC_TEXT_PANEL');
	}
	if(adHocTopFrame != null && adHocTextArea != null)
	{
		adHocTextContainer.setStyle({'width' : (parseInt(adHocTopFrame.getWidth())) + "px"});
		adHocTextArea.setStyle({'width' : (parseInt(adHocTopFrame.getWidth())-offsetAmount) + "px"});
		if(adHocHTMLArea != null)
			adHocHTMLArea.setStyle({'width' : (parseInt(adHocTopFrame.getWidth())-offsetAmount) + "px"});
	}
	var adHocEditor = $(this.elementUniqueID + "_SQL_TEXT_FRAME_editor");
	if(adHocTopFrame != null && adHocEditor != null)
	{
		adHocEditor.setStyle({'width' : (parseInt(adHocTopFrame.getWidth())-offsetAmount) + "px"});
	}
},
setHeight: function(Amount) {
	var offsetAmount = 20;
	var adHocTextContainer = $(this.elementUniqueID + "_SQL_TEXT_CONTAINER");
	var adHocTextArea = $(this.elementUniqueID + "_SQL_TEXT_FRAME");
	var adHocHTMLArea = $(this.elementUniqueID + "_SQL_HTML_FRAME");
	var adHocTopFrame = null;
	if(!this.AdHocLong)
	{
		adHocTopFrame = $(this.parentStageID + "_" + this.parentWindowID + "_" + this.elementUniqueID + "_ADHOC_TEXT_PANEL");
	}
	else
	{
		adHocTopFrame = $(this.elementUniqueID + '_RESULT_STAGE_' + this.elementUniqueID + '_ADHOC_TEXT_WINDOW_' + this.elementUniqueID + '_ADHOC_TEXT_PANEL');
	}
	if(adHocTopFrame != null && adHocTextArea != null && adHocTextContainer != null)
	{
		adHocTextContainer.setStyle({'height' : (parseInt(adHocTopFrame.getHeight())) + "px"});
		adHocTextArea.setStyle({'height' : (parseInt(adHocTopFrame.getHeight()) - (offsetAmount)) + "px"});
		if(adHocHTMLArea != null)
			adHocHTMLArea.setStyle({'height' : (parseInt(adHocTopFrame.getHeight()) - (offsetAmount)) + "px"});
	}
	var adHocEditor = $(this.elementUniqueID + "_SQL_TEXT_FRAME_editor");
	if(adHocTopFrame != null && adHocEditor != null)
	{
		adHocEditor.setStyle({'height' : (parseInt(adHocTopFrame.getHeight()) - (offsetAmount)) + "px"});
	}
},
changeScriptMode: function(scriptMode) {
	scriptMode = scriptMode.toUpperCase();
	if(scriptMode != "SQL" && scriptMode != "JSQL" && scriptMode != "SHELL")
		scriptMode = "SQL";
	this.scriptMode = scriptMode;
	if(scriptMode == "SQL" || scriptMode == "JSQL")
	{
		if(scriptMode == "SQL")
		{
			$(this.elementUniqueID + '_OptionScriptModeSQL').checked=true;
		}
		else
		{
			$(this.elementUniqueID + '_OptionScriptModeJSQL').checked=true;
		}
		$(this.elementUniqueID + "_SQLOptions").show();
		$(this.elementUniqueID + "_SHELLOptions").hide();
		$(this.elementUniqueID + "_OptionCommit").enable();
 		$(this.elementUniqueID + "_OptionTermChar").enable();
		$(this.elementUniqueID + "_OptionRows").enable();
		$(this.elementUniqueID + "_OptionXML").enable();
		$(this.elementUniqueID + "_OptionCLOB").enable();
		$(this.elementUniqueID + "_OptionBLOB").enable();
		$(this.elementUniqueID + "_OptionBDCLOB").enable();
		$(this.elementUniqueID + "_OptionMaxRunTime").disable();
	}
	else if(scriptMode == "SHELL")
	{
		$(this.elementUniqueID + '_OptionScriptModeSSH').checked=true;
		$(this.elementUniqueID + "_SQLOptions").hide();
		$(this.elementUniqueID + "_SHELLOptions").show();
		$(this.elementUniqueID + "_OptionCommit").disable();
 		$(this.elementUniqueID + "_OptionTermChar").disable();
		$(this.elementUniqueID + "_OptionRows").disable();
		$(this.elementUniqueID + "_OptionXML").disable();
		$(this.elementUniqueID + "_OptionCLOB").disable();
		$(this.elementUniqueID + "_OptionBLOB").disable();
		$(this.elementUniqueID + "_OptionBDCLOB").disable();
		$(this.elementUniqueID + "_OptionMaxRunTime").enable();
	}
	FLOATINGPANEL_activeFloatingPanels.get(this.elementUniqueID + "_AdhocOptions").size();
},
buildTableDefinitionFromResultSet: function(stmt, columnsInfo)
{
	var columns = "";
	var displayColumns = "";
	var i = 0;
	for(i = 0; i < columnsInfo.num; i++)
	{
		columns += '		<col type="column" name="' + columnsInfo.name[i] + '"/>\n';
		displayColumns += '	<column name="' + columnsInfo.name[i] + '">\n';
		displayColumns += '		<c_sql_name>' + columnsInfo.name[i] + '</c_sql_name>\n';
		displayColumns += '		<c_title>' + columnsInfo.name[i] + '</c_title>\n';
		displayColumns += '		<c_presentation>';
		var match1 = /long varchar|clob|blob|xml/;
		var match2 = /char|string|/;
		var match3 = /char|string|date/;
		if(columnsInfo.type[i].toLowerCase().match(match1) != null)
			displayColumns += 'y';
		else if(columnsInfo.type[i].match(match2) != null)
			displayColumns += '';
		else
			displayColumns += 'n';
		displayColumns += '</c_presentation>\n';
		displayColumns += '		<c_drill>';
		if(columnsInfo.type[i].toLowerCase().match(match3) != null)
			displayColumns += 'y';
		else
			displayColumns += 'n';
		displayColumns += '</c_drill>\n';
		displayColumns += '	</column>\n';
	}
	var output = '';
	output += '<table name="Unknown">\n';
	output += '	<sql_name>Unknown</sql_name>\n';
	output += '	<singular_name>Unknown</singular_name>\n';
	output += '	<plural_name>Unknown</plural_name>\n';
	output += '	<inlinequery>\n';
	output += '<![CDATA[\n';
	output += stmt;
	output += '\n]]>\n';
	output += '	</inlinequery>\n';
	output += '	<description>Query from ad hoc</description>\n';
	output += '	<rows_per_page>50</rows_per_page>\n';
	output += '	<order_by_index></order_by_index>\n';
	output += '	<display_columns>\n';
	output += columns;
	output += '	</display_columns>\n';
	output += displayColumns;
	output += '</table>\n';
	return output;
}
}));