/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
var graphContainer = Class.create(basePageElement, {
	initialize: function($super, ContainerID, StageID, WindowID, PanelID, PageID, Graph) {
		$super(PageID + "_" + getGUID(), "pageGraph");
		this.parentStageID = StageID;
		this.parentPanelID = PanelID;
		this.parentWindowID = WindowID;
		this.ContainerID = ContainerID;
		this.localGraph = Graph;
		this.title = this.localGraph.getTitle();
		this.tablePadding = 5;
		this.borderOffset = this.tablePadding * 4;
		getWindow(this.parentStageID,this.parentWindowID).WindowContainers.get(this.parentPanelID).registerNestedObject(this.elementUniqueID, this);
	},
	draw: function()
	{
		output = '';
		output += '<table id="' + this.elementUniqueID + '_graphTableHolder"cellpadding="' + this.tablePadding + 'px" cellspacing="0" style="width:500px;height:500px;">';
		output += '<tr id="' + this.elementUniqueID + '_TitleRow" style="height:30px;">';
		output += '<td>';
		output += '<table width="100%" cellpadding="0" cellspacing="0"style="border-bottom-width: 1px;border-bottom-style: solid;border-bottom-color:#454586;">';
		output += '<tr>';
		output += '<td>';
		output += '<span id="' + this.elementUniqueID + '_title" style="font-size: 14pt;font-style: normal;font-weight: bolder;color: #454586;">' + this.title + '</span>';
		output += '</td>';
		if(this.localGraph.updateEnabled)
		{
			output += '<td align="right"> Update Interval';
			output += '<select>';
			output += '<option id="timeOptions_null" onclick="activeGraphs.get(\'' + this.localGraph.elementName + '\').updateGraphTime(null);">Off</option>';
			var timeOptionLength = this.localGraph.updateTimeOption.length;
			for(i = 0; i < timeOptionLength; i++)
			{
				output += "<option onclick='activeGraphs.get(\"" + this.localGraph.elementName + "\").updateGraphTime(" + this.localGraph.updateTimeOption[i] + ");' ";
				if(this.localGraph.updateTimeOption[i] == this.localGraph.updateTime)
				{
					output += "selected";
				}
				output += ">";
				var timeInMin = Math.floor(this.localGraph.updateTimeOption[i]/60000);
				if(timeInMin != 0)
					output +=timeInMin + "m ";
				output +=((this.localGraph.updateTimeOption[i] % 60000)/1000) + "s";
				output += "</option>";
			}
			output += '</select>';
			output += '</td>';
		} //END IF
		output += '</tr>';
		output += '</table>';
		output += '</td>';
		output += '</tr>';
		output += '<tr>';
		output += '<td id="' + this.ContainerID + '">';
		output += '				Unable to load Flash content. The YUI Charts Control requires Flash Player 9.0.45 or higher. ';
		output += '				You can download the latest version of Flash Player from the <a href="http://www.adobe.com/go/getflashplayer">Adobe Flash Player Download Center</a>.';
		output += '</td>';
		output += '</tr>';
		output += '</table>';
		getWindow( this.parentStageID, this.parentWindowID).WindowContainers.get(this.parentPanelID).setContent(output, this.title);
		this.localGraph.draw();
	},
sizeWidth: function(Amount) {
	this.width += Amount;
	var adHocTextArea = $(this.elementUniqueID + '_graphTableHolder');
	if(adHocTextArea != null)
	{
		adHocTextArea.setStyle({'width' : Amount + "px"});
	}
	this.setEmbeddWidth();
},
sizeHeight: function(Amount) {
	this.height += Amount;
	var adHocTextArea = $(this.elementUniqueID + '_graphTableHolder');
	if(adHocTextArea != null)
	{
		adHocTextArea.setStyle({'height' : Amount + "px"});
	}
	this.setEmbeddHeight();
},
setWidth: function(Amount) {
	this.width = Amount;
	var adHocTextArea = $(this.elementUniqueID + '_graphTableHolder');
	if(adHocTextArea != null)
	{
		adHocTextArea.setStyle({'width' : Amount + "px"});
	}
	this.setEmbeddWidth();
},
setHeight: function(Amount) {
	this.height = Amount;
	var adHocTextArea = $(this.elementUniqueID + '_graphTableHolder');
	if(adHocTextArea != null)
	{
		adHocTextArea.setStyle({'height' : Amount + "px"});
	}
	this.setEmbeddHeight();
},
setEmbeddHeight: function() {
	var titleRow = $(this.elementUniqueID + '_TitleRow');
	var theContainer = $(this.ContainerID);
	var titleRowOffset = 0;
	if(titleRow != null)
	{
		titleRowOffset = titleRow.getHeight();
	}
	if(theContainer != null)
 	{
		theContainer.setStyle({'height' : (this.height - (titleRowOffset + this.borderOffset)) + "px"});
	}
},
setEmbeddWidth: function() {
	var theContainer = $(this.ContainerID);
	if(theContainer != null)
 	{
		theContainer.setStyle({'width' : (this.width - this.borderOffset) + "px"});
	}
}
});