/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
CORE_CLIENT_ACTIONS.set("graphYUI",Class.create(CORE_CLIENT_ACTIONS.get("list_table"), {
	initialize: function($super, callParameters) {
		this.firstGraphLoad = true;

		if(callParameters.table != null)
		{
			this.graphName = callParameters.graphName;
			if(this.graphName == null)
				this.graphName = 'default';
			this.graphName = callParameters.graphName != null ? callParameters.graphName.toUpperCase() : this.graphName.toUpperCase();
			$super(callParameters);
			this.buildFromTableDef = true;
			this.baseTableData.graphTitle = "default";
		}
		else if(callParameters.graph != null)
		{

			if(Object.isString(callParameters.graph)) callParameters.graph =eval("(" + callParameters.graph + ")");
			callParameters.INITIALIZE_TABLE_DISPLAY = false;
			$super(callParameters);
			
			this.baseTableData = {};
			this.graphDefinition = callParameters.graph.Graph != null ? callParameters.graph.Graph : callParameters.graph;
			this.baseTableData.graphTitle = this.graphDefinition.title != null ? this.graphDefinition.title : "default";
			this.draw();
			this.buildGraphFromJSON();
			this.baseTableData.graphObj.draw();
		}
		else
		{
			//raise error
			alert("Could not render graph");
		}
	},
	processDispalySetup: function() {

			this.buildGraphFromTableDef();
			this.baseTableData.graphTitle = this.baseTableData.components.graph[this.graphName].title;
	},
	
	renderTableData: function() {
			
			if(this.firstGraphLoad)
			{
				this.firstGraphLoad = false;
				this.baseTableData.graphObj.draw();
			}
			else
			{
				this.buildDataSet();
				this.baseTableData.graphObj.localChart.refreshData();
			}
	},
	
	draw: function()
	{		
		var output = "<table style='width:100%;height:100%;'><tr><td align='center' style='width:100%;height:100%;' id='" + this.elementUniqueID + "_chart" + "'>";
		output += '				Unable to load Flash content. The YUI Charts Control requires Flash Player 9.0.45 or higher. ';
		output += '				You can download the latest version of Flash Player from the <a href="http://www.adobe.com/go/getflashplayer">Adobe Flash Player Download Center</a>.';
		output += "</td></tr></table>";
		//var output = "<div id='" + this.elementUniqueID + "_chart" + "'></div>";
		getPanel(this.parentStageID, this.parentWindowID, this.parentPanelID ).setContent(output, this.baseTableData.graphTitle, null, null, null);
	},
	
	buildGraphFromJSON: function()
	{
		this.baseTableData.graphObj = new pageGraphs(this.elementUniqueID, this.elementUniqueID + '_chart', this.parentStageID, this.parentWindowID, this.parentPanelID, this.parentPageID);
		//this.baseTableData.graphObj.setTitle(this.graphDefinition.title);
		this.baseTableData.graphObj.setGraphType(this.graphDefinition.graphType);
		this.baseTableData.graphObj.setXField(this.graphDefinition.xField);
		this.baseTableData.graphObj.setYField(this.graphDefinition.yField);
		this.baseTableData.graphObj.setDataField(this.graphDefinition.dataField);
		this.baseTableData.graphObj.setCategoryField(this.graphDefinition.categoryField);
		if(this.graphDefinition.dataSourceType == null)
		{
			this.baseTableData.graphObj.setDataSourceType("data_from_raw");
		}
		else
		{
			this.baseTableData.graphObj.setDataSourceType(this.graphDefinition.dataSourceType);
		}
		this.baseTableData.graphObj.setDataResponseSchema(this.graphDefinition.responseSchema);
		this.baseTableData.graphObj.setStyle(this.graphDefinition.style);
		this.baseTableData.graphObj.setSeries(this.graphDefinition.seriesDef);
		this.baseTableData.graphObj.setDataSource(this.graphDefinition.datasets);			
	},
	
	buildGraphFromTableDef: function()
	{
		//Build the graph data but don't render it yet.
		this.baseTableData.graphObj = new pageGraphs(this.elementUniqueID, this.elementUniqueID + '_chart', this.parentStageID, this.parentWindowID, this.parentPanelID, this.parentPageID);
	
		//TODO: Check for null and assign default.
		var tableGraphDef = this.baseTableData.components["graph"][this.graphName];
	
		this.tempAxisDataColumns = [];
		
		//Iterate and find all of the graphing columns; Search for components.axisdataset.
		//var tempAxisDataColumns = this.baseTableData.components.columns;
		
		//foreach this.baseTableData.components as componentGroup 
		// do 
		//	foreach componentGroup as displayColumn 
		//	do 
		//		 if displayColumn.components['axisDataSet'] != null then 
		//			if displayColumn.components['axisDataSet'][name] != null then 
		//			 add to graphColumns
		
		var basecomponents = $H(this.baseTableData.components['column']);
		this.baseTableData.graphObj.setGraphType(tableGraphDef.type);
		var tempAxisType;
		var responseSchema = { fields: []};
		var seriesDef = [];
		this.yAxis = new YAHOO.widget.NumericAxis();
		this.baseTableData.graphObj.setYAxis(this.yAxis);
		this.xAxis = new YAHOO.widget.NumericAxis();
		this.baseTableData.graphObj.setXAxis(this.xAxis);
		var style = null; //TODO: Build default object
		style = tableGraphDef.style;
		this.baseTableData.graphObj.setStyle(style);
		this.baseTableData.graphObj.setDataSourceType('data_from_raw');
		var datasetDef;
		var thisObject = this;
		var datasetDetails;
		basecomponents.each(function(componentGroup) 
		{
			displayColumn = componentGroup.value;
			if(displayColumn.components != null)
			{
				if(displayColumn.components.axisdataset != null)
				{
					datasetDef = $H(displayColumn.components.axisdataset);
					
					datasetDef.each(function(dataset)
					{
						if(dataset.value != null)
						{
							thisObject.tempAxisDataColumns.push({
								name : displayColumn.name,
								type : dataset.value.axisType
							});
							tempAxisType = displayColumn.components.axisdataset[thisObject.graphName].axisType; //Not considering multple graphs
							datasetDetails = $H(displayColumn.components.axisdataset);
							datasetDetails.each(function(axisDetails)
							{
								tempAxisType = axisDetails.value.axisType;
								switch(tempAxisType)
								{
									case 'x_axis_labels':
										thisObject.baseTableData.graphObj.setXField(displayColumn.name);
										break;
									case 'y_axis_labels':
										thisObject.baseTableData.graphObj.setYField(displayColumn.name);
										break;
									case 'category_field':
										thisObject.baseTableData.graphObj.setCategoryField(displayColumn.name);
										break;
									case 'data_field':
										thisObject.baseTableData.graphObj.setDataField(displayColumn.name);
										break;
									default:
										//Do we want to change this so that a bar graph is vertical bars and hbar is horizontal?Currently bar is horizontal, column is vertical.
										switch(tableGraphDef.type)
										{
											case 'bar':
												seriesDef.push({
													displayName : axisDetails.value.label, 
													xField : displayColumn.name,
													style: axisDetails.value.dataStyle
												});
												break;
											case 'line':
											case 'column':
												seriesDef.push({
													displayName : axisDetails.value.label, 
													yField : displayColumn.name,
													style: axisDetails.value.dataStyle
												});
												break;
										}
										break;
								}						
								responseSchema.fields.push(displayColumn.name);
								this.responseSchema = responseSchema;
							});
						}
						else
						{
							alert("The table component of name '" + displayColumn.name + "' in the component group of type '" + componentGroup.type + "' does not exist!");
						}
					});			
				}
			}
		});
		//thisObject.baseTableData.graphObj.setDataResponseSchema(responseSchema);
		thisObject.baseTableData.graphObj.setSeries(seriesDef);
		this.dataObject = new YAHOO.util.FunctionDataSource(function() {
				var tempIndex;
				var value;			
				var tempRow;
				var tempDataset = [];
	
					for(currentRow = 0; currentRow < thisObject.baseTableData.rowsReturned; currentRow++)
					{
						tempRow = {};
						for(var i = 0; i < thisObject.tempAxisDataColumns.length; i++)
						{

							
						tempIndex = thisObject.baseTableData.resultSetIndexByColumnName[thisObject.tempAxisDataColumns[i].name];
						
						var type = DB2_DATA_TYPE_CLASSIFICATION[thisObject.baseTableData.columnsInfo.type[tempIndex].toLowerCase()];
						
						value = thisObject.baseTableData.baseData[currentRow][tempIndex];
							tempRow[thisObject.tempAxisDataColumns[i].name] = (type == DB2_NUMBER ? parseInt(value) : value);				
						}
						tempDataset.push(tempRow);
					}
				return tempDataset;
			});
		this.dataObject.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
		this.dataObject.responseSchema = responseSchema;
		thisObject.baseTableData.graphObj.setDataObject(this.dataObject);
	},
	
	buildDataSet: function()
	{
		var thisObject = this;
		this.dataObject = new YAHOO.util.FunctionDataSource(function() {
				var tempIndex;
				var value;			
				var tempRow;
				var tempDataset = [];
				var j = 1;
					for(currentRow = 0; currentRow < thisObject.baseTableData.rowsReturned; currentRow++)
					{
						tempRow = {};
						for(var i = 0; i < thisObject.tempAxisDataColumns.length; i++)
						{
							
						tempIndex = thisObject.baseTableData.resultSetIndexByColumnName[thisObject.tempAxisDataColumns[i].name];
						
						var type = DB2_DATA_TYPE_CLASSIFICATION[thisObject.baseTableData.columnsInfo.type[tempIndex].toLowerCase()];
						
						value = thisObject.baseTableData.baseData[currentRow][tempIndex];
							tempRow[thisObject.tempAxisDataColumns[i].name] = (type == DB2_NUMBER ? parseInt(value) : value);				
						}
						tempDataset.push(tempRow);
					}
				return tempDataset;
			});
		this.dataObject.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
		this.dataObject.responseSchema = responseSchema;
		//thisObject.baseTableData.graphObj.setDataObject(this.dataObject);
		thisObject.baseTableData.graphObj._dataSource = this.dataObject;
		
				/*var tempIndex;
				var value;			
				var tempRow;
				var tempDataset = [];
				var thisObject = this;
	
					for(currentRow = 0; currentRow < thisObject.baseTableData.rowsReturned; currentRow++)
					{
						tempRow = {};
						for(var i = 0; i < thisObject.tempAxisDataColumns.length; i++)
						{
							
						tempIndex = thisObject.baseTableData.resultSetIndexByColumnName[thisObject.tempAxisDataColumns[i].name];
						
						var type = DB2_DATA_TYPE_CLASSIFICATION[thisObject.baseTableData.columnsInfo.type[tempIndex].toLowerCase()];
						
						value = thisObject.baseTableData.baseData[currentRow][tempIndex];
							tempRow[thisObject.tempAxisDataColumns[i].name] = (type == DB2_NUMBER ? parseInt(value) : value);				
						}
						tempDataset.push(tempRow);
					}
					this.dataObject = new YAHOO.util.DataSource(tempDataset);
					this.dataObject.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
					this.dataObject.responseSchema = responseSchema;
					thisObject.baseTableData.graphObj._dataSource = this.dataObject;*/
	}
	//end of functions
}));