/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("DELTA", {
	
	currentDataReturn : "?dynamic_name?_DELTA || ' / ' || ?dynamic_name?_TIME || ' s'",
	
	dataHistoryRetrieval : "?dynamic_name? BIGINT PATH '@?dynamic_ID?', ?dynamic_name?_DELTA varchar(256) PATH '@?dynamic_ID?D'," +
			"?dynamic_name?_TIME varchar(256) PATH '@?dynamic_ID?T'",
	
	dataToArchive : "cast(CASE WHEN ?dynamic_name? is null THEN 0 ELSE (?column_SQL? - ?dynamic_name?) END as BIGINT) as ?dynamic_ID?D, " +
			"?time_diff? as ?dynamic_ID?T, " +
			"?column_SQL? as ?dynamic_ID?",
	
	firstArchiveReturn : "CAST(null as REAL) as ?dynamic_name?, CAST(null as REAL) as ?dynamic_name?_DELTA, CAST(null as REAL) as ?dynamic_name?_TIME"
});


TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("DELTA_NORMALIZED", {
	
	currentDataReturn : "?dynamic_name?_DELTA_N",
	
	dataHistoryRetrieval : "?dynamic_name?_DELTA_N REAL PATH '@?dynamic_ID?DN', ?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN null " +
			"ELSE CAST(((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) as BIGINT) END as ?dynamic_ID?DN, " +
			"?column_SQL? as ?dynamic_ID?",

	firstArchiveReturn : "CAST(null as REAL) as ?dynamic_name?, CAST(null as REAL) as ?dynamic_name?_DELTA_N"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("AVR_DELTA_NORMALIZED", {
	

	currentDataReturn : "?dynamic_name?_AVR",
	
	dataHistoryRetrieval : "?dynamic_name?_COUNT BIGINT PATH '@?dynamic_ID?C', ?dynamic_name?_AVR REAL PATH '@?dynamic_ID?A', " +
			"?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CAST(CASE WHEN ?dynamic_name? is null THEN 0 " +
			"ELSE (?dynamic_name?_COUNT +1) END as ?dynamic_ID?C, " +
			"CASE WHEN ?dynamic_name? is null THEN 0 " +
			"ELSE ((?dynamic_name?_AVR*?dynamic_name?_COUNT + ((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)))/(?dynamic_name?_COUNT +1)) END AS BIGINT) as ?dynamic_ID?A, " +
			"?column_SQL? as ?dynamic_ID?",
	
	firstArchiveReturn : "CAST(0 as BIGINT) as ?dynamic_name?_COUNT, CAST(0 as REAL) as ?dynamic_name?_AVR, CAST(null as REAL) as ?dynamic_name?"
	
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("AVR", {
	
	currentDataReturn : "?dynamic_name?",
	
	dataHistoryRetrieval : "?dynamic_name?_COUNT BIGINT PATH '@?dynamic_ID?C', ?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "(?dynamic_name?_COUNT +1) as ?dynamic_ID?C, " +
			"((?dynamic_name?*?dynamic_name?_COUNT + ?column_SQL?)/(?dynamic_name?_COUNT +1)) as ?dynamic_ID?",
	
	firstArchiveReturn : "0 as ?dynamic_name?_COUNT, 0 as ?dynamic_name?"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("MAX", {
	
	currentDataReturn : "?dynamic_name?",
	
	dataHistoryRetrieval : "?dynamic_name? BIGINT PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN ?column_SQL? WHEN ?column_SQL? > ?dynamic_name? THEN ?column_SQL? " +
			"ELSE ?dynamic_name? END as ?dynamic_ID?",
	
	firstArchiveReturn : "cast(null as BIGINT) as ?dynamic_name?"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("MAX_DELTA_NORMALIZED", {
	
	currentDataReturn : "?dynamic_name?_MAX",
	
	dataHistoryRetrieval : "?dynamic_name?_MAX REAL PATH '@?dynamic_ID?M', ?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN null " +
			"WHEN ?dynamic_name?_MAX is null " +
				"THEN CAST(((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) as BIGINT) " +
			"WHEN ((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) > ?dynamic_name?_MAX " +
				"THEN CAST(((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) as BIGINT)" +
			"ELSE ?dynamic_name?_MAX END as ?dynamic_ID?M, " +
			"?column_SQL? as ?dynamic_ID?",
	
	firstArchiveReturn : "cast(null as REAL) as ?dynamic_name?, cast(null as REAL) as ?dynamic_name?_MAX"
	
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("MIN", {
	
	currentDataReturn : "?dynamic_name?",
	
	dataHistoryRetrieval : "?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN ?column_SQL? WHEN ?column_SQL? < ?dynamic_name? THEN ?column_SQL? " +
			"ELSE ?dynamic_name? END as ?dynamic_ID?",
	
	firstArchiveReturn : "cast(null as REAL) as ?dynamic_name?"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("MIN_DELTA_NORMALIZED", {
	
	currentDataReturn : "?dynamic_name?_MIN",
	
	dataHistoryRetrieval : "?dynamic_name?_MIN REAL PATH '@?dynamic_ID?M', ?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN null " +
			"WHEN ?dynamic_name?_MIN is null " +
				"THEN CAST(((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) as BIGINT) " +
			"WHEN ((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) < ?dynamic_name?_MIN " +
				"THEN CAST(((?column_SQL? - ?dynamic_name?)/(?time_diff?/?dynamic_interval?)) as BIGINT)" +
			"ELSE ?dynamic_name?_MIN END as ?dynamic_ID?M, " +
			"?column_SQL? as ?dynamic_ID?",
	
	firstArchiveReturn : "cast(null as REAL) as ?dynamic_name?, cast(null as REAL) as ?dynamic_name?_MIN"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("FROM_POINT", {
	
	currentDataReturn : "CASE WHEN ?dynamic_name? is null THEN 0 ELSE (?column_SQL? - ?dynamic_name?) END",
	
	dataHistoryRetrieval : "?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "CASE WHEN ?dynamic_name? is null THEN ?column_SQL? ELSE ?dynamic_name? END as ?dynamic_ID?",
	
	firstArchiveReturn : "cast(null as REAL) as ?dynamic_name?"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("SUM", {
	
	currentDataReturn : "?dynamic_name?",
	
	dataHistoryRetrieval : "?dynamic_name? ?TYPE? PATH '@?dynamic_ID?'",
	
	dataToArchive : "?column_SQL? + ?dynamic_name? as ?dynamic_ID?",
	
	firstArchiveReturn : "0 as ?dynamic_name?"
});

TABLE_COLUMN_RENDERING_MODULES_DYNAMIC_COLUMN_TYPE_DEF.set("TIME_INTERVAL", {
	
	currentDataReturn : "cast(?dynamic_name? as REAL)",
	
	dataHistoryRetrieval : "?dynamic_name? REAL PATH '@?dynamic_ID?'",
	
	dataToArchive : "(?time_diff?/?dynamic_interval?) as ?dynamic_ID?",
	
	firstArchiveReturn : "0 as ?dynamic_name?"
});
