/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/

TABLE_MANIPULATION_MODULES.set("Core_Search", {
	
	panelLeftMenuObject: function(tableObject, menuArray) {
	
		if(tableObject.baseTableData.detailedView == true) return menuArray;
		
		if(tableObject.baseTableData.detailedView == true) return menuArray;
		var sortPanel = new floatingPanel(tableObject.elementUniqueID + '_SortDialog', 'RAW', "", tableObject.elementUniqueID + '_SortDialog_button', false, false);
		getWindow(tableObject.parentStageID,tableObject.parentWindowID).WindowContainers.get(tableObject.parentPanelID).registerNestedObject(tableObject.elementUniqueID + '_SortDialog', sortPanel);
		sortPanel.draw();

		
		menuArray.push({
				nodeType : "leaf",
				elementID : tableObject.elementUniqueID + '_SortDialog_button',
				elementValue : "Search",
				elementAction : 'onClick="TABLE_MANIPULATION_MODULES.get(\'Core_Search\').updateOnNoChage(\'' + tableObject.elementUniqueID + '\');FLOATINGPANEL_activeFloatingPanels.get(\'' + tableObject.elementUniqueID + '_SortDialog\').show_and_size(\'' + tableObject.elementUniqueID + '_SortDialog_button\');"'
		});
		return menuArray;
	},
	
	updateOnNoChage:function(tableID)
	{
			var tableObject = activeTables.get(tableID);
			var sortChange = $(tableID + "_SortPanelChangeNotification");
			if(tableObject.baseTableData.SortManipulationHasOccured == null || tableObject.baseTableData.SortManipulationHasOccured == false)
			{
				this.draw(tableID);
			}
			else if(sortChange != null)
			{
				if(tableObject.baseTableData.searchStartJSONText != null && tableObject.baseTableData.searchStartJSONText != Object.toJSON(tableObject.baseTableData.where))
				{
					sortChange.show();
				}
				else
				{
					sortChange.hide();
				}
			}
	},

	draw: function(tableID) {
		var sortPanel = FLOATINGPANEL_activeFloatingPanels.get(tableID + '_SortDialog')
		var tableObject = activeTables.get(tableID);

		tableObject.baseTableData.SortManipulationHasOccured = false;

		var nodeStack = [];
		var indexStack = [];

		var output = "";

		rootNode = tableObject.baseTableData.where;
		tableObject.baseTableData.searchStartJSONText = Object.toJSON(rootNode);
		rootNode = eval("(" + tableObject.baseTableData.searchStartJSONText + ")");
		
		if(rootNode == null)
		{
			rootNode = {
								type:"group",
								Operand: "AND",
								groupNodes: [{
								type: "value",
								column: "",
								compareType: "",
								value: ""
							}]
							};
		}
		if(rootNode.type.toLowerCase() != "group")
		{
			rootNode = {
								type:"group",
								Operand: "AND",
								groupNodes: [rootNode]
							};
		}
		tableObject.baseTableData.searchManipulationWhereObject = rootNode;
		
		
		output += "<table style='width:500px;padding-right:20px' cellpadding='0px' cellspacing='0px'>";
			output += "<tbody>";
				output += "<tr>";
					output += "<td id='" + tableID + "_SortPanelChangeNotification' style='display:none;background-color:lightgrey;'>";
						output += "<table style='width:100%'>";
							output += "<tbody>";
								output += "<tr>";
									output += "<td>";
										output += "External Changes";
									output += "</td>";
									output += "<td align='right'>";
										output += "<button onclick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').draw('" + tableObject.elementUniqueID + "');\">Reset search fields</button>";
									output += "</td>";
								output += "</tr>";
							output += "</tbody>";
						output += "</table>";
					output += "</td>";
				output += "</tr>";
				output += "<tr>";
					output += "<td id='" + tableID + "_SortPanelParameters'>";
					output += "</td>";
				output += "</tr>";
				output += "<tr>";
					output += "<td id='" + tableID + "_SortPanelRootNode'>";
					output += "</td>";
				output += "</tr>";
			output += "</tbody>";
		output += "</table>";
		
		
		var menu = [{
				nodeType : "leaf",
				elementValue : "Reset",
				elementAction : "onclick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').draw('" + tableObject.elementUniqueID + "');\""
		},{
				nodeType : "leaf",
				elementValue : "Apply search",
				elementAction : "onclick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').applySearchFilter('" + tableObject.elementUniqueID + "');\""
		}];
		
		sortPanel.setContent(output, 'Table sort manager', null, null, menu);
		
		this.insertParameters(tableObject);
		
		this.insertGroupInto(tableObject, tableID + "_SortPanelRootNode", rootNode, "");
		
		var holdingContainer = FLOATINGPANEL_activeFloatingPanels.get(tableID + '_SortDialog');
		if(holdingContainer != null)
			if(holdingContainer.size != null)
				holdingContainer.size();
		
	},
	
	insertParameters: function(tableObject) {
		var locationObject = $(tableObject.elementUniqueID + "_SortPanelParameters");
		if(tableObject.baseTableData.parameters != null)
		{
			if(tableObject.baseTableData.parameters.length > 0)
			{
				locationObject.insert({bottom:'<div class="groupTableTitle">Query parameters:</div>'});
				tableObject.baseTableData.parameters.each(function (parm)
				{
					var output = "";
					
					output += "<div style='margin-left:5px;margin-bottom:5px;padding:2px;width=100%;height=100%;border-width:1px;border-style:solid;border-color:black;'>";
					output += "<table style='width:100%;height:100%;'cellpadding='0px' cellspacing='0px'>";
					output += "<tbody>";
					output += "<tr><td style='background-color:#EDEDED;'>";
					output += parm.title + " (" + (parm.type == "s" ? "String" : (parm.type == "n" ? "Number" : "Mixed")) + ")";
					output += "</td></tr>";
					output += "<tr><td>";
					output += "<input id='" + tableObject.elementUniqueID + "_parameters_" + parm.name + "' type='text' id='value' style='width:95%;display:block;' name='TE_DATABASE_LOGIN_COMMENT'/>"
					output += "</td></tr>";
					output += "</tbody>";
					output += "</table>";
					output += "</div>";
					locationObject.insert({bottom:output});
					$(tableObject.elementUniqueID + "_parameters_" + parm.name).value = parm.value;
				});
				locationObject.insert({bottom:'<div class="groupTableTitle">Search operation:</div>'});
			}
		}
		
	},
	
	insertGroupInto: function(tableObject, locationID, groupNode, accessPath)
	{
		var locationObject = $(locationID);
		if(locationObject)
		{
			var id = getGUID();
			var output = "";
			
			output += "<div id='" + locationID + "_" + id + "_Main' style='margin-left:5px;margin-bottom:5px;padding:2px;width=100%;height=100%;border-width:1px;border-style:solid;border-color:black;'>";
			output += "<table style='width:100%;height:100%;'cellpadding='0px' cellspacing='0px'>";
			output += "<tbody>";
			output += "<tr><td style='padding:3px;background-color:black;'>";
			output += "<table style='width:100%;' cellpadding='0px' cellspacing='0px'><tbody><tr><td><font style='color:white;'>&nbsp;&nbsp;Group:&nbsp;</font>";
			output += "<button onClick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').addObject('" + tableObject.elementUniqueID + "', 'CONDITION', '" + locationID + "_" + id + "', '" + accessPath + "');\">Add condition</button>&nbsp;";
			output += "<button onClick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').addObject('" + tableObject.elementUniqueID + "', 'GROUP', '" + locationID + "_" + id + "', '" + accessPath + "');\">Add group</button>";
			output += "</td><td align='right'><font style='color:white;'>Type:&nbsp;</font><select type='text'onchange='TABLE_MANIPULATION_MODULES.get(\"Core_Search\").updateObject(\"" + tableObject.elementUniqueID + "\", \"" + accessPath + ".Operand\", this.value)'>";
				output += "<OPTION value=\"AND\" " + (groupNode.Operand.toUpperCase() == "AND" ? "selected" : "") + ">AND</OPTION>";
				output += "<OPTION value=\"OR\" " + (groupNode.Operand.toUpperCase() == "OR" ? "selected" : "") + ">OR</OPTION>";
			output += "</select>";
			output += "<button onClick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').removeObject('" + tableObject.elementUniqueID + "', '" + locationID + "_" + id + "', '" + accessPath + "');\">X</button></td></tr></tbody></table>";
			output += "</td></tr>";
			output += "<tr><td id='" + locationID + "_" + id + "' style=''>";

			output += "</td></tr>";
			output += "</tbody>";
			output += "</table>";
			output += "</div>";
			locationObject.insert({bottom:output});
			
			var length = groupNode.groupNodes.length;
			var i = 0;
			for(i=0; i < length; i++)
			{
				if(	groupNode.groupNodes[i].type.toLowerCase() == "group")
				{
					this.insertGroupInto(tableObject, locationID + "_" + id, groupNode.groupNodes[i], accessPath + ".groupNodes[" + i + "]");
				}
				else
				{
					this.insertSearchNode(tableObject, locationID + "_" + id, groupNode.groupNodes[i], accessPath + ".groupNodes[" + i + "]");
				}
			}
		}
	},
	
	insertSearchNode: function(tableObject, locationID, searchNode, accessPath)
	{
		var locationObject = $(locationID);
		if(locationObject)
		{
			var id = getGUID();
			var output = "";
			
			output += "<div id='" + locationID + "_" + id + "_Main' style='margin-left:5px;margin-bottom:5px;padding:2px;width=100%;height=100%;border-width:1px;border-style:solid;border-color:black;'>";
			output += "<table style='width:100%;height:100%;'cellpadding='0px' cellspacing='0px'>";
			output += "<tbody>";
			output += "<tr><td style='background-color:#EDEDED;'>";
			output += "<table style='width:100%;' cellpadding='0px' cellspacing='0px'><tbody><tr><td>&nbsp;&nbsp;Condition:</td>"
			output += "<td align='right'>Column:&nbsp;<select type='text'onclick='AllowAutoClosingOfFloatingObject = false;' onchange='TABLE_MANIPULATION_MODULES.get(\"Core_Search\").updateObject(\"" + tableObject.elementUniqueID + "\", \"" + accessPath + ".column\", this.value);TABLE_MANIPULATION_MODULES.get(\"Integrated_PrefillSelection\").requestPrefill(\"" + tableObject.elementUniqueID + "\", this.value, \"" + locationID + "_" + id + "_editableSelect\");'>";
				output += "<OPTION value=\"\"></OPTION>";
							$H(tableObject.baseTableData.components.column).each(function(value) { if(value.value.isSearchable & (value.value.localQueryDataType == null || (value.value.localQueryDataType != DB2_CLOB && value.value.localQueryDataType != DB2_BLOB))) output += "<OPTION value='" + value.key.toUpperCase() + "' " + (searchNode.column.toUpperCase() == value.key.toUpperCase() ? "selected" : "") + " >" + (value.value.title != null ? value.value.title : value.key)+ "</OPTION>"; });
			output += "</select>";
			output += "<button onClick=\"TABLE_MANIPULATION_MODULES.get('Core_Search').removeObject('" + tableObject.elementUniqueID + "', '" + locationID + "_" + id + "', '" + accessPath + "');\">X</button>";
			output += "</td></tr></tbody></table>";
			output += "</td></tr>";
			output += "<tr><td>";
			output += "<table style='width:100%;' cellpadding='0px' cellspacing='0px'>";
			output += "<tbody><tr><td style='width:10px;'>";
			output += "<select type='text' onclick='AllowAutoClosingOfFloatingObject = false;' onchange='TABLE_MANIPULATION_MODULES.get(\"Core_Search\").updateObject(\"" + tableObject.elementUniqueID + "\", \"" + accessPath + ".compareType\", this.value)'>";
			output += "<OPTION value=\"\"></OPTION>";
			SQL_COMPARISON_OPERATORS.each(function(value) { output += "<OPTION value='" + value + "' " + (searchNode.compareType == value ? "selected" : "") + " >" + value + "</OPTION>"; });
			output += "</select>";	
			output += "</td><td>";	
			output += "<table id='" + locationID + "_" + id + "_editableSelect' style='width:95%;border:1px solid black;'cellpadding='0px' cellspacing='0px'>";
			output += "<tbody><tr><td style='width:100%;'>";
			output += "<input id='" + locationID + "_" + id + "_editableSelect_textInput' type='text' id='value' style='border:none;width:100%;display:block;' name='TE_DATABASE_LOGIN_COMMENT' onchange='TABLE_MANIPULATION_MODULES.get(\"Core_Search\").updateObject(\"" + tableObject.elementUniqueID + "\", \"" + accessPath + ".value\", this.value)'/>"
			output += "</td><td id='" + locationID + "_" + id + "_editableSelect_buttonHolder' style='width:0%;'>";
			output += "</td></tr></tbody></table>";
			
			output += "</td></tr></tbody></table>";
			output += "</td></tr>";
			output += "</tbody>";
			output += "</table>";

			output += "</div>";
			locationObject.insert({bottom:output});
			$(locationID + "_" + id + "_editableSelect_textInput").value = searchNode.value;
			if(searchNode.column != "" && searchNode.column != null)
			{
				TABLE_MANIPULATION_MODULES.get("Integrated_PrefillSelection").requestPrefill(tableObject.elementUniqueID, searchNode.column, locationID + "_" + id + "_editableSelect");
			}
		}	
	},
	
	addObject:function(tableID, type, locationID, accessPath)
	{
		var tableObject = activeTables.get(tableID);
		tableObject.baseTableData.SortManipulationHasOccured = true;
		if(	type.toUpperCase() == "GROUP")
		{
			var NewObject = {
								type:"group",
								Operand: "AND",
								groupNodes: [{
								type: "value",
								column: "",
								compareType: "",
								value: ""
							}]
							}; 
			
			var groupNodes = eval("tableObject.baseTableData.searchManipulationWhereObject" + accessPath + ".groupNodes;");
			groupNodes.push(NewObject);
			this.insertGroupInto(tableObject, locationID, NewObject, accessPath + ".groupNodes[" + (groupNodes.length-1) + "]");
		}
		else
		{
			var NewObject = {
								type: "value",
								column: "",
								compareType: "",
								value: ""
							};
			
			var groupNodes = eval("tableObject.baseTableData.searchManipulationWhereObject" + accessPath + ".groupNodes;");
			groupNodes.push(NewObject);
			this.insertSearchNode(tableObject, locationID, NewObject, accessPath + ".groupNodes[" + (groupNodes.length-1) + "]");
		}
		var holdingContainer = FLOATINGPANEL_activeFloatingPanels.get(tableID + '_SortDialog');
		if(holdingContainer != null)
				holdingContainer.size();
	},
	
	removeObject:function(tableID, locationID, accessPath)
	{
		
		var tableObject = activeTables.get(tableID);
		tableObject.baseTableData.SortManipulationHasOccured = true;
		eval("tableObject.baseTableData.searchManipulationWhereObject" + accessPath + " = null;");
		$(locationID + "_Main").remove();

		if(tableObject.baseTableData.searchManipulationWhereObject == null)
		{
			var rootNode = {
								type:"group",
								Operand: "AND",
								groupNodes: [{
								type: "value",
								column: "",
								compareType: "",
								value: ""
							}]
						}; 
			tableObject.baseTableData.searchManipulationWhereObject = rootNode;
			this.insertGroupInto(tableObject, tableID + "_SortPanelRootNode", rootNode, '');

		}
		
		var holdingContainer = FLOATINGPANEL_activeFloatingPanels.get(tableObject.elementUniqueID + '_SortDialog');
		if(holdingContainer != null)
			if(holdingContainer.size != null)
				holdingContainer.size();
		
	},
	
	updateObject:function(tableID, accessPath, value) 
	{
		var tableObject = activeTables.get(tableID);
		tableObject.baseTableData.SortManipulationHasOccured = true;
		eval("tableObject.baseTableData.searchManipulationWhereObject" + accessPath + " = value;");
	},
	
	applySearchFilter : function(tableID)
	{
		var tableObject = activeTables.get(tableID);
		
		var rootNode = tableObject.baseTableData.searchManipulationWhereObject;

		var nodeStack = [];
		var indexStack = [];

		
		// this block is used to remove null values from the search object which were generated during editing.
		if(rootNode != null)
		{
			if(rootNode.type.toLowerCase() == "group")
			{
				if(rootNode.groupNodes != null)
				{
					for(var i = 0; i < rootNode.groupNodes.length || nodeStack.length != 0; i++)
					{
						if(rootNode != null)
						{
							if(i > rootNode.groupNodes.length)
							{
								rootNode = nodeStack.pop();
								i = indexStack.pop();
								if(rootNode.groupNodes[i].groupNodes.length == 0)
								{
									rootNode.groupNodes.splice(i,1);
									i--;
								}
							}
							else if(rootNode.groupNodes[i] == null)
							{
								rootNode.groupNodes.splice(i,1);
								i--;
							} 
							else if(rootNode.groupNodes[i].type.toLowerCase() == "group")
							{
								if(rootNode.groupNodes[i].groupNodes.length > 0)
								{
									nodeStack.push(rootNode);
									indexStack.push(i);
									i = 0;
									rootNode = rootNode.groupNodes[i];
								}
								else
								{
									rootNode.groupNodes.splice(i,1);
									i--;
								}
							}
							else
							{
								if(rootNode.column == "" && rootNode.compareType == "" && rootNode.value == "")
								{
									rootNode.groupNodes.splice(i,1);
									i--;
								}
							}
						}
					}
				}
			}
		}

		var parameterArray = null
		if( tableObject.baseTableData.parameters != null )
		{
			if(tableObject.baseTableData.parameters.length > 0)
			{
				parameterArray = [];
				var paramLength = tableObject.baseTableData.parameters.length;
				var i = 0;
				for(i=0; i< paramLength; i++)
				{
					parameterArray.push({
						name: tableObject.baseTableData.parameters[i].name,
						title: tableObject.baseTableData.parameters[i].title,
						value : $(tableObject.elementUniqueID + "_parameters_" + tableObject.baseTableData.parameters[i].name).value,
						type: tableObject.baseTableData.parameters[i].type
					});
				}
			}
		}
		
		this.applySearchObject(tableID, {where:rootNode, parameters: parameterArray}, PUSH_HISTORY_BACKWARDS);
		
		
		tableObject.baseTableData.searchManipulationWhereObject = null;
		tableObject.baseTableData.SortManipulationHasOccured = null;
		tableObject.baseTableData.searchStartJSONText = null;
		var holdingContainer = FLOATINGPANEL_activeFloatingPanels.get(tableID + '_SortDialog');
		if(holdingContainer != null)
			if(holdingContainer.close != null)
				holdingContainer.close();
	},
	
	applySearchObject: function(tableID, oldHistoryObject, historyRecordStat) {

		var tableObject = activeTables.get(tableID);
		
		var newHistoryObject = {
				where	: tableObject.baseTableData.where,
				parameters : tableObject.baseTableData.parameters	
			};
			
		tableObject.baseTableData.where = oldHistoryObject.where;
		tableObject.baseTableData.parameters = oldHistoryObject.parameters;
		
		if(historyRecordStat == PUSH_HISTORY_FORWARDS)
		{
			getWindow(tableObject.parentStageID, tableObject.parentWindowID).pushActionOnToForwardHistory("TABLE_MANIPULATION_MODULES.get(\"Core_Search\").applySearchObject(\"" + tableObject.elementUniqueID + "\", " + Object.toJSON(newHistoryObject) + ", PUSH_HISTORY_BACKWARDS)", false);
		}
		else if(historyRecordStat == PUSH_HISTORY_BACKWARDS)
		{
			getWindow(tableObject.parentStageID, tableObject.parentWindowID).pushActionOnToBackHistory("TABLE_MANIPULATION_MODULES.get(\"Core_Search\").applySearchObject(\"" + tableObject.elementUniqueID + "\", " + Object.toJSON(newHistoryObject) + ", PUSH_HISTORY_FORWARDS)", false);
		}
		tableObject.retrieveTableData();
	}
	
});