/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/


var TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTION_OPEN = false;

Event.observe(window, 'load', function() {
$('PageBody').observe('click', function() {
		var object = $('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR');
		if(object != null)
			$('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR').remove();
	});
});

TABLE_MANIPULATION_MODULES.set("Integrated_PrefillSelection", {
	
	
	openPrefillTable: null,
	openPrefillColumn: null,
	openPrefillData: null,
	
	requestPrefill: function(tableID, columnName, editableSelectBoxID)
	{
		var prefilleditableSelectBoxHolder = $(editableSelectBoxID + "_buttonHolder");
		if(columnName != null && columnName != "" && prefilleditableSelectBoxHolder != null)
		{
			var tableObject = activeTables.get(tableID);
			if(tableObject != null )
			{
				var columnObject = tableObject.baseTableData.components["column"][columnName];
				if(	columnObject != null )
				{
					if(columnObject.isPrefiled != null || columnObject.mask != null)
					{
						
							prefilleditableSelectBoxHolder.update("<img class='prefillImage' src='./images/spacer.gif' onclick='TABLE_MANIPULATION_MODULES.get(\"Integrated_PrefillSelection\").showPrefillSelection(\"" + tableID + "\", \"" + columnName + "\", \"" + editableSelectBoxID + "\");Event.stop(event);'/>");
					}
					else
					{
						prefilleditableSelectBoxHolder.update("");
					}
				}
			}
		}
	},
	
	
	showPrefillSelection:function(tableID, columnName, editableSelectBoxID)
	{
		var object = $('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR');
		if(object != null)
			$('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR').remove();
			
		this.openPrefillTable = tableID;
		this.openPrefillColumn = columnName;
		this.openPrefillData = null;
		
		
		var editableSelectBox = $(editableSelectBoxID);
		var tableObject = activeTables.get(tableID);
		
		if(editableSelectBox == null || tableObject == null) return;
		
		var columnObject = tableObject.baseTableData.components["column"][columnName];
		
		if(columnObject == null) return;
		
		
		
		var output = "";
		
		output += "<div id='TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR' onclick='Event.stop(event);' style='padding:0px;margin:0px;background-color:white;top:0px;left0px;position:absolute;z-index:" + getTopZindex() + ";width:" + editableSelectBox.getWidth() + "px'>";
		output += "<table cellpadding='0px' cellspacing='0px' style='width:100%;height:100%;position:static;'>";
		output += "<tbody>";
		//output += "<tr style='height:10px;background-color:#EDEDED;'><td align='left'>";
		//output += "<table cellpadding='0px' cellspacing='0px' style='width:100%;'><tr><td></td><td style='width:5px;'>";
		//output += "<img style='display:inline;float:none;' src='images/icon-link-refresh.gif' style='padding:3px;'/></td><td style='width:5px;'></td><td style='width:5px;'><img style='float:none;' src='images/close_s.gif'/></td><td style='width:5px;'>";
		//output += "</td></tr></table></tr>";
		output += "<tr>";
		output += "<td align='right' id=\"TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SEARCH_VALUE\">";

		output += "</td></tr>";
		output += "</tbody>";
		output += "</table>";
		output += "</div>";
		
		$("PageBody").insert(output);
		this.size(editableSelectBoxID);
		this.getPrefillData(tableID, columnName, editableSelectBoxID);
	},
	
	size: function(editableSelectBoxID) {
		
		var mainContainer = $('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR');
		
		if (mainContainer == null) return;
		
		var editableSelectBoxOffset = {
				left: 0,
				top: 0
			};
		var editableSelectBoxWidth = 20;
		var editableSelectBoxHeight = 20;
		
		var parentTrigger = $(editableSelectBoxID);
		if (parentTrigger != null) {
			editableSelectBoxOffset = parentTrigger.cumulativeOffset();
			editableSelectBoxWidth = parentTrigger.getWidth();
			editableSelectBoxHeight = parentTrigger.getHeight();
		}
		else {
			var editableSelectBoxLeft = CORE_Current_Mouse_X - 10;
			var editableSelectBoxTop = CORE_Current_Mouse_Y -10;
			editableSelectBoxOffset = {
				left: editableSelectBoxLeft,
				top: editableSelectBoxTop
			};
		}
		
		var speditableSelectBoxBottom = pageHeight - (editableSelectBoxOffset.top + editableSelectBoxHeight);
		
		var containerHeight = mainContainer.scrollHeight;

		if (speditableSelectBoxBottom >= containerHeight) 
			mainContainer.setStyle({ "top": editableSelectBoxOffset.top + editableSelectBoxHeight + "px", "left": editableSelectBoxOffset.left + "px" });
		else if (editableSelectBoxOffset.top >= containerHeight) 
			mainContainer.setStyle({ "top": (editableSelectBoxOffset.top - containerHeight) + "px", "left": editableSelectBoxOffset.left + "px" });
		else if (speditableSelectBoxBottom >= speditableSelectBoxTop)
			mainContainer.setStyle({ "top": editableSelectBoxOffset.top + editableSelectBoxHeight + "px", "left": editableSelectBoxOffset.left + "px" });
		else
			mainContainer.setStyle({ "top": (editableSelectBoxOffset.top - containerHeight) + "px", "left": editableSelectBoxOffset.left + "px" });
	},

	getPrefillData: function(tableID, columnName, editableSelectBoxID)
	{
		this.openPrefillData = [];
		var thisObject = this;
		
		var tableObject = activeTables.get(tableID);
		
		if(tableObject == null) return;
		
		var columnObject = tableObject.baseTableData.components["column"][columnName];
		
		if(columnObject == null) return;
		
		thisObject.openPrefillData = [];
		var value = "";
		var displayvalue = "";
		if(columnObject.mask != null)
		{
			$H(columnObject.mask).each(function(Mask) {
				if(Mask.value.mask != null)
				{
					if(columnObject.localQueryDataType == DB2_NUMBER)
						value = Mask.key + " /*" + Mask.value.mask + "*/";
					else
						value = "'" + Mask.key + "' /*" + Mask.value.mask + "*/";
					displayvalue = Mask.value.mask;
				}
				else 
				{
					if(columnObject.localQueryDataType == DB2_NUMBER)
						value = Mask.key;
					else
						value = "'" + Mask.key + "'";
					displayvalue = Mask.key;
				}
				thisObject.openPrefillData.push({
								value: value, 
								text: displayvalue
				});
			});
			if(columnObject.nullMask != null)
			{
				if(Mask.value.mask != null)
				{
					thisObject.openPrefillData.push({
										value: 'null /*' + columnObject.nullMask.value.mask + '*/', 
										text: "<font style='color:red;font-weight: bold;'>null</font>"
					});
				}
			}	
			thisObject.InsertPrefillData(tableID, columnName);
		}
		if(columnObject.prefillDATA == null && columnObject.isPrefiled != null)
		{
			var returnObject = {
				'tableID'	: tableID,
				'columnName' : columnName,
				'tableObject': tableObject,
				'columnObject' : columnObject,
				'thisObject' : this,
				'editableSelectBoxID' : editableSelectBoxID
			};
			if(columnObject.isPrefiled.table == null)
			{
				returnObject.tableDefinition = tableObject.baseTableData.localTableDeffinition;
				this.getData(returnObject);
			}
			else
			{
				var searchValueHolder = $("TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SEARCH_VALUE");
				if(searchValueHolder != null)
				{
					searchValueHolder.update("<img style='float:none;' src='images/loadingpage_small.gif'/>");
				}
				getTableDefinition(columnObject.isPrefiled.table, null, "returnObject.thisObject.getData", null, null, returnObject);
			}
		}
		else if(columnObject.prefillDATA != null)
		{
			thisObject.loadPrefillColumnData(tableID, columnName, columnObject, editableSelectBoxID);
		}
	},
	
	
	getData: function(returnObject) {
		
		var editableSelectBoxID = returnObject.editableSelectBoxID
		var thisObject = returnObject.thisObject;
		var tableID = returnObject.tableID;
		var columnName = returnObject.columnName;
		var tableObject = returnObject.tableObject;
		var columnObject = returnObject.columnObject;
		
		thisObject.loadPrefillColumnData(tableID, columnName, columnObject);
		POSTDATA = new Object();
		POSTDATA.SQL 					= QueryBuilder_buildWithList(returnObject.tableDefinition) + "SELECT DISTINCT " + (columnObject.isPrefiled.column == null ? columnObject.sql_name : (returnObject.tableDefinition.components.column[columnObject.isPrefiled.column] != null ? returnObject.tableDefinition.components.column[columnObject.isPrefiled.column].sql_name : columnObject.isPrefiled.column)) + " FROM " + QueryBuilder_buildFrom(returnObject.tableDefinition);
		POSTDATA.action 				= "executeSQL";
		POSTDATA.returntype 			= 'JSON';
		POSTDATA.maxRowReturn			= 1000;
		
		if(returnObject.tableObject.baseTableData.localTableDeffinition.useConnectWithTag != null)
		{
			POSTDATA.USE_CONNECTION = getConnectionWithTag(returnObject.tableObject.baseTableData.localTableDeffinition.useConnectWithTag);
		}
		if(POSTDATA.USE_CONNECTION == null)
		{
			POSTDATA.USE_CONNECTION = ACTIVE_DATABASE_CONNECTION;
		}
		
		new Ajax.Request(ACTION_PROCESSOR, {
					'parameters': POSTDATA,
					'method': 'post',
					'onSuccess': function(transport) {
						var result = transport.responseJSON;
						if(result == null) return;
						if(result.flagGeneralError == true && result.connectionError == true)
						{
							initiateConnectionRefresh();
						}
						
						if(result != null)
						{
							var resultSet = result.returnValue.resultSet[0];
							
							columnObject.prefillDATA = resultSet.data;
							
							if(thisObject.openPrefillTable != tableID || thisObject.openPrefillColumn != columnName) return;
							
							thisObject.loadPrefillColumnData(tableID, columnName, columnObject, editableSelectBoxID);
						}
					}
			});
	},
	
	loadPrefillColumnData: function(tableID, columnName, columnObject, editableSelectBoxID)
	{
		this.openPrefillData = [];
		var thisObject = this;
		var maskObject = columnObject.mask;
		if(columnObject.prefillDATA != null)
		{
			var aPrefillValue = "";
			var aPrefillText = "";
			columnObject.prefillDATA.each(function(value) {
				if(columnObject.localQueryDataType == DB2_NUMBER)
					aPrefillValue = value[0];
				else
					aPrefillValue = "'" + value[0] + "'";
				aPrefillText = value[0];
				
				if(maskObject != null)
				{
					if(maskObject[value[0]] != null)
					{
						if(maskObject[value[0]].mask != null)
						{
							aPrefillValue += " /* " + maskObject[value[0]].mask + " */";
							aPrefillText = maskObject[value[0]].mask;
						}
					}
				}

				thisObject.openPrefillData.push({
							value: aPrefillValue, 
							text: aPrefillText
					});
			});
		}
		this.InsertPrefillData(tableID, columnName, editableSelectBoxID);
	},
	
	InsertPrefillData:function(tableID, columnName, editableSelectBoxID)
	{
		if(this.openPrefillTable != tableID || this.openPrefillColumn != columnName) return;
		
		var searchValueHolder = $("TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SEARCH_VALUE");
		if(searchValueHolder != null)
		{
			var output = "";
			var i = 0;
			output += "<select onchange=\"$('" + editableSelectBoxID + "_textInput').value = TABLE_MANIPULATION_MODULES.get('Integrated_PrefillSelection').openPrefillData[this.value].value;$('TABLE_MANIPULATION_MODULES_INTEGRATED_PREFILL_SELECTOR').remove();$('" + editableSelectBoxID + "_textInput').onchange();\" onclick='Event.stop(event);' size=10 style='width:100%;height:200px;'>";
			for(i=0; i < this.openPrefillData.length; i++)
			{
				output += "<option value='" + i + "'>" + this.openPrefillData[i].text.escapeHTML() + "</option>";
			}
			output += "</select>";
			searchValueHolder.update(output);
		}
		
	}
	
	
});