/*******************************************************************************
 *Copyright IBM Corp. 2007 All rights reserved.
 *
 *Licensed under the Apache License, Version 2.0 (the "License");
 *you may not use this file except in compliance with the License.
 *You may obtain a copy of the License at
 *
 *	http://www.apache.org/licenses/LICENSE-2.0
 *
 *Unless required by applicable law or agreed to in writing, software
 *distributed under the License is distributed on an "AS IS" BASIS,
 *WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *See the License for the specific language governing permissions and
 *limitations under the License.
 *********************************************************************************/
var TutorialList = $H();
function getTutorial(TName){
	return TutorialList.get(TName);
}
function registerTutorial(aTutorial) {
	return TutorialList.set(aTutorial.elementUniqueID, aTutorial);
}
function removeTutorial(Tname){
	return TutorialList.unset(Tname);
}
CORE_CLIENT_ACTIONS.set("tutorial", Class.create(basePageElement,{
	initialize: function($super, callParameters) {
		
		$super(callParameters.uniqueID + "_tutorial", "TUTORIAL");
		
		this.parentStageID = callParameters.stageID;
		this.parentWindowID = callParameters.windowID;
		this.parentPanelID = callParameters.panelID;
		this.parentPageID = callParameters.uniqueID;
		
		this.tutorialName = callParameters.tutorialName;
		this.currentMenuLocation = callParameters.CurrentMenuLocation;
		
		this.startAtPage = callParameters.startAtPage;
		
		this.usingSharedSchema = false;
		
		this.Script = null;
		
		this.startAtPage = callParameters.startAtPage != null ? callParameters.startAtPage : 1;
		
		this.EndScroll = true;
		this.scrollAcceleration = 0;
		this.currentPageNumber = -1;
		this.currentPage = null;
		this.forwardMostVistedPage = 0;

		this.SetAdHocTextLoop = null;
		this.SetAdHocOptionsLoop = null;
		this.localTutorialConstants = $H();
		this.localTutorialResultsSets = $H();

		registerTutorial(this);
		this.setHeight();
		this.setWidth();
		this.draw();
	},
	
	draw: function() {
			var layout = ({
					type:"splitPane",
					direction:"h",
					maxSize:25,
					allowResize:false,
					showSplitSpacer:true,
					splitSpacerWidth:1,
					styleOverride:"background-color:#A0A0A0;",
					panelA: {
						type:"panel",
						name:"TUTORIAL_TITL_PANEL",
						PrimaryContainer:false,
						overflow:"hidden",
						ContentType:"RAW",
						data:'<table class="contextRootBase" width="100%" cellpadding="0" cellspacing="0">' +
							'<tr><td><table cellpadding="0" cellspacing="0"><tr>' +
							'<td align="left" style="padding-left:2px;">' +
							'<img id="' + this.elementUniqueID + '_PerviousPage" onClick="getTutorial(\'' + this.elementUniqueID + '\').displayPerviousPage();" src="images/windownav/BWArrow_inActive.gif"/>' +
							'</td>' +
							'<td align="left" style="padding-left:2px;" class="contextRootLILink" >' +
							'<img id="' + this.elementUniqueID + '_NextPage" onClick="getTutorial(\'' + this.elementUniqueID + '\').displayNextPage();" class="inlineimage" src="images/windownav/FWArrow_inActive.gif"/>' +
							'</td>' +
							'<td align="left" style="padding-left:2px;" id="' + this.elementUniqueID + '_options">' +
							'<a style="padding-top:2px;padding-bottom:2px;" onmousedown="FLOATINGPANEL_activeFloatingPanels.get(\'' + this.elementUniqueID + '_PagePanel\').show_and_size();" id="' + this.elementUniqueID + '_Current_Page" onmouseout="if(menuWaitingToOpen != null){clearTimeout(menuWaitingToOpen);} mouseIsOverContextBase=false;" onmouseover="mouseIsOverContextBase=true;">0&nbsp;of&nbsp;0</a>' +
							'</td>' +
							'<td align="left"><nobr id="' + this.elementUniqueID + '_topTutorialTitle" class="tutorialTitleBarTitle"></nobr>' +
							'</td></tr></table></td>' +
							'<td align="right" style="width:10px;valign:center;"><div id="' + this.elementUniqueID + '_devResources"></div></td></tr></table>'
					},
					panelB: {
						type:"splitPane",
						direction:"v",
						splitPercent:0.333,
						allowResize:true,
						panelA: {
							type:"panel",
							name:"TUTORIAL_TEXT_PANEL",
							PrimaryContainer:false,
							overflow:"hidden",
							ContentType:"RAW",
							data:'<table style="width:100%; height:100%;" cellpadding="0" cellspacing="0" align="left">' +
								'<tr style="height:100%;">' +
								'<td align="left" valign="top" style="padding:0px;" id="' + this.elementUniqueID + '_Body_container" class="tutorial_content">' +
								'<div class="tutorialCSS" style="position:relative;padding-left:10px; padding-right:10px; padding-top:10px; width:50px; height:50px; overflow:auto;" id="' + this.elementUniqueID + '_Body" >' +
								'</div></td></tr></table>'
						},
						panelB: {
							type				: "stage",
							name				: this.elementUniqueID + "_stage",
							HasMenuBarContainer : TOP_TAB_TASK_BAR, 
							top				 : 0, 
							botton			: 0, 
							left				: 0,
							right			 : 0,
							titleBarType		: NO_TITLE_BAR,
							windowOptionType	: NO_NAV_BAR, 
							windowControlTypes: NO_TITLE_BAR_OPTIONS,
							sizable			 : WINDOW_IS_FULL
						}		
			}});
		
		getPanel(this.parentStageID,this.parentWindowID, this.parentPanelID).loadLayout(layout);
		
		getPanel(this.parentStageID, this.parentWindowID, "TUTORIAL_TEXT_PANEL").registerNestedObject(this.elementUniqueID, this);	
		
		buttonSupport_registerButton(this.elementUniqueID + '_PerviousPage');
		
		buttonSupport_registerButton(this.elementUniqueID + '_NextPage');
		
		var TutorailPages = new floatingPanel(this.elementUniqueID + '_PagePanel', 'RAW', '<ul id="' + this.elementUniqueID + '_PageList" class="embeddedMenu" align="left"></ul>', this.elementUniqueID + '_Current_Page', true);
		getPanel(this.parentStageID, this.parentWindowID, this.parentPanelID).registerNestedObject(TutorailPages);
		TutorailPages.draw();
		
		if(ALLOW_DISPLAY_OF_XML || ALLOW_DEVELOPER_VIEW)
		{
			var menuItems = [];
			
			if(ALLOW_DISPLAY_OF_XML)
			{
					menuItems.push({
						nodeType : "leaf",
						elementID : "viewXML",
						elementValue : "XML",
						elementAction : 'onClick="openURLonDefaultStageInIframe(\'' + location.href.replace('index.php', '') + (this.currentMenuLocation + "/" + this.tutorialName + "/tutorialScript.xml").replace(/[\/]+/g, "/") + '\');"',
						elementSubNodes : null,
						elementSubNodeDirection : null
					});
			}

			if(ALLOW_DEVELOPER_VIEW)
			{
				menuItems.push({
						nodeType : "leaf",
						elementID : "viewFiles",
						elementValue : "Directory",
						elementAction : 'onClick="openURLonDefaultStageInIframe(\'' + location.href.replace('index.php', '') + (this.currentMenuLocation + "/" + this.tutorialName).replace(/[\/]+/g, "/") + '\');"',
						elementSubNodes : null,
						elementSubNodeDirection : null
					});
			}
		
			createContextMenu(this.elementUniqueID + '_devResources', [
				{
						nodeType : "branch",
						elementID : "branch",
						elementValue : "View",
						elementAction : '',
						elementSubNodes : menuItems,
						elementSubNodeDirection : HORIZONTAL
				}
			], HORIZONTAL, this.parentStageID, this.parentWindowID, this.parentPanelID);

		}
		this.loadTutorialScript();
	},
	
	loadTutorialScript: function() {
		var elementUniqueID = this.elementUniqueID;
		
		var thisObject = this;
		
		POSTDATA = new Object();
		POSTDATA.uniqueID 				= this.elementUniqueID;
		POSTDATA.stageID 				= this.parentStageID;
		POSTDATA.windowID 				= this.parentWindowID;
		POSTDATA.panelID 				= this.parentPanelID;
		POSTDATA.returntype 			= 'JSON';
		POSTDATA.tutorialName 			= this.tutorialName;
		POSTDATA.currentMenuLocation 	= this.currentMenuLocation;
		
		POSTDATA.action				 	= "getTutorialScript";
		getWindow(this.parentStageID, this.parentWindowID).setWindowTitle(this.tutorialName);
		new Ajax.Request(ACTION_PROCESSOR, {
					'parameters': POSTDATA,
					'method': 'post',
					'onCreate': function() {
						var contentArea = $(elementUniqueID + '_Body');
						if (contentArea != null)
							contentArea.update("<table width='100%' height='100%'cellspacing='0' cellpadding='0' align='center' valign='center'>" +
												"<tr height='200px'><td align='center' id='" + elementUniqueID + "_LoadingIconArea'><img style='float:none;' src='images/loadingpage.gif'/></td></tr>" +
												"<tr height='30px'><td><span><h1 id='" + elementUniqueID + "_LoadingTitleArea'>Loading tutorial script</h1></span></td></tr>" +
												"<tr><td id='" + elementUniqueID + "_LoadingInformationArea'></td></tr>" +
												"</table>");
					},
					'onSuccess': function(transport) {
						var TutorialScript = transport.responseJSON;
						var LoadingInformationArea = $(elementUniqueID + "_LoadingInformationArea");
						var LoadingIconArea = $(elementUniqueID + "_LoadingIconArea");
						var LoadingTitleArea = $(elementUniqueID + "_LoadingTitleArea");
						
						if(LoadingTitleArea != null)
							LoadingTitleArea.update("Finished Loading Script");
						
						if(TutorialScript == null)
						{
							if(LoadingIconArea != null)
								LoadingIconArea.update("");
							if(LoadingInformationArea != null)
								LoadingInformationArea.update("Tutorial JSON encoding error");
							return;
						}
						if(TutorialScript.returnCode == false)
						{
							if(LoadingIconArea != null)
								LoadingIconArea.update("");
							if(LoadingInformationArea != null)
								LoadingInformationArea.update(TutorialScript.returnValue);
							return;
						}
						if(Object.isArray(TutorialScript.returnValue))
						{
							if(LoadingIconArea != null)
								LoadingIconArea.update("");
							if(LoadingInformationArea != null)
								LoadingInformationArea.update("Tutorial script is empty");
							return;
						}
						thisObject.Script = TutorialScript.returnValue
						
						var schemaHasBeenSet = false;
						var parentStageObject = getStage(thisObject.parentStageID);
						if(parentStageObject != null)
						{
							var schema = parentStageObject.LOCAL_STAGE_VARIABLES.get('SCHEMA')
							if(schema != null)
							{
								thisObject.localTutorialConstants.set("SCHEMA", schema);
								thisObject.localTutorialConstants.set("SHARED_SCHEMA", "true");
								thisObject.usingSharedSchema = true;
								schemaHasBeenSet = true;
							}
						}
						
						if(!thisObject.Script.disableSetSchema && !schemaHasBeenSet)
						{
								thisObject.localTutorialConstants.set("SCHEMA", thisObject.Script.tutorialSchema);
								thisObject.localTutorialConstants.set("SHARED_SCHEMA", "false");
						}
							
						if(thisObject.Script.name != null && thisObject.Script.name != "")
							getWindow(thisObject.parentStageID, thisObject.parentWindowID).setWindowTitle(thisObject.Script.name);
							
						thisObject.pageFlow = TUTORIAL_FLOW_FREE;
						if(thisObject.Script.flowRestriction != null)
						{
							switch(thisObject.Script.flowRestriction.toLowerCase())
							{
								case "freewithchecks":
									thisObject.pageFlow = TUTORIAL_FREE_WITH_CHECKS;
									break;
								case "forwardsequential":
									thisObject.pageFlow = TUTORIAL_FLOW_FORWARD_SEQUENTIAL;
									break;
								case "strictsequential":
									thisObject.pageFlow = TUTORIAL_FLOW_STRICT_SEQUENTIAL;
									break;
								case "forwardexploration":
									thisObject.pageFlow = TUTORIAL_FLOW_FORWARD_EXPLORATION;
									break;
							}
						}
						
						
						var layout = ({
							target	: "TutorialSQL",
							raiseToTop: "",
							windowStage : thisObject.elementUniqueID + "_stage",
							windowType: CAN_NOT_CLOSE,
							content	 : {
												type:"panel",
												name:"SQLBasePanel",
												PrimaryContainer:true,
												overflow:"hidden",
												ContentType:"LINK",
												data:{
													type:"ACTION",
													data:{
														parameters:{
															action:"ADHOC",
															AdHocLong:thisObject.Script.useLongAcHoc
														}	
													}
													
												}
											}
							});
					
						loadNewPageLayout(layout);
						
						
						thisObject.localTutorialConstants.set("TUTORIAL_NAME", thisObject.Script.name);
						thisObject.localTutorialConstants.set("BASE_DIRECTORY", thisObject.Script.contentFolder);
						
						thisObject.callActionScript(thisObject.Script.openAction, "", "");
						thisObject.goToPage(thisObject.startAtPage-1);

					},
					'onFailure': function(transport) {
						var window = getWindow(parentStageID, parentWindowID);
						if (window != null)
							window.setDoneLoading(myID);
						thisObject.setContent(transport.responseText, "Error Loading Page");
					}
			});
		
		
		
		
	},
	
	callActionScript: function(script, varStore, callBack)
	{
		if(script != "" && script != null)
		{
			new actionScript(this.parentPageID + script.name, script, this.localTutorialConstants, this.parentStageID, this.parentWindowID, this.parentPanelID, this.parentPageID, null, this.localTutorialResultsSets);
			if(actionScriptHolder.get(this.parentPageID + script.name))
			{
				return actionScriptHolder.get(this.parentPageID + script.name).callAction('', '', callBack, varStore);
			}
		}
		return true;
	},
	clearPagesInRightStage: function() {
		STAGE_activeStages.get(this.elementUniqueID + '_stage').closeAllWindows();
	},
	destroy: function() {
		if(this.SetAdHocTextLoop != null)
		{
			clearTimeout(this.SetAdHocTextLoop);
			this.SetAdHocTextLoop = null;
		}
		if(this.SetAdHocOptionsLoop != null)
		{
			clearTimeout(this.SetAdHocOptionsLoop);
			this.SetAdHocOptionsLoop = null;
		}
		if(this.Script != null)
		{
			if(this.Script.closeAction != "" && this.Script.closeAction != null)
			{
				this.callActionScript(this.Script.closeAction, "", "");
			}
		}
		
		var localCloseScript = GLOBAL_ACTION_SCRIPT_STORE.get('TUTORIAL_CLOSE_SCRIPT');
		if(localCloseScript != "" && localCloseScript != null && !this.usingSharedSchema)
		{
			new actionScript(this.parentPageID + localCloseScript.name, localCloseScript, this.localTutorialConstants, null, null, null, this.parentPageID, null, this.localTutorialResultsSets);
			if(actionScriptHolder.get(this.parentPageID + localCloseScript.name))
			{
				actionScriptHolder.get(this.parentPageID + localCloseScript.name).callAction('', '', null, null);
			}
		}
		
		removeTutorial(this.elementUniqueID);
	},
	goToPage: function(PagNum) {
		if(this.Script.pageList != null)
		{
			if(PagNum >= this.Script.pageList.totalPages && PagNum < 0)
				return;
			this.displayPage(PagNum);
		}
	},
	displayNextPage: function() {
		if(this.Script.pageList != null)
		{
			if((this.currentPageNumber + 1) >= this.Script.pageList.totalPages)
				return;
			this.displayPage((this.currentPageNumber + 1));
		}
	},
	displayPerviousPage: function() {
		if((this.currentPageNumber - 1) < 0)
			return;
		this.displayPage((this.currentPageNumber - 1));
	},
	displayPage: function(ThePageNumber) {
		if(ThePageNumber == this.currentPageNumber)
			return;
		this.beginPageTransitions( ThePageNumber, this.getPageObject(ThePageNumber));
	},
	getPageObject: function(ThePageNumber) {
		if(this.Script.pageList.numIntroPages > ThePageNumber)
		{
			return this.Script.pageList.introPages[ThePageNumber];
		}
		else
		{
			ThePageNumber -= this.Script.pageList.numIntroPages ;
			if(this.Script.pageList.numGeneralPages > ThePageNumber)
			{
				return this.Script.pageList.generalPages[ThePageNumber];
			}
			else
			{
				ThePageNumber -= this.Script.pageList.numGeneralPages ;
				return this.Script.pageList.lastPages[ThePageNumber];
			}
		}
	},
	beginPageTransitions : function( pageNumber, thePage) {
		closeOpenFloatingObject();
		$(this.elementUniqueID + "_PerviousPage").hide();
		$(this.elementUniqueID + "_NextPage").hide();
		$(this.elementUniqueID + "_Current_Page").hide();
		var elementUniqueID = this.elementUniqueID;
		if($(elementUniqueID + '_Body') != null)
		{
			this.oldContent = $(elementUniqueID + '_Body').innerHTML;
			$(elementUniqueID + '_Body').update("<table width='100%' height='100%'cellspacing='0' cellpadding='0' align='center' valign='center'>" +
												"<tr height='200px'><td align='center'><img style='float:none;' src='images/loadingpage.gif'/></td></tr>" +
												"<tr height='30px'><td><span><h1>Loading Page " + (parseInt(pageNumber)+1) + ": " + thePage.name + "</h1></span></td></tr>" +
												"<tr><td>" + thePage.pageTransitionsDescription + "</td></tr>" +
												"</table>");
		}
		if(this.currentPage == null)
		{
			this.showPage(pageNumber, thePage);
		}
		else
		{
			var passVar = {
				"pageNumber" : pageNumber,
				"thePage" : thePage
			};
			if(TUTORIAL_FREE_WITH_CHECKS == this.pageFlow)
			{
				if(this.currentPage.exitAction != "" && this.currentPage.exitAction != null)
				{
					this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
				}
				else if(thePage.entryAction != "" && thePage.entryAction != null)
				{
					this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
				}
				else
				{
					this.showPage(pageNumber, thePage);
				}
				return;
			}
			else if(TUTORIAL_FLOW_FREE == this.pageFlow)
			{
				this.showPage(pageNumber, thePage);
				return;
			}
			var pageChangeScale = pageNumber - this.currentPageNumber;
			if(this.currentPageNumber == this.forwardMostVistedPage)
			{
				if(pageChangeScale == 1)
				{
					if(this.currentPage.exitAction != "" && this.currentPage.exitAction != null)
					{
						this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
					}
					else if(thePage.entryAction != "" && thePage.entryAction != null)
					{
						this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
					}
					else
					{
						this.showPage(pageNumber, thePage);
					}
					return;
				}
				else if(pageChangeScale == -1)
				{
					switch(this.pageFlow)
					{
						case TUTORIAL_FLOW_STRICT_SEQUENTIAL:
							if(this.currentPage.exitAction != "" && this.currentPage.exitAction != null)
							{
								this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
							}
							else if(thePage.entryAction != "" && thePage.entryAction != null)
							{
								this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
							}
							else
							{
								this.showPage(pageNumber, thePage);
							}
							break;
						default:
							this.showPage(pageNumber, thePage);
							break;
					}
					return;
				}
				else if(pageChangeScale > 1)
				{
					if(this.pageFlow == TUTORIAL_FLOW_FORWARD_EXPLORATION)
					{
							this.showPage(pageNumber, thePage);
					}
					return;
				}
				else if(pageChangeScale < -1)
				{
					switch(this.pageFlow)
					{
						case TUTORIAL_FLOW_FORWARD_SEQUENTIAL:
							this.showPage(pageNumber, thePage);
							break;
						case TUTORIAL_FLOW_FORWARD_EXPLORATION:
							this.showPage(pageNumber, thePage);
							break;
					}
					return;
				}
			}
			else
			{
				if(pageChangeScale == 1)
				{
					switch(this.pageFlow)
					{
						case TUTORIAL_FLOW_FORWARD_EXPLORATION:
							this.showPage(pageNumber, thePage);
							break;
						default:
							if(this.currentPage.exitAction != "" && this.currentPage.exitActio != null)
							{
								this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
							}
							else if(thePage.entryAction != "" && thePage.entryAction != null)
							{
								this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
							}
							else
							{
								this.showPage(pageNumber, thePage);
							}
							break;
					}
					return;
				}
				else if(pageChangeScale == -1)
				{
					switch(this.pageFlow)
					{
						case TUTORIAL_FLOW_STRICT_SEQUENTIAL:
							if(this.currentPage.exitAction != "" && this.currentPage.exitAction != null)
							{
								this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
							}
							else if(thePage.entryAction != "" && thePage.entryAction != null)
							{
								this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
							}
							else
							{
								this.showPage(pageNumber, thePage);
							}
							break;
						default:
							this.showPage(pageNumber, thePage);
							break;
					}
					return;
				}
				else if(pageChangeScale < -1)
				{
					switch(this.pageFlow)
					{
						case TUTORIAL_FLOW_FORWARD_SEQUENTIAL:
							this.showPage(pageNumber, thePage);
							break;
						case TUTORIAL_FLOW_FORWARD_EXPLORATION:
							this.showPage(pageNumber, thePage);
							break;
					}
					return;
				}
				else if(pageNumber <= this.forwardMostVistedPage)
				{
					if(this.pageFlow == TUTORIAL_FLOW_FORWARD_EXPLORATION)
					{
							this.showPage(pageNumber, thePage);
					}
					return;
				}
				else if(pageNumber = this.forwardMostVistedPage + 1)
				{
					if(this.pageFlow == TUTORIAL_FLOW_FORWARD_EXPLORATION)
					{
							if(this.currentPage.exitAction != "" && this.currentPage.exitAction != null)
							{
								this.callActionScript(this.currentPage.exitAction, passVar, "getTutorial('" + this.elementUniqueID + "').exitActionCallBack");
							}
							else if(thePage.entryAction != "" && thePage.entryAction != null)
							{
								this.callActionScript(thePage.entryAction, passVar, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
							}
							else
							{
								this.showPage(pageNumber, thePage);
							}
					}
					return;
				}
			}
		}
	},
	exitActionCallBack: function(returnStack) {
		var elementUniqueID = this.elementUniqueID;
		if("true" != String(returnStack.actionReturnValue).toLowerCase())
		{
			if($(elementUniqueID + '_Body') != null)
			{
				$(elementUniqueID + '_Body').update(this.oldContent);
			}
			this.displayPageNumber();
			return false;
		}
		if(returnStack.localVariables.thePage.entryAction != "" && returnStack.localVariables.thePage.entryAction != null)
		{
			this.callActionScript(returnStack.localVariables.thePage.entryAction, returnStack.localVariables, "getTutorial('" + this.elementUniqueID + "').entryActionCallBack");
		}
		else
		{
			this.showPage(returnStack.localVariables.pageNumber, returnStack.localVariables.thePage);
		}
	},
	entryActionCallBack : function(returnStack) {
		var elementUniqueID = this.elementUniqueID;
		if("true" != String(returnStack.actionReturnValue).toLowerCase())
		{
			if($(elementUniqueID + '_Body') != null)
			{
				$(elementUniqueID + '_Body').update(this.oldContent);
			}
			this.displayPageNumber();
			return false;
		}
		this.showPage(returnStack.localVariables.pageNumber, returnStack.localVariables.thePage);
	},
	showPage: function(pageNumber, thePage) {
		if(this.SetAdHocTextLoop != null)
		{
			clearTimeout(this.SetAdHocTextLoop);
			this.SetAdHocTextLoop = null;
		}
		if(this.SetAdHocOptionsLoop != null)
		{
			clearTimeout(this.SetAdHocOptionsLoop);
			this.SetAdHocOptionsLoop = null;
		}
		if(this.forwardMostVistedPage < pageNumber || this.pageFlow == TUTORIAL_FLOW_FORWARD_SEQUENTIAL)
			this.forwardMostVistedPage = parseInt(pageNumber);
		this.currentPageNumber =parseInt( pageNumber);
		var oldContent = "";
		var elementUniqueID = this.elementUniqueID;
		var localTutorialConstants = this.localTutorialConstants;
		var thisObject = this;
		this.currentPage = thePage;
		this.insertAllPages();
		if((this.Script.autoCloseWindowsInRightStage == true && thePage.closeWindowsInRightStage == null) || (thePage.closeWindowsInRightStage == true))
		{
			this.clearPagesInRightStage();
		}
		if((this.Script.autoClearAdhocResults == true && thePage.clearAdhocResults == null) || (thePage.clearAdhocResults == true))
		{
			try
			{
				var TutorialAdhocPanel = AdHocSQLWindows.get(elementUniqueID + '_stage_TutorialSQL_SQLBasePanel');
				if(TutorialAdhocPanel != null)
				{
					TutorialAdhocPanel.clearResults();
				}
			}
			catch(e){}
		}
		if(thePage.SQLFile != "" && thePage.SQLFile != null)
		{
			var localTutorialConstants = this.localTutorialConstants
			new Ajax.Request(this.Script.contentFolder + '/SQL/' + thePage.SQLFile, {
				'onSuccess': function(transport) {
					thisObject.updateSQLText(escape(encodeURIandNormaMessage(transport.responseText, localTutorialConstants)), pageNumber)
				}
			});
			RaiseToTop(elementUniqueID + '_stage', "TutorialSQL");
		}
		else if(thePage.SQLText != "" && thePage.SQLText != null)
		{
			thisObject.updateSQLText( encodeURIandNormaMessage(thePage.SQLText, localTutorialConstants), pageNumber)
		}
		if(thePage.loadActionScriptFile != "" && thePage.loadActionScriptFile != null)
		{
			var baseFolder = this.Script.contentFolder;
			var layout = ({
			target	: pageNumber + "_ActionPanel",
			raiseToTop: "y",
			windowStage :elementUniqueID + '_stage',
			content	 : {
							type:"panel",
							name:"titleBar",
							PrimaryContainer:true,
							ContentType:"URL",
							overflow:"hidden",
							data: ACTION_PROCESSOR + "?action=loadActionPanel&actionFile=" + encodeURIComponent( baseFolder + "/actionScript/" + thePage.loadActionScriptFile) + "&actionLocalConstant=" + encodeURIComponent('getTutorial("' + this.elementUniqueID + '").localTutorialConstants') + '&actionSharedResultSets=' + encodeURIComponent('getTutorial("' + this.elementUniqueID + '").localTutorialResultsSets')
						}
			});
			loadNewPageLayout(layout);
		}
		if(this.Script.useLongAcHoc)
		{
			RaiseToTop(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_RESULT_STAGE', 'ADHOC_TEXT_WINDOW');
		}
		this.setSQLOptions(pageNumber);
		if(thePage.autoLoadLink != "" && thePage.autoLoadLink != null)
			loadPage(encodeURIandNormaMessage(Object.toJSON(thePage.autoLoadLink.PageWindows), this.localTutorialConstants), encodeURIandNormaMessage(Object.toJSON(thePage.autoLoadLink.LinkList), this.localTutorialConstants));
		$(this.elementUniqueID + '_topTutorialTitle').update(thePage.name);
		if(thePage.contentFile != "" && thePage.contentFile != null)
		{
			new Ajax.Request(this.Script.contentFolder + '/HTML/' + thePage.contentFile, {
					'onSuccess': function(transport) {
						if($(elementUniqueID + '_Body') != null)
						{
							$(elementUniqueID + '_Body').update(encodeMessage(transport.responseText, localTutorialConstants));
						}
					},
					'onFailure': function(transport) {
						if($(elementUniqueID + '_Body') != null)
						{
							$(elementUniqueID + '_Body').update(encodeMessage(transport.responseText, localTutorialConstants));
						}
					}
			});
		}
		else if(thePage.contentUrl != "")
		{
			$(this.elementUniqueID + '_Body').update('<iframe src="' + encodeMessage(thePage.contentUrl, localTutorialConstants) + '" height="100%" width="100%" frameborder="0" scrolling="auto"></iframe>');
		}
		else
		{
			$(this.elementUniqueID + '_Body').update(unescape(encodeURIandNormaMessage(thePage.contentText)));
		}
		this.displayPageNumber();
		return true;
	},
	updateSQLText: function(SQLText, pageNumber)
	{
		if(this.SetAdHocTextLoop != null)
		{
			clearTimeout(this.SetAdHocTextLoop);
			this.SetAdHocTextLoop = null;
		}
		var SQLHighlightOptions = this.getPageObject(pageNumber).codeHighlightOptions;
		if($(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_TEXT_FRAME') != null)
		{
			SQLText = unescape(SQLText);
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_HTML_FRAME').hide();
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_TEXT_FRAME').show();
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_TEXT_FRAME').value = SQLText;
			changeBorderNotification(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_Execute');
			var Highlight = false;
			if(this.Script.globalCodeHighlightOptions != null)
			{
				if(this.Script.globalCodeHighlightOptions.highlightCode != null)
					Highlight = this.Script.globalCodeHighlightOptions.highlightCode
			}
			if(SQLHighlightOptions != null)
			{
				if(SQLHighlightOptions.highlightCode != null)
					Highlight = SQLHighlightOptions.highlightCode == true ? true : false;
			}
			var highlightedCode = "";
			if(Highlight)
			{
				if(SQLHighlightOptions == null && this.Script.globalCodeHighlightOptions == null)
				{
					highlightedCode = codeHighlight("DB2_SQL", SQLText, null, null, null, null);
				}
				else if(this.Script.globalCodeHighlightOptions == null && SQLHighlightOptions != null)
				{
					highlightedCode = codeHighlight("DB2_SQL", SQLText, SQLHighlightOptions.addedHighlightTokens, SQLHighlightOptions.changedHighlightTokens, SQLHighlightOptions.removedHighlightTokens, SQLHighlightOptions.copiedHighlightTokens);
				}
				else if(this.Script.globalCodeHighlightOptions != null && SQLHighlightOptions == null)
				{
					highlightedCode = codeHighlight("DB2_SQL", SQLText, this.Script.globalCodeHighlightOptions.addedHighlightTokens, this.Script.globalCodeHighlightOptions.changedHighlightTokens, this.Script.globalCodeHighlightOptions.removedHighlightTokens, this.Script.globalCodeHighlightOptions.copiedHighlightTokens);
				}
				else if(this.Script.globalCodeHighlightOptions != null && SQLHighlightOptions != null)
				{
					highlightedCode = codeHighlight("DB2_SQL", SQLText, this.Script.globalCodeHighlightOptions.addedHighlightTokens.concat(SQLHighlightOptions.addedHighlightTokens), this.Script.globalCodeHighlightOptions.changedHighlightTokens.concat(SQLHighlightOptions.changedHighlightTokens), this.Script.globalCodeHighlightOptions.removedHighlightTokens.concat(SQLHighlightOptions.removedHighlightTokens), this.Script.globalCodeHighlightOptions.copiedHighlightTokens.concat(SQLHighlightOptions.copiedHighlightTokens));
				}
				if($(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_HTML_FRAME') != null && highlightedCode != null)
				{
					$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_TEXT_FRAME').hide();
					$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_HTML_FRAME').show();
					$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_SQL_HTML_FRAME').update("<pre><code>" + highlightedCode + "</code></pre>");
					$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_EditQuery').show();
					changeBorderNotification(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_Execute');
				}
			}
			RaiseToTop(this.elementUniqueID + '_stage', "TutorialSQL");
			if(this.Script.useLongAcHoc)
			{
				RaiseToTop(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_RESULT_STAGE', this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_ADHOC_TEXT_WINDOW');
			}
		}
		else
		{
			this.SetAdHocTextLoop = setTimeout('getTutorial("' + this.elementUniqueID + '").updateSQLText("' + SQLText + '",' + pageNumber + ");", 500);
		}
	},
	setSQLOptions: function(pageNumber) {
		if(this.SetAdHocOptionsLoop != null)
		{
			clearTimeout(this.SetAdHocOptionsLoop);
			this.SetAdHocOptionsLoop = null;
		}
		try
		{
			var SQLOptions = this.getPageObject(pageNumber).SQLOptions;
			if($(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_adhocForm') == null)
			{
				this.SetAdHocOptionsLoop = setTimeout("getTutorial('" + this.elementUniqueID + "').setSQLOptions(" + pageNumber + ");", 500);
				return;
			}
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionXML').checked = SQLOptions.displayXML;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionXMLinline').checked = SQLOptions.displayXMLinline;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionCLOB').checked = SQLOptions.displayCLOB;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionCLOBinline').checked = SQLOptions.displayCLOBinline;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionBLOB').checked = SQLOptions.displayBLOB;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionBDCLOB').checked = SQLOptions.displayDBClob;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionCommit').checked = SQLOptions.commitPerStmt;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionTermChar').value = SQLOptions.termChar;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionRows').value = SQLOptions.numRowReturn;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionMaxRunTime').value = SQLOptions.shellMaxRunTime;
			$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionShellTermChar').value = SQLOptions.shellTermChar;
			if(!this.Script.disableSetSchema)
				$(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel_OptionDefaultSchema').value = this.localTutorialConstants.get("SCHEMA");
			var adhocPanel = AdHocSQLWindows.get(this.elementUniqueID + '_stage_TutorialSQL_SQLBasePanel');
			if(adhocPanel != null)
			{
				adhocPanel.changeScriptMode(SQLOptions.scriptMode);
				adhocPanel.resultSetStorageHolder = this.localTutorialResultsSets;
				adhocPanel.resultSetStorageName= SQLOptions.shellTermChar;
			}
		}
		catch(e)
		{
		}
	},
	displayPageNumber: function() {
		var pageNum = (parseInt(this.currentPageNumber) + 1);
		$(this.elementUniqueID + "_Current_Page").show();
		$(this.elementUniqueID + "_Current_Page").update("&nbsp;&nbsp;" + pageNum + "&nbsp;of&nbsp;" + this.Script.pageList.totalPages + "&nbsp;&nbsp;<img class='inlineimage' src='images/icon-down-on.gif'/>");
		$(this.elementUniqueID + "_PerviousPage").show();
		$(this.elementUniqueID + "_NextPage").show();
		if(this.currentPageNumber == 0)
		{
			$(this.elementUniqueID + "_PerviousPage").src = "./images/windownav/BWArrow_inActive.gif";
			$(this.elementUniqueID + "_NextPage").src = "./images/windownav/FWArrow_active.gif";
		}
		else if(this.currentPageNumber == (this.Script.pageList.numIntroPages + this.Script.pageList.numGeneralPages + this.Script.pageList.numLastPages - 1))
		{
			$(this.elementUniqueID + "_PerviousPage").src = "./images/windownav/BWArrow_active.gif";
			$(this.elementUniqueID + "_NextPage").src = "./images/windownav/FWArrow_inActive.gif";
		}
		else
		{
			$(this.elementUniqueID + "_PerviousPage").src = "./images/windownav/BWArrow_active.gif";
			$(this.elementUniqueID + "_NextPage").src = "./images/windownav/FWArrow_active.gif";
		}
	},
	insertAllPages: function() {
		var PageNumber = 0;
		var thisTutorial = this;
		var inserterFirstArrow = false;
		var NodeArray = [];
		var elementUniqueID = this.elementUniqueID;
		var currentPageNumber = this.currentPageNumber;
		var navigablePages = new Array();
		for(i=0; i < this.Script.pageList.totalPages; i++)
		{
			navigablePages[i] = false;
		}
		switch(this.pageFlow)
		{
			case TUTORIAL_FREE_WITH_CHECKS:
			case TUTORIAL_FLOW_FREE:
				for(i=0; i < this.Script.pageList.totalPages; i++)
				{
					navigablePages[i] = true;
				}
				break;
			case TUTORIAL_FLOW_FORWARD_SEQUENTIAL:
				for(i=0; i <= this.forwardMostVistedPage+1; i++)
				{
					navigablePages[i] = true;
				}
				break;
			case TUTORIAL_FLOW_STRICT_SEQUENTIAL:
				for(i=this.currentPageNumber-1; i <= this.currentPageNumber+1; i++)
				{
					navigablePages[i] = true;
				}
				break;
			case TUTORIAL_FLOW_FORWARD_EXPLORATION:
				for(i=0; i <= this.forwardMostVistedPage+1; i++)
				{
					navigablePages[i] = true;
				}
				break;
		}
		var makeLink = function(Page) {
			if(PageNumber == currentPageNumber)
			{
				$(elementUniqueID + '_PageList').insert('<li style="text-align:left;padding-left:10px;padding-right:10px;"><NOBR><b>'+ (PageNumber + 1) + ": " + Page.name.replace(" ", "&nbsp;") + "</b></NOBR></li>");
			}
			else if(navigablePages[PageNumber] == true)
			{
				$(elementUniqueID + '_PageList').insert('<li style="text-align:left;padding-left:10px;padding-right:10px;"><NOBR><a onClick="getTutorial(\'' + elementUniqueID + '\').goToPage(' + PageNumber + ');">'+ (PageNumber + 1) + ": " + Page.name.replace(" ", "&nbsp;") + "</a></NOBR></li>");
			}
			else
			{
				$(elementUniqueID + '_PageList').insert('<li style="text-align:left;padding-left:10px;padding-right:10px;"><NOBR>'+ (PageNumber + 1) + ": " + Page.name.replace(" ", "&nbsp;") + "</NOBR></li>");
			}
			PageNumber++;
		};
		$(elementUniqueID + '_PageList').update("");
		this.Script.pageList.introPages.each(makeLink);
		this.Script.pageList.generalPages.each(makeLink);
		this.Script.pageList.lastPages.each(makeLink);
	},
	sizeWidth: function(Amount) {
		this.setWidth(0);
	},
	sizeHeight: function(Amount) {
		this.setHeight(0);
	},
	setWidth: function(Amount) {
		var thewidth = 0;
		if ($(this.parentStageID + "_" + this.parentWindowID + "_TUTORIAL_TEXT_PANEL") != null)
			thewidth = $(this.parentStageID + "_" + this.parentWindowID + "_TUTORIAL_TEXT_PANEL").getWidth();
		if ($(this.elementUniqueID + "_Body") != null && $(this.elementUniqueID + "_Body_container") != null) {
			$(this.elementUniqueID + "_Body").setStyle({ "width": (thewidth - 20) + "px" });
		}
	},
	setHeight: function(Amount) {
		var theheight = 0;
		if ($(this.parentStageID + "_" + this.parentWindowID + "_TUTORIAL_TEXT_PANEL") != null)
			theheight = $(this.parentStageID + "_" + this.parentWindowID + "_TUTORIAL_TEXT_PANEL").getHeight();
		if ($(this.elementUniqueID + "_Body") != null)
			$(this.elementUniqueID + "_Body").setStyle({ "height": (theheight-10) + "px" });
	}
}));
