SELECT 
    NUM_EXECUTIONS, 
	coalesce(TOTAL_EXEC_TIME / nullif(NUM_EXECUTIONS,0),0) AS AVERAGE_EXECUTION_TIME,  
    coalesce(STMT_SORTS / nullif(NUM_EXECUTIONS,0),0) AS SORTS_PER_EXECUTION, 
	TOTAL_EXEC_TIME,
	TOTAL_SYS_CPU_TIME + TOTAL_USR_CPU_TIME as TOTAL_CPU_TIME,
	TOTAL_SYS_CPU_TIME,
	TOTAL_USR_CPU_TIME,
    DBPARTITIONNUM, 
	STMT_TEXT,
    SNAPSHOT_TIMESTAMP, 
    NUM_COMPILATIONS,
	PREP_TIME_WORST,
	PREP_TIME_BEST,
	INT_ROWS_DELETED,
	INT_ROWS_INSERTED,
	INT_ROWS_UPDATED,
	ROWS_READ,
	ROWS_WRITTEN,
	STMT_SORTS,
	SORT_OVERFLOWS,
	TOTAL_SORT_TIME,
	POOL_DATA_L_READS,
	POOL_DATA_P_READS,
	POOL_TEMP_DATA_L_READS,
	POOL_TEMP_DATA_P_READS,
	POOL_INDEX_L_READS,
	POOL_INDEX_P_READS,
	POOL_TEMP_INDEX_L_READS,
	POOL_TEMP_INDEX_P_READS,
	POOL_XDA_L_READS,
	POOL_XDA_P_READS,
	POOL_TEMP_XDA_L_READS,
	POOL_TEMP_XDA_P_READS 
FROM (
	SELECT 
    	NUM_EXECUTIONS, 
		decimal(TOTAL_EXEC_TIME,31,6) + decimal(TOTAL_EXEC_TIME_MS,31,6)/1000000 as TOTAL_EXEC_TIME,
		decimal(TOTAL_USR_CPU_TIME,31,6) + decimal(TOTAL_USR_CPU_TIME_MS,31,6)/1000000 as TOTAL_USR_CPU_TIME,
		decimal(TOTAL_SYS_CPU_TIME,31,6) + decimal(TOTAL_SYS_CPU_TIME_MS,31,6)/1000000 as TOTAL_SYS_CPU_TIME,
    	DBPARTITIONNUM, 
		STMT_TEXT,
    	SNAPSHOT_TIMESTAMP,
    	NUM_COMPILATIONS,
		PREP_TIME_WORST,
		PREP_TIME_BEST,
		INT_ROWS_DELETED,
		INT_ROWS_INSERTED,
		INT_ROWS_UPDATED,
		ROWS_READ,
		ROWS_WRITTEN,
		STMT_SORTS,
		SORT_OVERFLOWS,
		TOTAL_SORT_TIME,
		POOL_DATA_L_READS,
		POOL_DATA_P_READS,
		POOL_TEMP_DATA_L_READS,
		POOL_TEMP_DATA_P_READS,
		POOL_INDEX_L_READS,
		POOL_INDEX_P_READS,
		POOL_TEMP_INDEX_L_READS,
		POOL_TEMP_INDEX_P_READS,
		POOL_XDA_L_READS,
		POOL_XDA_P_READS,
		POOL_TEMP_XDA_L_READS,
		POOL_TEMP_XDA_P_READS 
	FROM  SYSIBMADM.SNAPDYN_SQL
	) t
	