
    SELECT 
        tbsp.snapshot_timestamp, 
        tbsp.tbsp_name, 
        tbsp.direct_reads, 
        tbsp.direct_read_reqs, 
        tbsp.pool_data_l_reads, 
        tbsp.pool_index_l_reads, 
        tbsp.pool_temp_data_l_reads, 
        tbsp.pool_temp_index_l_reads, 
        tbsp.pool_data_p_reads, 
        pool_index_p_reads, 
        tbsp.pool_temp_data_p_reads, 
        tbsp.pool_temp_index_p_reads, 
        tbsp.pool_async_data_reads, 
        tbsp.pool_async_index_reads, 
        tbsp.pool_async_data_read_reqs, 
        tbsp.pool_async_index_read_reqs, 
        tbsp.direct_writes, 
        tbsp.direct_write_time, 
        tbsp.pool_data_writes, 
        tbsp.pool_index_writes, 
        tbsp.pool_async_data_writes, 
        tbsp.pool_async_index_writes, 
        tbsp.tbsp_content_type, 
        tbsp.tbsp_page_size, 
        part.tbsp_used_pages, 
        part.tbsp_total_pages, 
        tbsp.tbsp_extent_size, 
        part.tbsp_page_top, 
        part.tbsp_max_size, 
        DECIMAL((part.tbsp_current_size / 1024.0 /1024.0),10,2) as current_size_mb,
        part.tbsp_state, 
        tbsp.tbsp_type, 
        tbsp.fs_caching, 
        tbsp.tbsp_auto_resize_enabled, 
        part.tbsp_last_resize_failed, 
        part.tbsp_last_resize_time, 
        tbsp.files_closed, 
        tbsp.pool_no_victim_buffer,
        tbsp.unread_prefetch_pages
      FROM 
        table(SNAP_GET_TBSP_V91('', -2)) AS TBSP, 
        table(SNAP_GET_TBSP_PART_V91('', -2)) AS PART 
      WHERE 
        tbsp.tbsp_id = part.tbsp_id