CREATE OR REPLACE PROCEDURE benchmark_plsql AS
  v_customer_id customer.customer_id%TYPE;
  customer_exists BOOLEAN;
  category_id category.category_id%TYPE;
  product_id product.product_id%TYPE:=1;
  v_order_id orders.order_id%TYPE;
  i INTEGER :=1;

BEGIN
   WHILE i<25 LOOP
      customer_package.create_customer('First' || i , 'last' || i , 'email' || i||'@test.com', '111-222-333', '1960-02-02' , v_customer_id , customer_exists);
      i:=i+1;
   END LOOP;
   i:=1;
   WHILE i<50 LOOP
	    product_package.create_product('Product ' || i , 'Main' , CAST(CAST(sysfun.rand() * 10000 as integer) / 100 as decimal(8 , 2)) , CAST(sysfun.rand() * 100000 as integer) , product_id);
	    i:=i+1;
   END LOOP;
   i:=1; 
   WHILE i<100 LOOP
     i:=i+1;
     DELETE from shopping_cart;
     FOR i IN (select product_id, CAST(sysfun.rand()*50 as integer) as quantity FROM product WHERE ROWNUM<CAST(sysfun.rand()*10 as integer)+1) LOOP
         order_package.add_item_to_shopping_cart(i.product_id, i.quantity);
     END LOOP;
     SELECT customer_id INTO v_customer_id FROM customer ORDER BY sysfun.rand() FETCH FIRST 1 ROW ONLY;
     FOR i IN (select product_id, CAST(sysfun.rand()*50 as integer)+1 as quantity FROM product WHERE ROWNUM<CAST(sysfun.rand()*10 as integer)) LOOP
          order_package.add_item_to_shopping_cart(i.product_id, i.quantity);
     END LOOP;
     order_package.create_order(v_customer_id, v_order_id);
  END LOOP;
  DELETE FROM order_details;
  DELETE FROM orders;
  DELETE FROM product;
  DELETE FROM customer;
END; 
@

CREATE OR REPLACE PROCEDURE benchmark_sqlpl SPECIFIC benchmark_sqlpl
LANGUAGE SQL
  SYSIBMINTERNAL_BLOCK: BEGIN
--#line 002
    DECLARE v_customer_id   ANCHOR TO customer.customer_id;
    DECLARE customer_exists BOOLEAN;
    DECLARE category_id     ANCHOR TO category.category_id;
    DECLARE product_id      ANCHOR TO product.product_id DEFAULT 1;
    DECLARE v_order_id      ANCHOR TO orders.order_id;
    DECLARE i               INTEGER DEFAULT 1;

--#line 010
    WHILE i < 25 DO
      CALL customer_package_db2.create_customer('First' || i, 'last' || i, 'email' || i || '@test.com', '111-222-333', '1960-02-02', v_customer_id, customer_exists);
      SET i = i + 1;
    END WHILE;

--#line 014
    SET i = 1;

--#line 015
    WHILE i < 50 DO
      CALL product_package_db2.create_product('Product ' || i, 'Main', CAST(CAST(sysfun.rand() * 10000 as integer) / 100 as decimal(8, 2)), CAST(sysfun.rand() * 100000 as integer), product_id);
      SET i = i + 1;
    END WHILE;

--#line 019
    SET i = 1;

--#line 020
    WHILE i < 100 DO
      SET i = i + 1;
      DELETE from shopping_cart;

--#line 023
      FOR i AS
        select product_id, CAST(sysfun.rand() * 50 as integer) as quantity FROM product WHERE ROWNUM < CAST(sysfun.rand() * 10 as integer) + 1
      DO
--#line 024
        CALL order_package_db2.add_item_to_shopping_cart(i.product_id, i.quantity);
      END FOR;

--#line 026
      SELECT customer_id INTO v_customer_id FROM customer ORDER BY sysfun.rand() FETCH FIRST 1 ROW ONLY;

--#line 027
      FOR i AS
        select product_id, CAST(sysfun.rand() * 50 as integer) + 1 as quantity FROM product WHERE ROWNUM < CAST(sysfun.rand() * 10 as integer)
      DO
--#line 028
        CALL order_package_db2.add_item_to_shopping_cart(i.product_id, i.quantity);
      END FOR;

--#line 030
      CALL order_package_db2.create_order(v_customer_id, v_order_id);
    END WHILE;
    DELETE FROM order_details;
    DELETE FROM orders;
    DELETE FROM product;
    DELETE FROM customer;

  END@