create view ?SCHEMA?.DoctorPatient as
(
select
   d.doc_id, 
   XML2CLOB
   (
      XMLELEMENT(NAME "DoctorPatient",
         XMLATTRIBUTES(d.doc_id as "DOCID"),
         XMLAGG
         (
            XMLELEMENT(NAME "Patient",
            XMLELEMENT(NAME "ID",   p.pat_id),
            XMLELEMENT(NAME "Name", p.pat_firstname || ' ' || p.pat_lastname),
            XMLELEMENT(NAME "Room",        p.pat_room))
            ORDER BY p.pat_id
         )
      )
   ) AS DOCPATIENT
   from
      ?SCHEMA?.patients p,
      ?SCHEMA?.doctors  d
   where
      d.doc_id = p.doc_id
   group by 
      d.doc_id
);

select * from ?SCHEMA?.doctorpatient;