-- Create table SUBSCRIBER_MSISDN_HISTORY_IND for indexing and populate the table with data

CREATE TABLE ?SCHEMA?.SUBSCRIBER_MSISDN_HISTORY_IND  (
                  SUBSCRIBER_MSISDN 	        BIGINT ,
                  MSISDN_START_DT 		DATE NOT NULL ,
                  CIRCLE_ID 			SMALLINT ,
                  SUBSCRIBER_KEY 		VARCHAR(21) ,
                  MSISDN_END_DT 		DATE ,
                  MSISDN_EFF_TIME 		TIME ,
                  MSISDN_END_TIME 		TIME )
                  DISTRIBUTE BY HASH(SUBSCRIBER_MSISDN)
                  IN FACTSPACE INDEX IN INDSPACE1 NOT LOGGED INITIALLY ;

INSERT INTO ?SCHEMA?.SUBSCRIBER_MSISDN_HISTORY_IND (SELECT * FROM TE_TEMP.SUBSCRIBER_MSISDN_HISTORY) ;

-- Create a regular index

CREATE INDEX ?SCHEMA?.INDEX_MSISDN_HISTORY 
  ON ?SCHEMA?.SUBSCRIBER_MSISDN_HISTORY_IND
  (SUBSCRIBER_MSISDN) 
  ALLOW REVERSE SCANS ;

CALL ADMIN_CMD('RUNSTATS ON TABLE ?SCHEMA?.SUBSCRIBER_MSISDN_HISTORY_IND FOR INDEX ?SCHEMA?.INDEX_MSISDN_HISTORY') ;


-- Create table DEDICATED_ACCOUNT_IND for indexing and populate the table with data

CREATE TABLE ?SCHEMA?.DEDICATED_ACCOUNT_IND ( 
                  DED_ACC_KEY 			SMALLINT ,
                  DED_ACC_EFF_DT 		DATE , 
                  DED_ACC_END_DT 		DATE , 
                  DED_ACC_CONVERSION_FACTOR 	DECIMAL(10,2) , 
                  CIRCLE_ID 			SMALLINT) 
                  IN DIMSPACE INDEX IN INDSPACE2 NOT LOGGED INITIALLY ;


INSERT INTO ?SCHEMA?.DEDICATED_ACCOUNT_IND (SELECT * FROM TE_TEMP.DEDICATED_ACCOUNT_TEMP) ;

-- Create a regular index

CREATE INDEX ?SCHEMA?.INDEX_DEDICATED_ACCOUNT
  ON ?SCHEMA?.DEDICATED_ACCOUNT_IND
  (CIRCLE_ID, DED_ACC_KEY) 
  ALLOW REVERSE SCANS ;

CALL ADMIN_CMD('RUNSTATS ON TABLE ?SCHEMA?.DEDICATED_ACCOUNT_IND FOR INDEX ?SCHEMA?.INDEX_DEDICATED_ACCOUNT') ;

