-- Grant privileges to users.
GRANT SELECT, INSERT, UPDATE, DELETE ON ?SCHEMA?.dailysales TO USER bob;
GRANT SELECT, INSERT, UPDATE, DELETE ON ?SCHEMA?.dailysales TO USER joe;
GRANT SELECT, INSERT, UPDATE, DELETE ON ?SCHEMA?.dailysales TO USER sue;
GRANT SELECT, INSERT, UPDATE, DELETE ON ?SCHEMA?.dailysales TO USER mark;

-- Grant security labels to users.
GRANT SECURITY LABEL Sec_Policy.EAST TO USER sam FOR ALL ACCESS;
GRANT SECURITY LABEL Sec_Policy.WEST TO USER nick FOR ALL ACCESS;
GRANT SECURITY LABEL Sec_Policy.NORTH TO USER betcy FOR ALL ACCESS;
GRANT SECURITY LABEL Sec_Policy.SOUTH TO USER bob FOR ALL ACCESS;
GRANT SECURITY LABEL Sec_Policy.CENTRAL TO USER joe FOR READ ACCESS;
GRANT SECURITY LABEL Sec_Policy.COASTAL TO USER sue FOR READ ACCESS;
GRANT SECURITY LABEL Sec_Policy.SALES_ORGANIZATION TO USER mark FOR READ ACCESS;

-- Alter table 'dailysales' to add security policy and security labels.
ALTER TABLE ?SCHEMA?.dailysales ADD SECURITY POLICY Sec_Policy;
ALTER TABLE ?SCHEMA?.dailysales ADD COLUMN secLabel_region DB2SECURITYLABEL;

UPDATE ?SCHEMA?.dailysales 
  SET secLabel_region = SECLABEL_BY_NAME('SEC_POLICY','EAST') 
  WHERE ID = 101;

UPDATE ?SCHEMA?.dailysales 
  SET secLabel_region = SECLABEL_BY_NAME('SEC_POLICY','WEST') 
  WHERE ID = 102;

UPDATE ?SCHEMA?.dailysales 
  SET secLabel_region = SECLABEL_BY_NAME('SEC_POLICY','NORTH') 
  WHERE ID = 103;

UPDATE ?SCHEMA?.dailysales 
  SET secLabel_region = SECLABEL_BY_NAME('SEC_POLICY','SOUTH') 
  WHERE ID = 104;

